/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/security/manager/ssl/nsICertOverrideService.idl
 */

#ifndef __gen_nsICertOverrideService_h__
#define __gen_nsICertOverrideService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIArray; /* forward declaration */

class nsIX509Cert; /* forward declaration */

#define NS_CERTOVERRIDE_CONTRACTID "@mozilla.org/security/certoverride;1"

/* starting interface:    nsICertOverrideService */
#define NS_ICERTOVERRIDESERVICE_IID_STR "be019e47-22fc-4355-9f16-9ab047d6742d"

#define NS_ICERTOVERRIDESERVICE_IID \
  {0xbe019e47, 0x22fc, 0x4355, \
    { 0x9f, 0x16, 0x9a, 0xb0, 0x47, 0xd6, 0x74, 0x2d }}

class NS_NO_VTABLE nsICertOverrideService : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ICERTOVERRIDESERVICE_IID)

  enum {
    ERROR_UNTRUSTED = 1,
    ERROR_MISMATCH = 2,
    ERROR_TIME = 4
  };

  /* [must_use] void rememberValidityOverride (in AUTF8String aHostName, in int32_t aPort, in nsIX509Cert aCert, in uint32_t aOverrideBits, in boolean aTemporary); */
  MOZ_MUST_USE NS_IMETHOD RememberValidityOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t aOverrideBits, bool aTemporary) = 0;

  /* [must_use] void rememberTemporaryValidityOverrideUsingFingerprint (in AUTF8String aHostName, in int32_t aPort, in AUTF8String aCertFingerprint, in uint32_t aOverrideBits); */
  MOZ_MUST_USE NS_IMETHOD RememberTemporaryValidityOverrideUsingFingerprint(const nsACString& aHostName, int32_t aPort, const nsACString& aCertFingerprint, uint32_t aOverrideBits) = 0;

  /* [must_use] boolean hasMatchingOverride (in AUTF8String aHostName, in int32_t aPort, in nsIX509Cert aCert, out uint32_t aOverrideBits, out boolean aIsTemporary); */
  MOZ_MUST_USE NS_IMETHOD HasMatchingOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t *aOverrideBits, bool *aIsTemporary, bool *_retval) = 0;

  /* void clearValidityOverride (in AUTF8String aHostName, in int32_t aPort); */
  NS_IMETHOD ClearValidityOverride(const nsACString& aHostName, int32_t aPort) = 0;

  /* void clearAllOverrides (); */
  NS_IMETHOD ClearAllOverrides(void) = 0;

  /* [must_use] uint32_t isCertUsedForOverrides (in nsIX509Cert aCert, in boolean aCheckTemporaries, in boolean aCheckPermanents); */
  MOZ_MUST_USE NS_IMETHOD IsCertUsedForOverrides(nsIX509Cert *aCert, bool aCheckTemporaries, bool aCheckPermanents, uint32_t *_retval) = 0;

  /* void setDisableAllSecurityChecksAndLetAttackersInterceptMyData (in boolean aDisable); */
  NS_IMETHOD SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(bool aDisable) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsICertOverrideService, NS_ICERTOVERRIDESERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICERTOVERRIDESERVICE \
  MOZ_MUST_USE NS_IMETHOD RememberValidityOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t aOverrideBits, bool aTemporary) override; \
  MOZ_MUST_USE NS_IMETHOD RememberTemporaryValidityOverrideUsingFingerprint(const nsACString& aHostName, int32_t aPort, const nsACString& aCertFingerprint, uint32_t aOverrideBits) override; \
  MOZ_MUST_USE NS_IMETHOD HasMatchingOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t *aOverrideBits, bool *aIsTemporary, bool *_retval) override; \
  NS_IMETHOD ClearValidityOverride(const nsACString& aHostName, int32_t aPort) override; \
  NS_IMETHOD ClearAllOverrides(void) override; \
  MOZ_MUST_USE NS_IMETHOD IsCertUsedForOverrides(nsIX509Cert *aCert, bool aCheckTemporaries, bool aCheckPermanents, uint32_t *_retval) override; \
  NS_IMETHOD SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(bool aDisable) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSICERTOVERRIDESERVICE \
  MOZ_MUST_USE nsresult RememberValidityOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t aOverrideBits, bool aTemporary); \
  MOZ_MUST_USE nsresult RememberTemporaryValidityOverrideUsingFingerprint(const nsACString& aHostName, int32_t aPort, const nsACString& aCertFingerprint, uint32_t aOverrideBits); \
  MOZ_MUST_USE nsresult HasMatchingOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t *aOverrideBits, bool *aIsTemporary, bool *_retval); \
  nsresult ClearValidityOverride(const nsACString& aHostName, int32_t aPort); \
  nsresult ClearAllOverrides(void); \
  MOZ_MUST_USE nsresult IsCertUsedForOverrides(nsIX509Cert *aCert, bool aCheckTemporaries, bool aCheckPermanents, uint32_t *_retval); \
  nsresult SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(bool aDisable); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICERTOVERRIDESERVICE(_to) \
  MOZ_MUST_USE NS_IMETHOD RememberValidityOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t aOverrideBits, bool aTemporary) override { return _to RememberValidityOverride(aHostName, aPort, aCert, aOverrideBits, aTemporary); } \
  MOZ_MUST_USE NS_IMETHOD RememberTemporaryValidityOverrideUsingFingerprint(const nsACString& aHostName, int32_t aPort, const nsACString& aCertFingerprint, uint32_t aOverrideBits) override { return _to RememberTemporaryValidityOverrideUsingFingerprint(aHostName, aPort, aCertFingerprint, aOverrideBits); } \
  MOZ_MUST_USE NS_IMETHOD HasMatchingOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t *aOverrideBits, bool *aIsTemporary, bool *_retval) override { return _to HasMatchingOverride(aHostName, aPort, aCert, aOverrideBits, aIsTemporary, _retval); } \
  NS_IMETHOD ClearValidityOverride(const nsACString& aHostName, int32_t aPort) override { return _to ClearValidityOverride(aHostName, aPort); } \
  NS_IMETHOD ClearAllOverrides(void) override { return _to ClearAllOverrides(); } \
  MOZ_MUST_USE NS_IMETHOD IsCertUsedForOverrides(nsIX509Cert *aCert, bool aCheckTemporaries, bool aCheckPermanents, uint32_t *_retval) override { return _to IsCertUsedForOverrides(aCert, aCheckTemporaries, aCheckPermanents, _retval); } \
  NS_IMETHOD SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(bool aDisable) override { return _to SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(aDisable); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSICERTOVERRIDESERVICE(_to) \
  MOZ_MUST_USE NS_IMETHOD RememberValidityOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t aOverrideBits, bool aTemporary) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RememberValidityOverride(aHostName, aPort, aCert, aOverrideBits, aTemporary); } \
  MOZ_MUST_USE NS_IMETHOD RememberTemporaryValidityOverrideUsingFingerprint(const nsACString& aHostName, int32_t aPort, const nsACString& aCertFingerprint, uint32_t aOverrideBits) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RememberTemporaryValidityOverrideUsingFingerprint(aHostName, aPort, aCertFingerprint, aOverrideBits); } \
  MOZ_MUST_USE NS_IMETHOD HasMatchingOverride(const nsACString& aHostName, int32_t aPort, nsIX509Cert *aCert, uint32_t *aOverrideBits, bool *aIsTemporary, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->HasMatchingOverride(aHostName, aPort, aCert, aOverrideBits, aIsTemporary, _retval); } \
  NS_IMETHOD ClearValidityOverride(const nsACString& aHostName, int32_t aPort) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearValidityOverride(aHostName, aPort); } \
  NS_IMETHOD ClearAllOverrides(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearAllOverrides(); } \
  MOZ_MUST_USE NS_IMETHOD IsCertUsedForOverrides(nsIX509Cert *aCert, bool aCheckTemporaries, bool aCheckPermanents, uint32_t *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsCertUsedForOverrides(aCert, aCheckTemporaries, aCheckPermanents, _retval); } \
  NS_IMETHOD SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(bool aDisable) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDisableAllSecurityChecksAndLetAttackersInterceptMyData(aDisable); } 


#endif /* __gen_nsICertOverrideService_h__ */
