//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStorageParent.h"
#include "mozilla/dom/cache/CacheStorageParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheStorageParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PCacheStorageParent::PCacheStorageParent() :
    mozilla::ipc::IProtocol(PCacheStorageMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PCacheStorageParent);
}

PCacheStorageParent::~PCacheStorageParent()
{
    MOZ_COUNT_DTOR(PCacheStorageParent);
}

auto PCacheStorageParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheStorageParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    mManagedPCacheOpParent.ToArray(aArr);
}

auto PCacheStorageParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheStorageParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPCacheOpParent.Count();
    arr__.SetCapacity(total);

    for (auto it = mManagedPCacheOpParent.ConstIter(); !it.Done(); it.Next()) {
        arr__.AppendElement(it.Get()->GetKey()->GetLifecycleProxy());
    }

}

auto PCacheStorageParent::OpenPCacheOpEndpoint(PCacheOpParent* aActor) -> ManagedEndpoint<PCacheOpChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpParent actor");
        return ManagedEndpoint<PCacheOpChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPCacheOpParent.PutEntry(aActor);

    return ManagedEndpoint<PCacheOpChild>(mozilla::ipc::PrivateIPDLInterface(), aActor->Id());
}

auto PCacheStorageParent::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpParent> aEndpoint,
        PCacheOpParent* aActor) -> bool
{
    MOZ_RELEASE_ASSERT(aEndpoint.ActorId(), "Invalid Endpoint!");
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpParent actor");
        return false;
    }

    aActor->SetManagerAndRegister(this, *aEndpoint.ActorId());
    mManagedPCacheOpParent.PutEntry(aActor);

    return true;
}

auto PCacheStorageParent::Send__delete__(PCacheStorageParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PCacheStorage::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(1244441181);



    if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStorageParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStorage::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PCacheStorageMsgStart, actor);
    return sendok__;
}

auto PCacheStorageParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
{
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);
            auto& container = mManagedPCacheOpParent;

            // Use a temporary variable here so all the assertion expressions
            // in the MOZ_RELEASE_ASSERT call below are textually identical;
            // the linker can then merge the strings from the assertion macro(s).
            MOZ_RELEASE_ASSERT(container.Contains(actor),
                "actor not managed by this!");
            container.RemoveEntry(actor);

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PCacheStorageParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        static_cast<CacheStorageParent*>(this)->DeallocPCacheOpParent(static_cast<PCacheOpParent*>(aListener));
        return;
    default:
        FatalError("unreached");
        return;
    }
}

auto PCacheStorageParent::OnMessageReceived(const Message& msg__) -> PCacheStorageParent::Result
{
    switch (msg__.type()) {
    case PCacheStorage::Msg_PCacheOpConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStorageParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_PCacheOpConstructor", OTHER);

            PickleIterator iter__(msg__);
            ActorHandle handle__;
            CacheOpArgs aOpArgs;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(handle__)))))) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 1244441181)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aOpArgs)))))) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aOpArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 3793140876)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            PCacheOpParent* actor = (static_cast<CacheStorageParent*>(this))->AllocPCacheOpParent(aOpArgs);
            if (!actor) {
                NS_WARNING("Cannot bind null PCacheOpParent actor");
                return MsgValueError;
            }

            actor->SetManagerAndRegister(this, (handle__).mId);
            mManagedPCacheOpParent.PutEntry(actor);

            if ((!((static_cast<CacheStorageParent*>(this))->RecvPCacheOpConstructor(std::move(actor), std::move(aOpArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStorageParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg_Teardown", OTHER);

            if ((!((static_cast<CacheStorageParent*>(this))->RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PCacheStorageParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    return MsgNotKnown;
}

auto PCacheStorageParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStorageParent::ClearSubtree() -> void
{
    for (auto it = mManagedPCacheOpParent.Iter(); !it.Done(); it.Next()) {
        it.Get()->GetKey()->ClearSubtree();
    }
    for (auto it = mManagedPCacheOpParent.Iter(); !it.Done(); it.Next()) {
        // Recursively releasing mManagedPCacheOpParent kids.
        auto* proxy = it.Get()->GetKey()->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPCacheOpParent.Clear();

}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheStorageParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheStorageParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PCacheStorage", PCacheStorageMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::cache::PCacheStorageParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
