//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/dom/cache/CacheStreamControlParent.h"
#include "mozilla/ipc/IPCStreamUtils.h"
#include "nsID.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace dom {
namespace cache {


MOZ_IMPLICIT PCacheStreamControlParent::PCacheStreamControlParent() :
    mozilla::ipc::IProtocol(PCacheStreamControlMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PCacheStreamControlParent);
}

PCacheStreamControlParent::~PCacheStreamControlParent()
{
    MOZ_COUNT_DTOR(PCacheStreamControlParent);
}

auto PCacheStreamControlParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheStreamControlParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PCacheStreamControlParent::SendClose(const nsID& aStreamId) -> bool
{
    IPC::Message* msg__ = PCacheStreamControl::Msg_Close(Id());

    WriteIPDLParam(msg__, this, aStreamId);
    // Sentinel = 'aStreamId'
    (msg__)->WriteSentinel(2426339439);




    if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStreamControlParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStreamControl::Msg_Close", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PCacheStreamControlParent::SendCloseAll() -> bool
{
    IPC::Message* msg__ = PCacheStreamControl::Msg_CloseAll(Id());





    if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStreamControlParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStreamControl::Msg_CloseAll", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PCacheStreamControlParent::Send__delete__(PCacheStreamControlParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PCacheStreamControl::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(1244441181);



    if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStreamControlParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStreamControl::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PCacheStreamControlMsgStart, actor);
    return sendok__;
}

auto PCacheStreamControlParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PCacheStreamControlParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PCacheStreamControlParent::OnMessageReceived(const Message& msg__) -> PCacheStreamControlParent::Result
{
    switch (msg__.type()) {
    case PCacheStreamControl::Msg_OpenStream__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStreamControlParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStreamControl::Msg_OpenStream", OTHER);

            PickleIterator iter__(msg__);
            nsID aStreamId;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aStreamId)))))) {
                FatalError("Error deserializing 'nsID'");
                return MsgValueError;
            }
            // Sentinel = 'aStreamId'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2426339439)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsID'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            int32_t id__ = Id();

            int32_t seqno__ = (msg__).seqno();
            WeakPtr<PCacheStreamControlParent> self__ = this;
            OpenStreamResolver resolver = [this, self__, id__, seqno__](nsIInputStream* aParam) {
                if ((!(self__))) {
                    NS_WARNING("Not resolving response because actor is dead.");
                    return;
                }
                bool resolve__ = true;
                RefPtr<nsIInputStream> aStream;
                aStream = std::move(aParam);
                IPC::Message* reply__ = PCacheStreamControl::Reply_OpenStream(id__);
                WriteIPDLParam(reply__, self__, resolve__);
                // Sentinel = 'resolve__'
                (reply__)->WriteSentinel(1790859373);
                WriteIPDLParam(reply__, self__, aStream);
                // Sentinel = 'aStream'
                (reply__)->WriteSentinel(1154079001);
                (reply__)->set_seqno(seqno__);

                if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
                    mozilla::ipc::LogMessageForProtocol(
                        "PCacheStreamControlParent",
                        OtherPid(),
                        "Sending reply ",
                        reply__->type(),
                        mozilla::ipc::MessageDirection::eSending);
                }
                bool sendok__ = ChannelSend(reply__);
                if ((!(sendok__))) {
                    NS_WARNING("Error sending reply");
                }
            };
            if ((!((static_cast<CacheStreamControlParent*>(this))->RecvOpenStream(std::move(aStreamId), std::move(resolver))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStreamControl::Msg_NoteClosed__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStreamControlParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStreamControlParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStreamControl::Msg_NoteClosed", OTHER);

            PickleIterator iter__(msg__);
            nsID aStreamId;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aStreamId)))))) {
                FatalError("Error deserializing 'nsID'");
                return MsgValueError;
            }
            // Sentinel = 'aStreamId'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2426339439)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsID'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((static_cast<CacheStreamControlParent*>(this))->RecvNoteClosed(std::move(aStreamId))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCacheStreamControl::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PCacheStreamControlParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStreamControlParent::Result
{
    return MsgNotKnown;
}

auto PCacheStreamControlParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStreamControlParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStreamControlParent::ClearSubtree() -> void
{
}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheStreamControlParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheStreamControlParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PCacheStreamControl", PCacheStreamControlMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::cache::PCacheStreamControlParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
