//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/ipc/PInProcessParent.h"
#include "mozilla/ipc/InProcessParent.h"

#include "mozilla/dom/PWindowGlobalParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace ipc {


auto PInProcessParent::ProcessingError(
        Result aCode,
        const char* aReason) -> void
{
}

auto PInProcessParent::ShouldContinueFromReplyTimeout() -> bool
{
    return true;
}

auto PInProcessParent::EnteredCxxStack() -> void
{
}

auto PInProcessParent::ExitedCxxStack() -> void
{
}

auto PInProcessParent::EnteredCall() -> void
{
}

auto PInProcessParent::ExitedCall() -> void
{
}

MOZ_IMPLICIT PInProcessParent::PInProcessParent() :
    mozilla::ipc::IToplevelProtocol("PInProcessParent", PInProcessMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PInProcessParent);
}

PInProcessParent::~PInProcessParent()
{
    MOZ_COUNT_DTOR(PInProcessParent);
}

auto PInProcessParent::ManagedPWindowGlobalParent(nsTArray<PWindowGlobalParent*>& aArr) const -> void
{
    mManagedPWindowGlobalParent.ToArray(aArr);
}

auto PInProcessParent::ManagedPWindowGlobalParent() const -> const ManagedContainer<PWindowGlobalParent>&
{
    return mManagedPWindowGlobalParent;
}

auto PInProcessParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPWindowGlobalParent.Count();
    arr__.SetCapacity(total);

    for (auto it = mManagedPWindowGlobalParent.ConstIter(); !it.Done(); it.Next()) {
        arr__.AppendElement(it.Get()->GetKey()->GetLifecycleProxy());
    }

}

auto PInProcessParent::OpenPWindowGlobalEndpoint(PWindowGlobalParent* aActor) -> ManagedEndpoint<PWindowGlobalChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PWindowGlobalParent actor");
        return ManagedEndpoint<PWindowGlobalChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPWindowGlobalParent.PutEntry(aActor);

    return ManagedEndpoint<PWindowGlobalChild>(mozilla::ipc::PrivateIPDLInterface(), aActor->Id());
}

auto PInProcessParent::BindPWindowGlobalEndpoint(
        ManagedEndpoint<PWindowGlobalParent> aEndpoint,
        PWindowGlobalParent* aActor) -> bool
{
    MOZ_RELEASE_ASSERT(aEndpoint.ActorId(), "Invalid Endpoint!");
    if (!aActor) {
        NS_WARNING("Cannot bind null PWindowGlobalParent actor");
        return false;
    }

    aActor->SetManagerAndRegister(this, *aEndpoint.ActorId());
    mManagedPWindowGlobalParent.PutEntry(aActor);

    return true;
}

auto PInProcessParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PWindowGlobalMsgStart:
{
            PWindowGlobalParent* actor = static_cast<PWindowGlobalParent*>(aListener);
            auto& container = mManagedPWindowGlobalParent;

            // Use a temporary variable here so all the assertion expressions
            // in the MOZ_RELEASE_ASSERT call below are textually identical;
            // the linker can then merge the strings from the assertion macro(s).
            MOZ_RELEASE_ASSERT(container.Contains(actor),
                "actor not managed by this!");
            container.RemoveEntry(actor);

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PInProcessParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    default:
        FatalError("unreached");
        return;
    }
}

auto PInProcessParent::OnMessageReceived(const Message& msg__) -> PInProcessParent::Result
{
    int32_t route__ = msg__.routing_id();
    if (MSG_ROUTING_CONTROL != route__) {
        IProtocol* routed__ = Lookup(route__);
        if (!routed__ || !routed__->GetLifecycleProxy()) {
            if (mozilla::ipc::LoggingEnabledFor("PInProcessParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PInProcessParent",
                    OtherPid(),
                    "Ignored message for dead actor",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }

            return MsgProcessed;
        }

        RefPtr<mozilla::ipc::ActorLifecycleProxy> proxy__ =
            routed__->GetLifecycleProxy();
        return proxy__->Get()->OnMessageReceived(msg__);
    }

    switch (msg__.type()) {
    default:
        return MsgNotKnown;
    case SHMEM_CREATED_MESSAGE_TYPE:
        {
            FatalError("this protocol tree does not use shmem");
            return MsgNotKnown;
        }
    case SHMEM_DESTROYED_MESSAGE_TYPE:
        {
            FatalError("this protocol tree does not use shmem");
            return MsgNotKnown;
        }
    }
}

auto PInProcessParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PInProcessParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PInProcessParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PInProcessParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PInProcessParent::OnChannelClose() -> void
{
    DestroySubtree(NormalShutdown);
    ClearSubtree();
    DeallocShmems();
    if (GetLifecycleProxy()) {
        GetLifecycleProxy()->Release();
    }
}

auto PInProcessParent::OnChannelError() -> void
{
    DestroySubtree(AbnormalShutdown);
    ClearSubtree();
    DeallocShmems();
    if (GetLifecycleProxy()) {
        GetLifecycleProxy()->Release();
    }
}

auto PInProcessParent::ClearSubtree() -> void
{
    for (auto it = mManagedPWindowGlobalParent.Iter(); !it.Done(); it.Next()) {
        it.Get()->GetKey()->ClearSubtree();
    }
    for (auto it = mManagedPWindowGlobalParent.Iter(); !it.Done(); it.Next()) {
        // Recursively releasing mManagedPWindowGlobalParent kids.
        auto* proxy = it.Get()->GetKey()->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPWindowGlobalParent.Clear();

}



} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::ipc::PInProcessParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::ipc::PInProcessParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PInProcess", PInProcessMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::ipc::PInProcessParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
