//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/media/PMediaParent.h"

#include "mozilla/dom/PContentParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace media {


MOZ_IMPLICIT PMediaParent::PMediaParent() :
    mozilla::ipc::IProtocol(PMediaMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PMediaParent);
}

PMediaParent::~PMediaParent()
{
    MOZ_COUNT_DTOR(PMediaParent);
}

auto PMediaParent::Manager() const -> PContentParent*
{
    return static_cast<PContentParent*>(IProtocol::Manager());
}

auto PMediaParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PMediaParent::Send__delete__(PMediaParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PMedia::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(1244441181);



    if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PMediaParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PMedia::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PMediaMsgStart, actor);
    return sendok__;
}

auto PMediaParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PMediaParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PMediaParent::OnMessageReceived(const Message& msg__) -> PMediaParent::Result
{
    switch (msg__.type()) {
    case PMedia::Msg_GetPrincipalKey__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PMediaParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMedia::Msg_GetPrincipalKey", OTHER);

            PickleIterator iter__(msg__);
            PrincipalInfo aPrincipal;
            bool aPersist;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aPrincipal)))))) {
                FatalError("Error deserializing 'PrincipalInfo'");
                return MsgValueError;
            }
            // Sentinel = 'aPrincipal'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 2210605987)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PrincipalInfo'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aPersist)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aPersist'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 1936387774)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            int32_t id__ = Id();

            int32_t seqno__ = (msg__).seqno();
            WeakPtr<PMediaParent> self__ = this;
            GetPrincipalKeyResolver resolver = [this, self__, id__, seqno__](const nsCString& aParam) {
                if ((!(self__))) {
                    NS_WARNING("Not resolving response because actor is dead.");
                    return;
                }
                bool resolve__ = true;
                nsCString aKey;
                aKey = std::move(aParam);
                IPC::Message* reply__ = PMedia::Reply_GetPrincipalKey(id__);
                WriteIPDLParam(reply__, self__, resolve__);
                // Sentinel = 'resolve__'
                (reply__)->WriteSentinel(1790859373);
                WriteIPDLParam(reply__, self__, aKey);
                // Sentinel = 'aKey'
                (reply__)->WriteSentinel(3235456110);
                (reply__)->set_seqno(seqno__);

                if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                    mozilla::ipc::LogMessageForProtocol(
                        "PMediaParent",
                        OtherPid(),
                        "Sending reply ",
                        reply__->type(),
                        mozilla::ipc::MessageDirection::eSending);
                }
                bool sendok__ = ChannelSend(reply__);
                if ((!(sendok__))) {
                    NS_WARNING("Error sending reply");
                }
            };
            if ((!((this)->RecvGetPrincipalKey(std::move(aPrincipal), std::move(aPersist), std::move(resolver))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Msg_SanitizeOriginKeys__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PMediaParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PMediaParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PMedia::Msg_SanitizeOriginKeys", OTHER);

            PickleIterator iter__(msg__);
            uint64_t aSinceWhen;
            bool aOnlyPrivateBrowsing;

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aSinceWhen)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aSinceWhen'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 280480362)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aOnlyPrivateBrowsing)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aOnlyPrivateBrowsing'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 10261376)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((this)->RecvSanitizeOriginKeys(std::move(aSinceWhen), std::move(aOnlyPrivateBrowsing))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PMedia::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PMediaParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    return MsgNotKnown;
}

auto PMediaParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PMediaParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PMediaParent::ClearSubtree() -> void
{
}



} // namespace media
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::media::PMediaParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::media::PMediaParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PMedia", PMediaMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::media::PMediaParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
