//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PMediaDecoderParams_h
#define PMediaDecoderParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "TimeUnits.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MediaDataIPDL|
//
namespace mozilla {
class MediaDataIPDL final
{
private:
    typedef mozilla::media::TimeUnit TimeUnit;

public:
    MOZ_IMPLICIT MediaDataIPDL() :
        time_(),
        timecode_(),
        duration_(),
        keyframe_(),
        offset_()
    {
    }

    MOZ_IMPLICIT MediaDataIPDL(
            const int64_t& _offset,
            const TimeUnit& _time,
            const TimeUnit& _timecode,
            const TimeUnit& _duration,
            const bool& _keyframe) :
        time_(_time),
        timecode_(_timecode),
        duration_(_duration),
        keyframe_(_keyframe),
        offset_(_offset)
    {
    }

    bool
    operator==(const MediaDataIPDL& _o) const;

    bool
    operator!=(const MediaDataIPDL& _o) const;

    int64_t&
    offset()
    {
        return offset_;
    }
    const int64_t&
    offset() const
    {
        return offset_;
    }

    TimeUnit&
    time()
    {
        return time_;
    }
    const TimeUnit&
    time() const
    {
        return time_;
    }

    TimeUnit&
    timecode()
    {
        return timecode_;
    }
    const TimeUnit&
    timecode() const
    {
        return timecode_;
    }

    TimeUnit&
    duration()
    {
        return duration_;
    }
    const TimeUnit&
    duration() const
    {
        return duration_;
    }

    bool&
    keyframe()
    {
        return keyframe_;
    }
    const bool&
    keyframe() const
    {
        return keyframe_;
    }

private:
    TimeUnit time_;
    TimeUnit timecode_;
    TimeUnit duration_;
    bool keyframe_;
    int64_t offset_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::MediaDataIPDL>
{
    typedef mozilla::MediaDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MediaRawDataIPDL|
//
namespace mozilla {
class MediaRawDataIPDL final
{
private:
    typedef mozilla::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT MediaRawDataIPDL() :
        base_(),
        eos_(),
        buffer_(),
        bufferSize_(),
        discardPadding_()
    {
    }

    MOZ_IMPLICIT MediaRawDataIPDL(
            const MediaDataIPDL& _base,
            const bool& _eos,
            const uint32_t& _discardPadding,
            const int64_t& _bufferSize,
            Shmem&& _buffer) :
        base_(_base),
        eos_(_eos),
        buffer_(_buffer),
        bufferSize_(_bufferSize),
        discardPadding_(_discardPadding)
    {
    }

    bool
    operator==(const MediaRawDataIPDL& _o) const;

    bool
    operator!=(const MediaRawDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    bool&
    eos()
    {
        return eos_;
    }
    const bool&
    eos() const
    {
        return eos_;
    }

    uint32_t&
    discardPadding()
    {
        return discardPadding_;
    }
    const uint32_t&
    discardPadding() const
    {
        return discardPadding_;
    }

    int64_t&
    bufferSize()
    {
        return bufferSize_;
    }
    const int64_t&
    bufferSize() const
    {
        return bufferSize_;
    }

    Shmem&
    buffer()
    {
        return buffer_;
    }
    Shmem&
    buffer() const
    {
        return const_cast<Shmem&>(buffer_);
    }

private:
    MediaDataIPDL base_;
    bool eos_;
    Shmem buffer_;
    int64_t bufferSize_;
    uint32_t discardPadding_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::MediaRawDataIPDL>
{
    typedef mozilla::MediaRawDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PMediaDecoderParams_h
