//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/PropertyBagUtils.h"
#include "mozilla/dom/SessionHistoryEntry.h"
#include "mozilla/ipc/BackgroundUtils.h"
#include "mozilla/net/PHttpChannelParams.h"
#include "nsDOMNavigationTiming.h"
#include "nsHttpResponseHead.h"
#include "nsILoadInfo.h"
#include "mozilla/dom/BlobTypes.h"
#include "mozilla/dom/ClientIPCTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/dom/IPCServiceWorkerDescriptor.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookiePermissionData|
//
namespace mozilla {
namespace net {
class CookiePermissionData final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT CookiePermissionData() :
        principalInfo_(),
        cookiePermission_()
    {
    }

    MOZ_IMPLICIT CookiePermissionData(
            const PrincipalInfo& _principalInfo,
            const uint32_t& _cookiePermission) :
        principalInfo_(_principalInfo),
        cookiePermission_(_cookiePermission)
    {
    }

    bool
    operator==(const CookiePermissionData& _o) const;

    bool
    operator!=(const CookiePermissionData& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    uint32_t&
    cookiePermission()
    {
        return cookiePermission_;
    }
    const uint32_t&
    cookiePermission() const
    {
        return cookiePermission_;
    }

private:
    PrincipalInfo principalInfo_;
    uint32_t cookiePermission_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookiePermissionData>
{
    typedef mozilla::net::CookiePermissionData paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieJarSettingsArgs|
//
namespace mozilla {
namespace net {
class CookieJarSettingsArgs final
{
private:
    typedef mozilla::net::CookiePermissionData CookiePermissionData;

public:
    MOZ_IMPLICIT CookieJarSettingsArgs() :
        isFirstPartyIsolated_(),
        isOnContentBlockingAllowList_(),
        cookiePermissions_(),
        isFixed_(),
        firstPartyDomain_(),
        cookieBehavior_()
    {
    }

    MOZ_IMPLICIT CookieJarSettingsArgs(
            const uint32_t& _cookieBehavior,
            const bool& _isFirstPartyIsolated,
            const bool& _isOnContentBlockingAllowList,
            const nsTArray<CookiePermissionData>& _cookiePermissions,
            const bool& _isFixed,
            const nsString& _firstPartyDomain) :
        isFirstPartyIsolated_(_isFirstPartyIsolated),
        isOnContentBlockingAllowList_(_isOnContentBlockingAllowList),
        cookiePermissions_(_cookiePermissions),
        isFixed_(_isFixed),
        firstPartyDomain_(_firstPartyDomain),
        cookieBehavior_(_cookieBehavior)
    {
    }

    bool
    operator==(const CookieJarSettingsArgs& _o) const;

    bool
    operator!=(const CookieJarSettingsArgs& _o) const;

    uint32_t&
    cookieBehavior()
    {
        return cookieBehavior_;
    }
    const uint32_t&
    cookieBehavior() const
    {
        return cookieBehavior_;
    }

    bool&
    isFirstPartyIsolated()
    {
        return isFirstPartyIsolated_;
    }
    const bool&
    isFirstPartyIsolated() const
    {
        return isFirstPartyIsolated_;
    }

    bool&
    isOnContentBlockingAllowList()
    {
        return isOnContentBlockingAllowList_;
    }
    const bool&
    isOnContentBlockingAllowList() const
    {
        return isOnContentBlockingAllowList_;
    }

    nsTArray<CookiePermissionData>&
    cookiePermissions()
    {
        return cookiePermissions_;
    }
    const nsTArray<CookiePermissionData>&
    cookiePermissions() const
    {
        return cookiePermissions_;
    }

    bool&
    isFixed()
    {
        return isFixed_;
    }
    const bool&
    isFixed() const
    {
        return isFixed_;
    }

    nsString&
    firstPartyDomain()
    {
        return firstPartyDomain_;
    }
    const nsString&
    firstPartyDomain() const
    {
        return firstPartyDomain_;
    }

private:
    bool isFirstPartyIsolated_;
    bool isOnContentBlockingAllowList_;
    CopyableTArray<CookiePermissionData> cookiePermissions_;
    bool isFixed_;
    nsString firstPartyDomain_;
    uint32_t cookieBehavior_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookieJarSettingsArgs>
{
    typedef mozilla::net::CookieJarSettingsArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PreferredAlternativeDataTypeParams|
//
namespace mozilla {
namespace net {
class PreferredAlternativeDataTypeParams final
{
private:

public:
    MOZ_IMPLICIT PreferredAlternativeDataTypeParams() :
        type_(),
        contentType_(),
        deliverAltData_()
    {
    }

    MOZ_IMPLICIT PreferredAlternativeDataTypeParams(
            const nsCString& _type,
            const nsCString& _contentType,
            const bool& _deliverAltData) :
        type_(_type),
        contentType_(_contentType),
        deliverAltData_(_deliverAltData)
    {
    }

    bool
    operator==(const PreferredAlternativeDataTypeParams& _o) const;

    bool
    operator!=(const PreferredAlternativeDataTypeParams& _o) const;

    nsCString&
    type()
    {
        return type_;
    }
    const nsCString&
    type() const
    {
        return type_;
    }

    nsCString&
    contentType()
    {
        return contentType_;
    }
    const nsCString&
    contentType() const
    {
        return contentType_;
    }

    bool&
    deliverAltData()
    {
        return deliverAltData_;
    }
    const bool&
    deliverAltData() const
    {
        return deliverAltData_;
    }

private:
    nsCString type_;
    nsCString contentType_;
    bool deliverAltData_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PreferredAlternativeDataTypeParams>
{
    typedef mozilla::net::PreferredAlternativeDataTypeParams paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RedirectHistoryEntryInfo|
//
namespace mozilla {
namespace net {
class RedirectHistoryEntryInfo final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;

public:
    MOZ_IMPLICIT RedirectHistoryEntryInfo() :
        principalInfo_(),
        referrerUri_(),
        remoteAddress_()
    {
    }

    MOZ_IMPLICIT RedirectHistoryEntryInfo(
            const PrincipalInfo& _principalInfo,
            const mozilla::Maybe<URIParams>& _referrerUri,
            const nsCString& _remoteAddress) :
        principalInfo_(_principalInfo),
        referrerUri_(_referrerUri),
        remoteAddress_(_remoteAddress)
    {
    }

    bool
    operator==(const RedirectHistoryEntryInfo& _o) const;

    bool
    operator!=(const RedirectHistoryEntryInfo& _o) const;

    PrincipalInfo&
    principalInfo()
    {
        return principalInfo_;
    }
    const PrincipalInfo&
    principalInfo() const
    {
        return principalInfo_;
    }

    mozilla::Maybe<URIParams>&
    referrerUri()
    {
        return referrerUri_;
    }
    const mozilla::Maybe<URIParams>&
    referrerUri() const
    {
        return referrerUri_;
    }

    nsCString&
    remoteAddress()
    {
        return remoteAddress_;
    }
    const nsCString&
    remoteAddress() const
    {
        return remoteAddress_;
    }

private:
    PrincipalInfo principalInfo_;
    mozilla::Maybe<URIParams> referrerUri_;
    nsCString remoteAddress_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::RedirectHistoryEntryInfo>
{
    typedef mozilla::net::RedirectHistoryEntryInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LoadInfoArgs|
//
namespace mozilla {
namespace net {
class LoadInfoArgs final
{
private:
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef mozilla::net::CookieJarSettingsArgs CookieJarSettingsArgs;
    typedef mozilla::ipc::CSPInfo CSPInfo;
    typedef nsILoadInfo::CrossOriginEmbedderPolicy CrossOriginEmbedderPolicy;

public:
    MOZ_IMPLICIT LoadInfoArgs() :
        requestingPrincipalInfo_(),
        triggeringPrincipalInfo_(),
        principalToInheritInfo_(),
        sandboxedLoadingPrincipalInfo_(),
        topLevelPrincipalInfo_(),
        topLevelStorageAreaPrincipalInfo_(),
        resultPrincipalURI_(),
        blockAllMixedContent_(),
        upgradeInsecureRequests_(),
        browserUpgradeInsecureRequests_(),
        browserWouldUpgradeInsecureRequests_(),
        forceAllowDataURI_(),
        allowInsecureRedirectToDataURI_(),
        bypassCORSChecks_(),
        skipContentPolicyCheckForWebRequest_(),
        originalFrameSrcLoad_(),
        forceInheritPrincipalDropped_(),
        initialSecurityCheckDone_(),
        isInThirdPartyContext_(),
        isThirdPartyContextToTopWindow_(),
        isFormSubmission_(),
        sendCSPViolationEvents_(),
        originAttributes_(),
        redirectChainIncludingInternalRedirects_(),
        redirectChain_(),
        ancestorPrincipals_(),
        ancestorOuterWindowIDs_(),
        clientInfo_(),
        reservedClientInfo_(),
        initialClientInfo_(),
        controller_(),
        corsUnsafeHeaders_(),
        forcePreflight_(),
        isPreflight_(),
        loadTriggeredFromExternal_(),
        serviceWorkerTaintingSynthesized_(),
        documentHasUserInteracted_(),
        documentHasLoaded_(),
        allowListFutureDocumentsCreatedFromThisRedirectChain_(),
        cspNonce_(),
        skipContentSniffing_(),
        hasValidUserGestureActivation_(),
        allowDeprecatedSystemRequests_(),
        parserCreatedScript_(),
        isFromProcessingFrameAttributes_(),
        cookieJarSettings_(),
        cspToInheritInfo_(),
        hasStoragePermission_(),
        loadingEmbedderPolicy_(),
        innerWindowID_(),
        outerWindowID_(),
        parentOuterWindowID_(),
        topOuterWindowID_(),
        frameOuterWindowID_(),
        browsingContextID_(),
        frameBrowsingContextID_(),
        securityFlags_(),
        sandboxFlags_(),
        contentPolicyType_(),
        tainting_(),
        httpsOnlyStatus_(),
        requestBlockingReason_()
    {
    }

    MOZ_IMPLICIT LoadInfoArgs(
            const mozilla::Maybe<PrincipalInfo>& _requestingPrincipalInfo,
            const PrincipalInfo& _triggeringPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _principalToInheritInfo,
            const mozilla::Maybe<PrincipalInfo>& _sandboxedLoadingPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _topLevelPrincipalInfo,
            const mozilla::Maybe<PrincipalInfo>& _topLevelStorageAreaPrincipalInfo,
            const mozilla::Maybe<URIParams>& _resultPrincipalURI,
            const uint32_t& _securityFlags,
            const uint32_t& _sandboxFlags,
            const uint32_t& _contentPolicyType,
            const uint32_t& _tainting,
            const bool& _blockAllMixedContent,
            const bool& _upgradeInsecureRequests,
            const bool& _browserUpgradeInsecureRequests,
            const bool& _browserWouldUpgradeInsecureRequests,
            const bool& _forceAllowDataURI,
            const bool& _allowInsecureRedirectToDataURI,
            const bool& _bypassCORSChecks,
            const bool& _skipContentPolicyCheckForWebRequest,
            const bool& _originalFrameSrcLoad,
            const bool& _forceInheritPrincipalDropped,
            const uint64_t& _innerWindowID,
            const uint64_t& _outerWindowID,
            const uint64_t& _parentOuterWindowID,
            const uint64_t& _topOuterWindowID,
            const uint64_t& _frameOuterWindowID,
            const uint64_t& _browsingContextID,
            const uint64_t& _frameBrowsingContextID,
            const bool& _initialSecurityCheckDone,
            const bool& _isInThirdPartyContext,
            const bool& _isThirdPartyContextToTopWindow,
            const bool& _isFormSubmission,
            const bool& _sendCSPViolationEvents,
            const OriginAttributes& _originAttributes,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChainIncludingInternalRedirects,
            const nsTArray<RedirectHistoryEntryInfo>& _redirectChain,
            const nsTArray<PrincipalInfo>& _ancestorPrincipals,
            const nsTArray<uint64_t>& _ancestorOuterWindowIDs,
            const mozilla::Maybe<IPCClientInfo>& _clientInfo,
            const mozilla::Maybe<IPCClientInfo>& _reservedClientInfo,
            const mozilla::Maybe<IPCClientInfo>& _initialClientInfo,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const nsTArray<nsCString>& _corsUnsafeHeaders,
            const bool& _forcePreflight,
            const bool& _isPreflight,
            const bool& _loadTriggeredFromExternal,
            const bool& _serviceWorkerTaintingSynthesized,
            const bool& _documentHasUserInteracted,
            const bool& _documentHasLoaded,
            const bool& _allowListFutureDocumentsCreatedFromThisRedirectChain,
            const nsString& _cspNonce,
            const bool& _skipContentSniffing,
            const uint32_t& _httpsOnlyStatus,
            const bool& _hasValidUserGestureActivation,
            const bool& _allowDeprecatedSystemRequests,
            const bool& _parserCreatedScript,
            const bool& _isFromProcessingFrameAttributes,
            const CookieJarSettingsArgs& _cookieJarSettings,
            const uint32_t& _requestBlockingReason,
            const mozilla::Maybe<CSPInfo>& _cspToInheritInfo,
            const bool& _hasStoragePermission,
            const CrossOriginEmbedderPolicy& _loadingEmbedderPolicy) :
        requestingPrincipalInfo_(_requestingPrincipalInfo),
        triggeringPrincipalInfo_(_triggeringPrincipalInfo),
        principalToInheritInfo_(_principalToInheritInfo),
        sandboxedLoadingPrincipalInfo_(_sandboxedLoadingPrincipalInfo),
        topLevelPrincipalInfo_(_topLevelPrincipalInfo),
        topLevelStorageAreaPrincipalInfo_(_topLevelStorageAreaPrincipalInfo),
        resultPrincipalURI_(_resultPrincipalURI),
        blockAllMixedContent_(_blockAllMixedContent),
        upgradeInsecureRequests_(_upgradeInsecureRequests),
        browserUpgradeInsecureRequests_(_browserUpgradeInsecureRequests),
        browserWouldUpgradeInsecureRequests_(_browserWouldUpgradeInsecureRequests),
        forceAllowDataURI_(_forceAllowDataURI),
        allowInsecureRedirectToDataURI_(_allowInsecureRedirectToDataURI),
        bypassCORSChecks_(_bypassCORSChecks),
        skipContentPolicyCheckForWebRequest_(_skipContentPolicyCheckForWebRequest),
        originalFrameSrcLoad_(_originalFrameSrcLoad),
        forceInheritPrincipalDropped_(_forceInheritPrincipalDropped),
        initialSecurityCheckDone_(_initialSecurityCheckDone),
        isInThirdPartyContext_(_isInThirdPartyContext),
        isThirdPartyContextToTopWindow_(_isThirdPartyContextToTopWindow),
        isFormSubmission_(_isFormSubmission),
        sendCSPViolationEvents_(_sendCSPViolationEvents),
        originAttributes_(_originAttributes),
        redirectChainIncludingInternalRedirects_(_redirectChainIncludingInternalRedirects),
        redirectChain_(_redirectChain),
        ancestorPrincipals_(_ancestorPrincipals),
        ancestorOuterWindowIDs_(_ancestorOuterWindowIDs),
        clientInfo_(_clientInfo),
        reservedClientInfo_(_reservedClientInfo),
        initialClientInfo_(_initialClientInfo),
        controller_(_controller),
        corsUnsafeHeaders_(_corsUnsafeHeaders),
        forcePreflight_(_forcePreflight),
        isPreflight_(_isPreflight),
        loadTriggeredFromExternal_(_loadTriggeredFromExternal),
        serviceWorkerTaintingSynthesized_(_serviceWorkerTaintingSynthesized),
        documentHasUserInteracted_(_documentHasUserInteracted),
        documentHasLoaded_(_documentHasLoaded),
        allowListFutureDocumentsCreatedFromThisRedirectChain_(_allowListFutureDocumentsCreatedFromThisRedirectChain),
        cspNonce_(_cspNonce),
        skipContentSniffing_(_skipContentSniffing),
        hasValidUserGestureActivation_(_hasValidUserGestureActivation),
        allowDeprecatedSystemRequests_(_allowDeprecatedSystemRequests),
        parserCreatedScript_(_parserCreatedScript),
        isFromProcessingFrameAttributes_(_isFromProcessingFrameAttributes),
        cookieJarSettings_(_cookieJarSettings),
        cspToInheritInfo_(_cspToInheritInfo),
        hasStoragePermission_(_hasStoragePermission),
        loadingEmbedderPolicy_(_loadingEmbedderPolicy),
        innerWindowID_(_innerWindowID),
        outerWindowID_(_outerWindowID),
        parentOuterWindowID_(_parentOuterWindowID),
        topOuterWindowID_(_topOuterWindowID),
        frameOuterWindowID_(_frameOuterWindowID),
        browsingContextID_(_browsingContextID),
        frameBrowsingContextID_(_frameBrowsingContextID),
        securityFlags_(_securityFlags),
        sandboxFlags_(_sandboxFlags),
        contentPolicyType_(_contentPolicyType),
        tainting_(_tainting),
        httpsOnlyStatus_(_httpsOnlyStatus),
        requestBlockingReason_(_requestBlockingReason)
    {
    }

    bool
    operator==(const LoadInfoArgs& _o) const;

    bool
    operator!=(const LoadInfoArgs& _o) const;

    mozilla::Maybe<PrincipalInfo>&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    PrincipalInfo&
    triggeringPrincipalInfo()
    {
        return triggeringPrincipalInfo_;
    }
    const PrincipalInfo&
    triggeringPrincipalInfo() const
    {
        return triggeringPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalToInheritInfo()
    {
        return principalToInheritInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalToInheritInfo() const
    {
        return principalToInheritInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    sandboxedLoadingPrincipalInfo()
    {
        return sandboxedLoadingPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    sandboxedLoadingPrincipalInfo() const
    {
        return sandboxedLoadingPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    topLevelPrincipalInfo()
    {
        return topLevelPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    topLevelPrincipalInfo() const
    {
        return topLevelPrincipalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    topLevelStorageAreaPrincipalInfo()
    {
        return topLevelStorageAreaPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    topLevelStorageAreaPrincipalInfo() const
    {
        return topLevelStorageAreaPrincipalInfo_;
    }

    mozilla::Maybe<URIParams>&
    resultPrincipalURI()
    {
        return resultPrincipalURI_;
    }
    const mozilla::Maybe<URIParams>&
    resultPrincipalURI() const
    {
        return resultPrincipalURI_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    sandboxFlags()
    {
        return sandboxFlags_;
    }
    const uint32_t&
    sandboxFlags() const
    {
        return sandboxFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    blockAllMixedContent()
    {
        return blockAllMixedContent_;
    }
    const bool&
    blockAllMixedContent() const
    {
        return blockAllMixedContent_;
    }

    bool&
    upgradeInsecureRequests()
    {
        return upgradeInsecureRequests_;
    }
    const bool&
    upgradeInsecureRequests() const
    {
        return upgradeInsecureRequests_;
    }

    bool&
    browserUpgradeInsecureRequests()
    {
        return browserUpgradeInsecureRequests_;
    }
    const bool&
    browserUpgradeInsecureRequests() const
    {
        return browserUpgradeInsecureRequests_;
    }

    bool&
    browserWouldUpgradeInsecureRequests()
    {
        return browserWouldUpgradeInsecureRequests_;
    }
    const bool&
    browserWouldUpgradeInsecureRequests() const
    {
        return browserWouldUpgradeInsecureRequests_;
    }

    bool&
    forceAllowDataURI()
    {
        return forceAllowDataURI_;
    }
    const bool&
    forceAllowDataURI() const
    {
        return forceAllowDataURI_;
    }

    bool&
    allowInsecureRedirectToDataURI()
    {
        return allowInsecureRedirectToDataURI_;
    }
    const bool&
    allowInsecureRedirectToDataURI() const
    {
        return allowInsecureRedirectToDataURI_;
    }

    bool&
    bypassCORSChecks()
    {
        return bypassCORSChecks_;
    }
    const bool&
    bypassCORSChecks() const
    {
        return bypassCORSChecks_;
    }

    bool&
    skipContentPolicyCheckForWebRequest()
    {
        return skipContentPolicyCheckForWebRequest_;
    }
    const bool&
    skipContentPolicyCheckForWebRequest() const
    {
        return skipContentPolicyCheckForWebRequest_;
    }

    bool&
    originalFrameSrcLoad()
    {
        return originalFrameSrcLoad_;
    }
    const bool&
    originalFrameSrcLoad() const
    {
        return originalFrameSrcLoad_;
    }

    bool&
    forceInheritPrincipalDropped()
    {
        return forceInheritPrincipalDropped_;
    }
    const bool&
    forceInheritPrincipalDropped() const
    {
        return forceInheritPrincipalDropped_;
    }

    uint64_t&
    innerWindowID()
    {
        return innerWindowID_;
    }
    const uint64_t&
    innerWindowID() const
    {
        return innerWindowID_;
    }

    uint64_t&
    outerWindowID()
    {
        return outerWindowID_;
    }
    const uint64_t&
    outerWindowID() const
    {
        return outerWindowID_;
    }

    uint64_t&
    parentOuterWindowID()
    {
        return parentOuterWindowID_;
    }
    const uint64_t&
    parentOuterWindowID() const
    {
        return parentOuterWindowID_;
    }

    uint64_t&
    topOuterWindowID()
    {
        return topOuterWindowID_;
    }
    const uint64_t&
    topOuterWindowID() const
    {
        return topOuterWindowID_;
    }

    uint64_t&
    frameOuterWindowID()
    {
        return frameOuterWindowID_;
    }
    const uint64_t&
    frameOuterWindowID() const
    {
        return frameOuterWindowID_;
    }

    uint64_t&
    browsingContextID()
    {
        return browsingContextID_;
    }
    const uint64_t&
    browsingContextID() const
    {
        return browsingContextID_;
    }

    uint64_t&
    frameBrowsingContextID()
    {
        return frameBrowsingContextID_;
    }
    const uint64_t&
    frameBrowsingContextID() const
    {
        return frameBrowsingContextID_;
    }

    bool&
    initialSecurityCheckDone()
    {
        return initialSecurityCheckDone_;
    }
    const bool&
    initialSecurityCheckDone() const
    {
        return initialSecurityCheckDone_;
    }

    bool&
    isInThirdPartyContext()
    {
        return isInThirdPartyContext_;
    }
    const bool&
    isInThirdPartyContext() const
    {
        return isInThirdPartyContext_;
    }

    bool&
    isThirdPartyContextToTopWindow()
    {
        return isThirdPartyContextToTopWindow_;
    }
    const bool&
    isThirdPartyContextToTopWindow() const
    {
        return isThirdPartyContextToTopWindow_;
    }

    bool&
    isFormSubmission()
    {
        return isFormSubmission_;
    }
    const bool&
    isFormSubmission() const
    {
        return isFormSubmission_;
    }

    bool&
    sendCSPViolationEvents()
    {
        return sendCSPViolationEvents_;
    }
    const bool&
    sendCSPViolationEvents() const
    {
        return sendCSPViolationEvents_;
    }

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects()
    {
        return redirectChainIncludingInternalRedirects_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChainIncludingInternalRedirects() const
    {
        return redirectChainIncludingInternalRedirects_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    redirectChain()
    {
        return redirectChain_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    redirectChain() const
    {
        return redirectChain_;
    }

    nsTArray<PrincipalInfo>&
    ancestorPrincipals()
    {
        return ancestorPrincipals_;
    }
    const nsTArray<PrincipalInfo>&
    ancestorPrincipals() const
    {
        return ancestorPrincipals_;
    }

    nsTArray<uint64_t>&
    ancestorOuterWindowIDs()
    {
        return ancestorOuterWindowIDs_;
    }
    const nsTArray<uint64_t>&
    ancestorOuterWindowIDs() const
    {
        return ancestorOuterWindowIDs_;
    }

    mozilla::Maybe<IPCClientInfo>&
    clientInfo()
    {
        return clientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    clientInfo() const
    {
        return clientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo()
    {
        return reservedClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo() const
    {
        return reservedClientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    nsTArray<nsCString>&
    corsUnsafeHeaders()
    {
        return corsUnsafeHeaders_;
    }
    const nsTArray<nsCString>&
    corsUnsafeHeaders() const
    {
        return corsUnsafeHeaders_;
    }

    bool&
    forcePreflight()
    {
        return forcePreflight_;
    }
    const bool&
    forcePreflight() const
    {
        return forcePreflight_;
    }

    bool&
    isPreflight()
    {
        return isPreflight_;
    }
    const bool&
    isPreflight() const
    {
        return isPreflight_;
    }

    bool&
    loadTriggeredFromExternal()
    {
        return loadTriggeredFromExternal_;
    }
    const bool&
    loadTriggeredFromExternal() const
    {
        return loadTriggeredFromExternal_;
    }

    bool&
    serviceWorkerTaintingSynthesized()
    {
        return serviceWorkerTaintingSynthesized_;
    }
    const bool&
    serviceWorkerTaintingSynthesized() const
    {
        return serviceWorkerTaintingSynthesized_;
    }

    bool&
    documentHasUserInteracted()
    {
        return documentHasUserInteracted_;
    }
    const bool&
    documentHasUserInteracted() const
    {
        return documentHasUserInteracted_;
    }

    bool&
    documentHasLoaded()
    {
        return documentHasLoaded_;
    }
    const bool&
    documentHasLoaded() const
    {
        return documentHasLoaded_;
    }

    bool&
    allowListFutureDocumentsCreatedFromThisRedirectChain()
    {
        return allowListFutureDocumentsCreatedFromThisRedirectChain_;
    }
    const bool&
    allowListFutureDocumentsCreatedFromThisRedirectChain() const
    {
        return allowListFutureDocumentsCreatedFromThisRedirectChain_;
    }

    nsString&
    cspNonce()
    {
        return cspNonce_;
    }
    const nsString&
    cspNonce() const
    {
        return cspNonce_;
    }

    bool&
    skipContentSniffing()
    {
        return skipContentSniffing_;
    }
    const bool&
    skipContentSniffing() const
    {
        return skipContentSniffing_;
    }

    uint32_t&
    httpsOnlyStatus()
    {
        return httpsOnlyStatus_;
    }
    const uint32_t&
    httpsOnlyStatus() const
    {
        return httpsOnlyStatus_;
    }

    bool&
    hasValidUserGestureActivation()
    {
        return hasValidUserGestureActivation_;
    }
    const bool&
    hasValidUserGestureActivation() const
    {
        return hasValidUserGestureActivation_;
    }

    bool&
    allowDeprecatedSystemRequests()
    {
        return allowDeprecatedSystemRequests_;
    }
    const bool&
    allowDeprecatedSystemRequests() const
    {
        return allowDeprecatedSystemRequests_;
    }

    bool&
    parserCreatedScript()
    {
        return parserCreatedScript_;
    }
    const bool&
    parserCreatedScript() const
    {
        return parserCreatedScript_;
    }

    bool&
    isFromProcessingFrameAttributes()
    {
        return isFromProcessingFrameAttributes_;
    }
    const bool&
    isFromProcessingFrameAttributes() const
    {
        return isFromProcessingFrameAttributes_;
    }

    CookieJarSettingsArgs&
    cookieJarSettings()
    {
        return cookieJarSettings_;
    }
    const CookieJarSettingsArgs&
    cookieJarSettings() const
    {
        return cookieJarSettings_;
    }

    uint32_t&
    requestBlockingReason()
    {
        return requestBlockingReason_;
    }
    const uint32_t&
    requestBlockingReason() const
    {
        return requestBlockingReason_;
    }

    mozilla::Maybe<CSPInfo>&
    cspToInheritInfo()
    {
        return cspToInheritInfo_;
    }
    const mozilla::Maybe<CSPInfo>&
    cspToInheritInfo() const
    {
        return cspToInheritInfo_;
    }

    bool&
    hasStoragePermission()
    {
        return hasStoragePermission_;
    }
    const bool&
    hasStoragePermission() const
    {
        return hasStoragePermission_;
    }

    CrossOriginEmbedderPolicy&
    loadingEmbedderPolicy()
    {
        return loadingEmbedderPolicy_;
    }
    const CrossOriginEmbedderPolicy&
    loadingEmbedderPolicy() const
    {
        return loadingEmbedderPolicy_;
    }

private:
    void
    StaticAssertions() const;
    mozilla::Maybe<PrincipalInfo> requestingPrincipalInfo_;
    PrincipalInfo triggeringPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> principalToInheritInfo_;
    mozilla::Maybe<PrincipalInfo> sandboxedLoadingPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> topLevelPrincipalInfo_;
    mozilla::Maybe<PrincipalInfo> topLevelStorageAreaPrincipalInfo_;
    mozilla::Maybe<URIParams> resultPrincipalURI_;
    bool blockAllMixedContent_;
    bool upgradeInsecureRequests_;
    bool browserUpgradeInsecureRequests_;
    bool browserWouldUpgradeInsecureRequests_;
    bool forceAllowDataURI_;
    bool allowInsecureRedirectToDataURI_;
    bool bypassCORSChecks_;
    bool skipContentPolicyCheckForWebRequest_;
    bool originalFrameSrcLoad_;
    bool forceInheritPrincipalDropped_;
    bool initialSecurityCheckDone_;
    bool isInThirdPartyContext_;
    bool isThirdPartyContextToTopWindow_;
    bool isFormSubmission_;
    bool sendCSPViolationEvents_;
    OriginAttributes originAttributes_;
    CopyableTArray<RedirectHistoryEntryInfo> redirectChainIncludingInternalRedirects_;
    CopyableTArray<RedirectHistoryEntryInfo> redirectChain_;
    CopyableTArray<PrincipalInfo> ancestorPrincipals_;
    CopyableTArray<uint64_t> ancestorOuterWindowIDs_;
    mozilla::Maybe<IPCClientInfo> clientInfo_;
    mozilla::Maybe<IPCClientInfo> reservedClientInfo_;
    mozilla::Maybe<IPCClientInfo> initialClientInfo_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    CopyableTArray<nsCString> corsUnsafeHeaders_;
    bool forcePreflight_;
    bool isPreflight_;
    bool loadTriggeredFromExternal_;
    bool serviceWorkerTaintingSynthesized_;
    bool documentHasUserInteracted_;
    bool documentHasLoaded_;
    bool allowListFutureDocumentsCreatedFromThisRedirectChain_;
    nsString cspNonce_;
    bool skipContentSniffing_;
    bool hasValidUserGestureActivation_;
    bool allowDeprecatedSystemRequests_;
    bool parserCreatedScript_;
    bool isFromProcessingFrameAttributes_;
    CookieJarSettingsArgs cookieJarSettings_;
    mozilla::Maybe<CSPInfo> cspToInheritInfo_;
    bool hasStoragePermission_;
    CrossOriginEmbedderPolicy loadingEmbedderPolicy_;
    uint64_t innerWindowID_;
    uint64_t outerWindowID_;
    uint64_t parentOuterWindowID_;
    uint64_t topOuterWindowID_;
    uint64_t frameOuterWindowID_;
    uint64_t browsingContextID_;
    uint64_t frameBrowsingContextID_;
    uint32_t securityFlags_;
    uint32_t sandboxFlags_;
    uint32_t contentPolicyType_;
    uint32_t tainting_;
    uint32_t httpsOnlyStatus_;
    uint32_t requestBlockingReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::LoadInfoArgs>
{
    typedef mozilla::net::LoadInfoArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentLoadInfoForwarderArgs|
//
namespace mozilla {
namespace net {
class ParentLoadInfoForwarderArgs final
{
private:
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;
    typedef mozilla::net::CookieJarSettingsArgs CookieJarSettingsArgs;

public:
    MOZ_IMPLICIT ParentLoadInfoForwarderArgs() :
        allowInsecureRedirectToDataURI_(),
        bypassCORSChecks_(),
        controller_(),
        skipContentSniffing_(),
        hasValidUserGestureActivation_(),
        allowDeprecatedSystemRequests_(),
        parserCreatedScript_(),
        serviceWorkerTaintingSynthesized_(),
        documentHasUserInteracted_(),
        documentHasLoaded_(),
        allowListFutureDocumentsCreatedFromThisRedirectChain_(),
        cookieJarSettings_(),
        hasStoragePermission_(),
        isThirdPartyContextToTopWindow_(),
        tainting_(),
        httpsOnlyStatus_(),
        requestBlockingReason_()
    {
    }

    MOZ_IMPLICIT ParentLoadInfoForwarderArgs(
            const bool& _allowInsecureRedirectToDataURI,
            const bool& _bypassCORSChecks,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const uint32_t& _tainting,
            const bool& _skipContentSniffing,
            const uint32_t& _httpsOnlyStatus,
            const bool& _hasValidUserGestureActivation,
            const bool& _allowDeprecatedSystemRequests,
            const bool& _parserCreatedScript,
            const bool& _serviceWorkerTaintingSynthesized,
            const bool& _documentHasUserInteracted,
            const bool& _documentHasLoaded,
            const bool& _allowListFutureDocumentsCreatedFromThisRedirectChain,
            const mozilla::Maybe<CookieJarSettingsArgs>& _cookieJarSettings,
            const uint32_t& _requestBlockingReason,
            const bool& _hasStoragePermission,
            const bool& _isThirdPartyContextToTopWindow) :
        allowInsecureRedirectToDataURI_(_allowInsecureRedirectToDataURI),
        bypassCORSChecks_(_bypassCORSChecks),
        controller_(_controller),
        skipContentSniffing_(_skipContentSniffing),
        hasValidUserGestureActivation_(_hasValidUserGestureActivation),
        allowDeprecatedSystemRequests_(_allowDeprecatedSystemRequests),
        parserCreatedScript_(_parserCreatedScript),
        serviceWorkerTaintingSynthesized_(_serviceWorkerTaintingSynthesized),
        documentHasUserInteracted_(_documentHasUserInteracted),
        documentHasLoaded_(_documentHasLoaded),
        allowListFutureDocumentsCreatedFromThisRedirectChain_(_allowListFutureDocumentsCreatedFromThisRedirectChain),
        cookieJarSettings_(_cookieJarSettings),
        hasStoragePermission_(_hasStoragePermission),
        isThirdPartyContextToTopWindow_(_isThirdPartyContextToTopWindow),
        tainting_(_tainting),
        httpsOnlyStatus_(_httpsOnlyStatus),
        requestBlockingReason_(_requestBlockingReason)
    {
    }

    bool
    operator==(const ParentLoadInfoForwarderArgs& _o) const;

    bool
    operator!=(const ParentLoadInfoForwarderArgs& _o) const;

    bool&
    allowInsecureRedirectToDataURI()
    {
        return allowInsecureRedirectToDataURI_;
    }
    const bool&
    allowInsecureRedirectToDataURI() const
    {
        return allowInsecureRedirectToDataURI_;
    }

    bool&
    bypassCORSChecks()
    {
        return bypassCORSChecks_;
    }
    const bool&
    bypassCORSChecks() const
    {
        return bypassCORSChecks_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    uint32_t&
    tainting()
    {
        return tainting_;
    }
    const uint32_t&
    tainting() const
    {
        return tainting_;
    }

    bool&
    skipContentSniffing()
    {
        return skipContentSniffing_;
    }
    const bool&
    skipContentSniffing() const
    {
        return skipContentSniffing_;
    }

    uint32_t&
    httpsOnlyStatus()
    {
        return httpsOnlyStatus_;
    }
    const uint32_t&
    httpsOnlyStatus() const
    {
        return httpsOnlyStatus_;
    }

    bool&
    hasValidUserGestureActivation()
    {
        return hasValidUserGestureActivation_;
    }
    const bool&
    hasValidUserGestureActivation() const
    {
        return hasValidUserGestureActivation_;
    }

    bool&
    allowDeprecatedSystemRequests()
    {
        return allowDeprecatedSystemRequests_;
    }
    const bool&
    allowDeprecatedSystemRequests() const
    {
        return allowDeprecatedSystemRequests_;
    }

    bool&
    parserCreatedScript()
    {
        return parserCreatedScript_;
    }
    const bool&
    parserCreatedScript() const
    {
        return parserCreatedScript_;
    }

    bool&
    serviceWorkerTaintingSynthesized()
    {
        return serviceWorkerTaintingSynthesized_;
    }
    const bool&
    serviceWorkerTaintingSynthesized() const
    {
        return serviceWorkerTaintingSynthesized_;
    }

    bool&
    documentHasUserInteracted()
    {
        return documentHasUserInteracted_;
    }
    const bool&
    documentHasUserInteracted() const
    {
        return documentHasUserInteracted_;
    }

    bool&
    documentHasLoaded()
    {
        return documentHasLoaded_;
    }
    const bool&
    documentHasLoaded() const
    {
        return documentHasLoaded_;
    }

    bool&
    allowListFutureDocumentsCreatedFromThisRedirectChain()
    {
        return allowListFutureDocumentsCreatedFromThisRedirectChain_;
    }
    const bool&
    allowListFutureDocumentsCreatedFromThisRedirectChain() const
    {
        return allowListFutureDocumentsCreatedFromThisRedirectChain_;
    }

    mozilla::Maybe<CookieJarSettingsArgs>&
    cookieJarSettings()
    {
        return cookieJarSettings_;
    }
    const mozilla::Maybe<CookieJarSettingsArgs>&
    cookieJarSettings() const
    {
        return cookieJarSettings_;
    }

    uint32_t&
    requestBlockingReason()
    {
        return requestBlockingReason_;
    }
    const uint32_t&
    requestBlockingReason() const
    {
        return requestBlockingReason_;
    }

    bool&
    hasStoragePermission()
    {
        return hasStoragePermission_;
    }
    const bool&
    hasStoragePermission() const
    {
        return hasStoragePermission_;
    }

    bool&
    isThirdPartyContextToTopWindow()
    {
        return isThirdPartyContextToTopWindow_;
    }
    const bool&
    isThirdPartyContextToTopWindow() const
    {
        return isThirdPartyContextToTopWindow_;
    }

private:
    void
    StaticAssertions() const;
    bool allowInsecureRedirectToDataURI_;
    bool bypassCORSChecks_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    bool skipContentSniffing_;
    bool hasValidUserGestureActivation_;
    bool allowDeprecatedSystemRequests_;
    bool parserCreatedScript_;
    bool serviceWorkerTaintingSynthesized_;
    bool documentHasUserInteracted_;
    bool documentHasLoaded_;
    bool allowListFutureDocumentsCreatedFromThisRedirectChain_;
    mozilla::Maybe<CookieJarSettingsArgs> cookieJarSettings_;
    bool hasStoragePermission_;
    bool isThirdPartyContextToTopWindow_;
    uint32_t tainting_;
    uint32_t httpsOnlyStatus_;
    uint32_t requestBlockingReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ParentLoadInfoForwarderArgs>
{
    typedef mozilla::net::ParentLoadInfoForwarderArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildLoadInfoForwarderArgs|
//
namespace mozilla {
namespace net {
class ChildLoadInfoForwarderArgs final
{
private:
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;
    typedef mozilla::dom::IPCServiceWorkerDescriptor IPCServiceWorkerDescriptor;

public:
    MOZ_IMPLICIT ChildLoadInfoForwarderArgs() :
        reservedClientInfo_(),
        initialClientInfo_(),
        controller_(),
        requestBlockingReason_()
    {
    }

    MOZ_IMPLICIT ChildLoadInfoForwarderArgs(
            const mozilla::Maybe<IPCClientInfo>& _reservedClientInfo,
            const mozilla::Maybe<IPCClientInfo>& _initialClientInfo,
            const mozilla::Maybe<IPCServiceWorkerDescriptor>& _controller,
            const uint32_t& _requestBlockingReason) :
        reservedClientInfo_(_reservedClientInfo),
        initialClientInfo_(_initialClientInfo),
        controller_(_controller),
        requestBlockingReason_(_requestBlockingReason)
    {
    }

    bool
    operator==(const ChildLoadInfoForwarderArgs& _o) const;

    bool
    operator!=(const ChildLoadInfoForwarderArgs& _o) const;

    mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo()
    {
        return reservedClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    reservedClientInfo() const
    {
        return reservedClientInfo_;
    }

    mozilla::Maybe<IPCClientInfo>&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller()
    {
        return controller_;
    }
    const mozilla::Maybe<IPCServiceWorkerDescriptor>&
    controller() const
    {
        return controller_;
    }

    uint32_t&
    requestBlockingReason()
    {
        return requestBlockingReason_;
    }
    const uint32_t&
    requestBlockingReason() const
    {
        return requestBlockingReason_;
    }

private:
    mozilla::Maybe<IPCClientInfo> reservedClientInfo_;
    mozilla::Maybe<IPCClientInfo> initialClientInfo_;
    mozilla::Maybe<IPCServiceWorkerDescriptor> controller_;
    uint32_t requestBlockingReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ChildLoadInfoForwarderArgs>
{
    typedef mozilla::net::ChildLoadInfoForwarderArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CorsPreflightArgs|
//
namespace mozilla {
namespace net {
class CorsPreflightArgs final
{
private:

public:
    MOZ_IMPLICIT CorsPreflightArgs() :
        unsafeHeaders_()
    {
    }

    MOZ_IMPLICIT CorsPreflightArgs(const nsTArray<nsCString>& _unsafeHeaders) :
        unsafeHeaders_(_unsafeHeaders)
    {
    }

    bool
    operator==(const CorsPreflightArgs& _o) const;

    bool
    operator!=(const CorsPreflightArgs& _o) const;

    nsTArray<nsCString>&
    unsafeHeaders()
    {
        return unsafeHeaders_;
    }
    const nsTArray<nsCString>&
    unsafeHeaders() const
    {
        return unsafeHeaders_;
    }

private:
    CopyableTArray<nsCString> unsafeHeaders_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CorsPreflightArgs>
{
    typedef mozilla::net::CorsPreflightArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef mozilla::net::nsHttpResponseHead nsHttpResponseHead;
    typedef mozilla::net::CorsPreflightArgs CorsPreflightArgs;
    typedef mozilla::net::PreferredAlternativeDataTypeParams PreferredAlternativeDataTypeParams;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs() :
        uri_(),
        original_(),
        doc_(),
        referrerInfo_(),
        apiRedirectTo_(),
        topWindowURI_(),
        requestHeaders_(),
        requestMethod_(),
        uploadStream_(),
        uploadStreamHasHeaders_(),
        allowSTS_(),
        resumeAt_(),
        entityID_(),
        chooseApplicationCache_(),
        appCacheClientID_(),
        allowSpdy_(),
        allowAltSvc_(),
        beConservative_(),
        loadInfo_(),
        synthesizedResponseHead_(),
        synthesizedSecurityInfoSerialization_(),
        preflightArgs_(),
        blockAuthPrompt_(),
        suspendAfterSynthesizeResponse_(),
        allowStaleCacheContent_(),
        preferCacheLoadOverBypass_(),
        contentTypeHint_(),
        integrityMetadata_(),
        preferredAlternativeTypes_(),
        launchServiceWorkerStart_(),
        launchServiceWorkerEnd_(),
        dispatchFetchEventStart_(),
        dispatchFetchEventEnd_(),
        handleFetchEventStart_(),
        handleFetchEventEnd_(),
        forceMainDocumentChannel_(),
        navigationStartTimeStamp_(),
        hasNonEmptySandboxingFlag_(),
        startPos_(),
        requestContextID_(),
        channelId_(),
        contentWindowId_(),
        topLevelOuterContentWindowId_(),
        loadFlags_(),
        classOfService_(),
        thirdPartyFlags_(),
        tlsFlags_(),
        cacheKey_(),
        initialRwin_(),
        corsMode_(),
        redirectMode_(),
        priority_(),
        redirectionLimit_()
    {
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const mozilla::Maybe<URIParams>& _original,
            const mozilla::Maybe<URIParams>& _doc,
            nsIReferrerInfo* _referrerInfo,
            const mozilla::Maybe<URIParams>& _apiRedirectTo,
            const mozilla::Maybe<URIParams>& _topWindowURI,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const mozilla::Maybe<IPCStream>& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const int16_t& _priority,
            const uint32_t& _classOfService,
            const uint8_t& _redirectionLimit,
            const bool& _allowSTS,
            const uint32_t& _thirdPartyFlags,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const bool& _allowAltSvc,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const mozilla::Maybe<LoadInfoArgs>& _loadInfo,
            const mozilla::Maybe<nsHttpResponseHead>& _synthesizedResponseHead,
            const nsCString& _synthesizedSecurityInfoSerialization,
            const uint32_t& _cacheKey,
            const uint64_t& _requestContextID,
            const mozilla::Maybe<CorsPreflightArgs>& _preflightArgs,
            const uint32_t& _initialRwin,
            const bool& _blockAuthPrompt,
            const bool& _suspendAfterSynthesizeResponse,
            const bool& _allowStaleCacheContent,
            const bool& _preferCacheLoadOverBypass,
            const nsCString& _contentTypeHint,
            const uint32_t& _corsMode,
            const uint32_t& _redirectMode,
            const uint64_t& _channelId,
            const nsString& _integrityMetadata,
            const uint64_t& _contentWindowId,
            const nsTArray<PreferredAlternativeDataTypeParams>& _preferredAlternativeTypes,
            const uint64_t& _topLevelOuterContentWindowId,
            const TimeStamp& _launchServiceWorkerStart,
            const TimeStamp& _launchServiceWorkerEnd,
            const TimeStamp& _dispatchFetchEventStart,
            const TimeStamp& _dispatchFetchEventEnd,
            const TimeStamp& _handleFetchEventStart,
            const TimeStamp& _handleFetchEventEnd,
            const bool& _forceMainDocumentChannel,
            const TimeStamp& _navigationStartTimeStamp,
            const bool& _hasNonEmptySandboxingFlag) :
        uri_(_uri),
        original_(_original),
        doc_(_doc),
        referrerInfo_(_referrerInfo),
        apiRedirectTo_(_apiRedirectTo),
        topWindowURI_(_topWindowURI),
        requestHeaders_(_requestHeaders),
        requestMethod_(_requestMethod),
        uploadStream_(_uploadStream),
        uploadStreamHasHeaders_(_uploadStreamHasHeaders),
        allowSTS_(_allowSTS),
        resumeAt_(_resumeAt),
        entityID_(_entityID),
        chooseApplicationCache_(_chooseApplicationCache),
        appCacheClientID_(_appCacheClientID),
        allowSpdy_(_allowSpdy),
        allowAltSvc_(_allowAltSvc),
        beConservative_(_beConservative),
        loadInfo_(_loadInfo),
        synthesizedResponseHead_(_synthesizedResponseHead),
        synthesizedSecurityInfoSerialization_(_synthesizedSecurityInfoSerialization),
        preflightArgs_(_preflightArgs),
        blockAuthPrompt_(_blockAuthPrompt),
        suspendAfterSynthesizeResponse_(_suspendAfterSynthesizeResponse),
        allowStaleCacheContent_(_allowStaleCacheContent),
        preferCacheLoadOverBypass_(_preferCacheLoadOverBypass),
        contentTypeHint_(_contentTypeHint),
        integrityMetadata_(_integrityMetadata),
        preferredAlternativeTypes_(_preferredAlternativeTypes),
        launchServiceWorkerStart_(_launchServiceWorkerStart),
        launchServiceWorkerEnd_(_launchServiceWorkerEnd),
        dispatchFetchEventStart_(_dispatchFetchEventStart),
        dispatchFetchEventEnd_(_dispatchFetchEventEnd),
        handleFetchEventStart_(_handleFetchEventStart),
        handleFetchEventEnd_(_handleFetchEventEnd),
        forceMainDocumentChannel_(_forceMainDocumentChannel),
        navigationStartTimeStamp_(_navigationStartTimeStamp),
        hasNonEmptySandboxingFlag_(_hasNonEmptySandboxingFlag),
        startPos_(_startPos),
        requestContextID_(_requestContextID),
        channelId_(_channelId),
        contentWindowId_(_contentWindowId),
        topLevelOuterContentWindowId_(_topLevelOuterContentWindowId),
        loadFlags_(_loadFlags),
        classOfService_(_classOfService),
        thirdPartyFlags_(_thirdPartyFlags),
        tlsFlags_(_tlsFlags),
        cacheKey_(_cacheKey),
        initialRwin_(_initialRwin),
        corsMode_(_corsMode),
        redirectMode_(_redirectMode),
        priority_(_priority),
        redirectionLimit_(_redirectionLimit)
    {
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    bool
    operator!=(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    mozilla::Maybe<URIParams>&
    original()
    {
        return original_;
    }
    const mozilla::Maybe<URIParams>&
    original() const
    {
        return original_;
    }

    mozilla::Maybe<URIParams>&
    doc()
    {
        return doc_;
    }
    const mozilla::Maybe<URIParams>&
    doc() const
    {
        return doc_;
    }

    RefPtr<nsIReferrerInfo>&
    referrerInfo()
    {
        return referrerInfo_;
    }
    nsIReferrerInfo*
    referrerInfo() const
    {
        return referrerInfo_;
    }

    mozilla::Maybe<URIParams>&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const mozilla::Maybe<URIParams>&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    mozilla::Maybe<URIParams>&
    topWindowURI()
    {
        return topWindowURI_;
    }
    const mozilla::Maybe<URIParams>&
    topWindowURI() const
    {
        return topWindowURI_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    mozilla::Maybe<IPCStream>&
    uploadStream()
    {
        return uploadStream_;
    }
    const mozilla::Maybe<IPCStream>&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    int16_t&
    priority()
    {
        return priority_;
    }
    const int16_t&
    priority() const
    {
        return priority_;
    }

    uint32_t&
    classOfService()
    {
        return classOfService_;
    }
    const uint32_t&
    classOfService() const
    {
        return classOfService_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    uint32_t&
    thirdPartyFlags()
    {
        return thirdPartyFlags_;
    }
    const uint32_t&
    thirdPartyFlags() const
    {
        return thirdPartyFlags_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    bool&
    allowAltSvc()
    {
        return allowAltSvc_;
    }
    const bool&
    allowAltSvc() const
    {
        return allowAltSvc_;
    }

    bool&
    beConservative()
    {
        return beConservative_;
    }
    const bool&
    beConservative() const
    {
        return beConservative_;
    }

    uint32_t&
    tlsFlags()
    {
        return tlsFlags_;
    }
    const uint32_t&
    tlsFlags() const
    {
        return tlsFlags_;
    }

    mozilla::Maybe<LoadInfoArgs>&
    loadInfo()
    {
        return loadInfo_;
    }
    const mozilla::Maybe<LoadInfoArgs>&
    loadInfo() const
    {
        return loadInfo_;
    }

    mozilla::Maybe<nsHttpResponseHead>&
    synthesizedResponseHead()
    {
        return synthesizedResponseHead_;
    }
    const mozilla::Maybe<nsHttpResponseHead>&
    synthesizedResponseHead() const
    {
        return synthesizedResponseHead_;
    }

    nsCString&
    synthesizedSecurityInfoSerialization()
    {
        return synthesizedSecurityInfoSerialization_;
    }
    const nsCString&
    synthesizedSecurityInfoSerialization() const
    {
        return synthesizedSecurityInfoSerialization_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    uint64_t&
    requestContextID()
    {
        return requestContextID_;
    }
    const uint64_t&
    requestContextID() const
    {
        return requestContextID_;
    }

    mozilla::Maybe<CorsPreflightArgs>&
    preflightArgs()
    {
        return preflightArgs_;
    }
    const mozilla::Maybe<CorsPreflightArgs>&
    preflightArgs() const
    {
        return preflightArgs_;
    }

    uint32_t&
    initialRwin()
    {
        return initialRwin_;
    }
    const uint32_t&
    initialRwin() const
    {
        return initialRwin_;
    }

    bool&
    blockAuthPrompt()
    {
        return blockAuthPrompt_;
    }
    const bool&
    blockAuthPrompt() const
    {
        return blockAuthPrompt_;
    }

    bool&
    suspendAfterSynthesizeResponse()
    {
        return suspendAfterSynthesizeResponse_;
    }
    const bool&
    suspendAfterSynthesizeResponse() const
    {
        return suspendAfterSynthesizeResponse_;
    }

    bool&
    allowStaleCacheContent()
    {
        return allowStaleCacheContent_;
    }
    const bool&
    allowStaleCacheContent() const
    {
        return allowStaleCacheContent_;
    }

    bool&
    preferCacheLoadOverBypass()
    {
        return preferCacheLoadOverBypass_;
    }
    const bool&
    preferCacheLoadOverBypass() const
    {
        return preferCacheLoadOverBypass_;
    }

    nsCString&
    contentTypeHint()
    {
        return contentTypeHint_;
    }
    const nsCString&
    contentTypeHint() const
    {
        return contentTypeHint_;
    }

    uint32_t&
    corsMode()
    {
        return corsMode_;
    }
    const uint32_t&
    corsMode() const
    {
        return corsMode_;
    }

    uint32_t&
    redirectMode()
    {
        return redirectMode_;
    }
    const uint32_t&
    redirectMode() const
    {
        return redirectMode_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    nsString&
    integrityMetadata()
    {
        return integrityMetadata_;
    }
    const nsString&
    integrityMetadata() const
    {
        return integrityMetadata_;
    }

    uint64_t&
    contentWindowId()
    {
        return contentWindowId_;
    }
    const uint64_t&
    contentWindowId() const
    {
        return contentWindowId_;
    }

    nsTArray<PreferredAlternativeDataTypeParams>&
    preferredAlternativeTypes()
    {
        return preferredAlternativeTypes_;
    }
    const nsTArray<PreferredAlternativeDataTypeParams>&
    preferredAlternativeTypes() const
    {
        return preferredAlternativeTypes_;
    }

    uint64_t&
    topLevelOuterContentWindowId()
    {
        return topLevelOuterContentWindowId_;
    }
    const uint64_t&
    topLevelOuterContentWindowId() const
    {
        return topLevelOuterContentWindowId_;
    }

    TimeStamp&
    launchServiceWorkerStart()
    {
        return launchServiceWorkerStart_;
    }
    const TimeStamp&
    launchServiceWorkerStart() const
    {
        return launchServiceWorkerStart_;
    }

    TimeStamp&
    launchServiceWorkerEnd()
    {
        return launchServiceWorkerEnd_;
    }
    const TimeStamp&
    launchServiceWorkerEnd() const
    {
        return launchServiceWorkerEnd_;
    }

    TimeStamp&
    dispatchFetchEventStart()
    {
        return dispatchFetchEventStart_;
    }
    const TimeStamp&
    dispatchFetchEventStart() const
    {
        return dispatchFetchEventStart_;
    }

    TimeStamp&
    dispatchFetchEventEnd()
    {
        return dispatchFetchEventEnd_;
    }
    const TimeStamp&
    dispatchFetchEventEnd() const
    {
        return dispatchFetchEventEnd_;
    }

    TimeStamp&
    handleFetchEventStart()
    {
        return handleFetchEventStart_;
    }
    const TimeStamp&
    handleFetchEventStart() const
    {
        return handleFetchEventStart_;
    }

    TimeStamp&
    handleFetchEventEnd()
    {
        return handleFetchEventEnd_;
    }
    const TimeStamp&
    handleFetchEventEnd() const
    {
        return handleFetchEventEnd_;
    }

    bool&
    forceMainDocumentChannel()
    {
        return forceMainDocumentChannel_;
    }
    const bool&
    forceMainDocumentChannel() const
    {
        return forceMainDocumentChannel_;
    }

    TimeStamp&
    navigationStartTimeStamp()
    {
        return navigationStartTimeStamp_;
    }
    const TimeStamp&
    navigationStartTimeStamp() const
    {
        return navigationStartTimeStamp_;
    }

    bool&
    hasNonEmptySandboxingFlag()
    {
        return hasNonEmptySandboxingFlag_;
    }
    const bool&
    hasNonEmptySandboxingFlag() const
    {
        return hasNonEmptySandboxingFlag_;
    }

private:
    void
    StaticAssertions() const;
    URIParams uri_;
    mozilla::Maybe<URIParams> original_;
    mozilla::Maybe<URIParams> doc_;
    RefPtr<nsIReferrerInfo> referrerInfo_;
    mozilla::Maybe<URIParams> apiRedirectTo_;
    mozilla::Maybe<URIParams> topWindowURI_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    mozilla::Maybe<IPCStream> uploadStream_;
    bool uploadStreamHasHeaders_;
    bool allowSTS_;
    bool resumeAt_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    bool allowAltSvc_;
    bool beConservative_;
    mozilla::Maybe<LoadInfoArgs> loadInfo_;
    mozilla::Maybe<nsHttpResponseHead> synthesizedResponseHead_;
    nsCString synthesizedSecurityInfoSerialization_;
    mozilla::Maybe<CorsPreflightArgs> preflightArgs_;
    bool blockAuthPrompt_;
    bool suspendAfterSynthesizeResponse_;
    bool allowStaleCacheContent_;
    bool preferCacheLoadOverBypass_;
    nsCString contentTypeHint_;
    nsString integrityMetadata_;
    CopyableTArray<PreferredAlternativeDataTypeParams> preferredAlternativeTypes_;
    TimeStamp launchServiceWorkerStart_;
    TimeStamp launchServiceWorkerEnd_;
    TimeStamp dispatchFetchEventStart_;
    TimeStamp dispatchFetchEventEnd_;
    TimeStamp handleFetchEventStart_;
    TimeStamp handleFetchEventEnd_;
    bool forceMainDocumentChannel_;
    TimeStamp navigationStartTimeStamp_;
    bool hasNonEmptySandboxingFlag_;
    uint64_t startPos_;
    uint64_t requestContextID_;
    uint64_t channelId_;
    uint64_t contentWindowId_;
    uint64_t topLevelOuterContentWindowId_;
    uint32_t loadFlags_;
    uint32_t classOfService_;
    uint32_t thirdPartyFlags_;
    uint32_t tlsFlags_;
    uint32_t cacheKey_;
    uint32_t initialRwin_;
    uint32_t corsMode_;
    uint32_t redirectMode_;
    int16_t priority_;
    uint8_t redirectionLimit_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelOpenArgs>
{
    typedef mozilla::net::HttpChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs() :
        shouldIntercept_(),
        registrarId_()
    {
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(
            const uint32_t& _registrarId,
            const bool& _shouldIntercept) :
        shouldIntercept_(_shouldIntercept),
        registrarId_(_registrarId)
    {
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    bool
    operator!=(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    registrarId()
    {
        return registrarId_;
    }
    const uint32_t&
    registrarId() const
    {
        return registrarId_;
    }

    bool&
    shouldIntercept()
    {
        return shouldIntercept_;
    }
    const bool&
    shouldIntercept() const
    {
        return shouldIntercept_;
    }

private:
    bool shouldIntercept_;
    uint32_t registrarId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelConnectArgs>
{
    typedef mozilla::net::HttpChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelOpenArgs> VHttpChannelOpenArgs;
        mozilla::AlignedStorage2<HttpChannelConnectArgs> VHttpChannelConnectArgs;
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    const HttpChannelOpenArgs*
    constptr_HttpChannelOpenArgs() const
    {
        return ((mValue).VHttpChannelOpenArgs).addr();
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }
    const HttpChannelConnectArgs*
    constptr_HttpChannelConnectArgs() const
    {
        return ((mValue).VHttpChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelOpenArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelConnectArgs&& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(HttpChannelCreationArgs&& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelOpenArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelConnectArgs&& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(HttpChannelCreationArgs&& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelCreationArgs>
{
    typedef mozilla::net::HttpChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ProxyInfoCloneArgs|
//
namespace mozilla {
namespace net {
class ProxyInfoCloneArgs final
{
private:

public:
    MOZ_IMPLICIT ProxyInfoCloneArgs() :
        type_(),
        host_(),
        username_(),
        password_(),
        proxyAuthorizationHeader_(),
        connectionIsolationKey_(),
        port_(),
        flags_(),
        timeout_(),
        resolveFlags_()
    {
    }

    MOZ_IMPLICIT ProxyInfoCloneArgs(
            const nsCString& _type,
            const nsCString& _host,
            const int32_t& _port,
            const nsCString& _username,
            const nsCString& _password,
            const uint32_t& _flags,
            const uint32_t& _timeout,
            const uint32_t& _resolveFlags,
            const nsCString& _proxyAuthorizationHeader,
            const nsCString& _connectionIsolationKey) :
        type_(_type),
        host_(_host),
        username_(_username),
        password_(_password),
        proxyAuthorizationHeader_(_proxyAuthorizationHeader),
        connectionIsolationKey_(_connectionIsolationKey),
        port_(_port),
        flags_(_flags),
        timeout_(_timeout),
        resolveFlags_(_resolveFlags)
    {
    }

    bool
    operator==(const ProxyInfoCloneArgs& _o) const;

    bool
    operator!=(const ProxyInfoCloneArgs& _o) const;

    nsCString&
    type()
    {
        return type_;
    }
    const nsCString&
    type() const
    {
        return type_;
    }

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    int32_t&
    port()
    {
        return port_;
    }
    const int32_t&
    port() const
    {
        return port_;
    }

    nsCString&
    username()
    {
        return username_;
    }
    const nsCString&
    username() const
    {
        return username_;
    }

    nsCString&
    password()
    {
        return password_;
    }
    const nsCString&
    password() const
    {
        return password_;
    }

    uint32_t&
    flags()
    {
        return flags_;
    }
    const uint32_t&
    flags() const
    {
        return flags_;
    }

    uint32_t&
    timeout()
    {
        return timeout_;
    }
    const uint32_t&
    timeout() const
    {
        return timeout_;
    }

    uint32_t&
    resolveFlags()
    {
        return resolveFlags_;
    }
    const uint32_t&
    resolveFlags() const
    {
        return resolveFlags_;
    }

    nsCString&
    proxyAuthorizationHeader()
    {
        return proxyAuthorizationHeader_;
    }
    const nsCString&
    proxyAuthorizationHeader() const
    {
        return proxyAuthorizationHeader_;
    }

    nsCString&
    connectionIsolationKey()
    {
        return connectionIsolationKey_;
    }
    const nsCString&
    connectionIsolationKey() const
    {
        return connectionIsolationKey_;
    }

private:
    void
    StaticAssertions() const;
    nsCString type_;
    nsCString host_;
    nsCString username_;
    nsCString password_;
    nsCString proxyAuthorizationHeader_;
    nsCString connectionIsolationKey_;
    int32_t port_;
    uint32_t flags_;
    uint32_t timeout_;
    uint32_t resolveFlags_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ProxyInfoCloneArgs>
{
    typedef mozilla::net::ProxyInfoCloneArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpConnectionInfoCloneArgs|
//
namespace mozilla {
namespace net {
class HttpConnectionInfoCloneArgs final
{
private:
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::net::ProxyInfoCloneArgs ProxyInfoCloneArgs;

public:
    MOZ_IMPLICIT HttpConnectionInfoCloneArgs() :
        host_(),
        npnToken_(),
        username_(),
        originAttributes_(),
        endToEndSSL_(),
        routedHost_(),
        anonymous_(),
        aPrivate_(),
        insecureScheme_(),
        noSpdy_(),
        beConservative_(),
        isolated_(),
        isTrrServiceChannel_(),
        isIPv4Disabled_(),
        isIPv6Disabled_(),
        topWindowOrigin_(),
        isHttp3_(),
        proxyInfo_(),
        port_(),
        routedPort_(),
        tlsFlags_(),
        trrMode_()
    {
    }

    MOZ_IMPLICIT HttpConnectionInfoCloneArgs(
            const nsCString& _host,
            const int32_t& _port,
            const nsCString& _npnToken,
            const nsCString& _username,
            const OriginAttributes& _originAttributes,
            const bool& _endToEndSSL,
            const nsCString& _routedHost,
            const int32_t& _routedPort,
            const bool& _anonymous,
            const bool& _aPrivate,
            const bool& _insecureScheme,
            const bool& _noSpdy,
            const bool& _beConservative,
            const uint32_t& _tlsFlags,
            const bool& _isolated,
            const bool& _isTrrServiceChannel,
            const uint8_t& _trrMode,
            const bool& _isIPv4Disabled,
            const bool& _isIPv6Disabled,
            const nsCString& _topWindowOrigin,
            const bool& _isHttp3,
            const nsTArray<ProxyInfoCloneArgs>& _proxyInfo) :
        host_(_host),
        npnToken_(_npnToken),
        username_(_username),
        originAttributes_(_originAttributes),
        endToEndSSL_(_endToEndSSL),
        routedHost_(_routedHost),
        anonymous_(_anonymous),
        aPrivate_(_aPrivate),
        insecureScheme_(_insecureScheme),
        noSpdy_(_noSpdy),
        beConservative_(_beConservative),
        isolated_(_isolated),
        isTrrServiceChannel_(_isTrrServiceChannel),
        isIPv4Disabled_(_isIPv4Disabled),
        isIPv6Disabled_(_isIPv6Disabled),
        topWindowOrigin_(_topWindowOrigin),
        isHttp3_(_isHttp3),
        proxyInfo_(_proxyInfo),
        port_(_port),
        routedPort_(_routedPort),
        tlsFlags_(_tlsFlags),
        trrMode_(_trrMode)
    {
    }

    bool
    operator==(const HttpConnectionInfoCloneArgs& _o) const;

    bool
    operator!=(const HttpConnectionInfoCloneArgs& _o) const;

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    int32_t&
    port()
    {
        return port_;
    }
    const int32_t&
    port() const
    {
        return port_;
    }

    nsCString&
    npnToken()
    {
        return npnToken_;
    }
    const nsCString&
    npnToken() const
    {
        return npnToken_;
    }

    nsCString&
    username()
    {
        return username_;
    }
    const nsCString&
    username() const
    {
        return username_;
    }

    OriginAttributes&
    originAttributes()
    {
        return originAttributes_;
    }
    const OriginAttributes&
    originAttributes() const
    {
        return originAttributes_;
    }

    bool&
    endToEndSSL()
    {
        return endToEndSSL_;
    }
    const bool&
    endToEndSSL() const
    {
        return endToEndSSL_;
    }

    nsCString&
    routedHost()
    {
        return routedHost_;
    }
    const nsCString&
    routedHost() const
    {
        return routedHost_;
    }

    int32_t&
    routedPort()
    {
        return routedPort_;
    }
    const int32_t&
    routedPort() const
    {
        return routedPort_;
    }

    bool&
    anonymous()
    {
        return anonymous_;
    }
    const bool&
    anonymous() const
    {
        return anonymous_;
    }

    bool&
    aPrivate()
    {
        return aPrivate_;
    }
    const bool&
    aPrivate() const
    {
        return aPrivate_;
    }

    bool&
    insecureScheme()
    {
        return insecureScheme_;
    }
    const bool&
    insecureScheme() const
    {
        return insecureScheme_;
    }

    bool&
    noSpdy()
    {
        return noSpdy_;
    }
    const bool&
    noSpdy() const
    {
        return noSpdy_;
    }

    bool&
    beConservative()
    {
        return beConservative_;
    }
    const bool&
    beConservative() const
    {
        return beConservative_;
    }

    uint32_t&
    tlsFlags()
    {
        return tlsFlags_;
    }
    const uint32_t&
    tlsFlags() const
    {
        return tlsFlags_;
    }

    bool&
    isolated()
    {
        return isolated_;
    }
    const bool&
    isolated() const
    {
        return isolated_;
    }

    bool&
    isTrrServiceChannel()
    {
        return isTrrServiceChannel_;
    }
    const bool&
    isTrrServiceChannel() const
    {
        return isTrrServiceChannel_;
    }

    uint8_t&
    trrMode()
    {
        return trrMode_;
    }
    const uint8_t&
    trrMode() const
    {
        return trrMode_;
    }

    bool&
    isIPv4Disabled()
    {
        return isIPv4Disabled_;
    }
    const bool&
    isIPv4Disabled() const
    {
        return isIPv4Disabled_;
    }

    bool&
    isIPv6Disabled()
    {
        return isIPv6Disabled_;
    }
    const bool&
    isIPv6Disabled() const
    {
        return isIPv6Disabled_;
    }

    nsCString&
    topWindowOrigin()
    {
        return topWindowOrigin_;
    }
    const nsCString&
    topWindowOrigin() const
    {
        return topWindowOrigin_;
    }

    bool&
    isHttp3()
    {
        return isHttp3_;
    }
    const bool&
    isHttp3() const
    {
        return isHttp3_;
    }

    nsTArray<ProxyInfoCloneArgs>&
    proxyInfo()
    {
        return proxyInfo_;
    }
    const nsTArray<ProxyInfoCloneArgs>&
    proxyInfo() const
    {
        return proxyInfo_;
    }

private:
    void
    StaticAssertions() const;
    nsCString host_;
    nsCString npnToken_;
    nsCString username_;
    OriginAttributes originAttributes_;
    bool endToEndSSL_;
    nsCString routedHost_;
    bool anonymous_;
    bool aPrivate_;
    bool insecureScheme_;
    bool noSpdy_;
    bool beConservative_;
    bool isolated_;
    bool isTrrServiceChannel_;
    bool isIPv4Disabled_;
    bool isIPv6Disabled_;
    nsCString topWindowOrigin_;
    bool isHttp3_;
    CopyableTArray<ProxyInfoCloneArgs> proxyInfo_;
    int32_t port_;
    int32_t routedPort_;
    uint32_t tlsFlags_;
    uint8_t trrMode_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpConnectionInfoCloneArgs>
{
    typedef mozilla::net::HttpConnectionInfoCloneArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ConsoleReportCollected|
//
namespace mozilla {
namespace net {
class ConsoleReportCollected final
{
private:

public:
    MOZ_IMPLICIT ConsoleReportCollected() :
        category_(),
        sourceFileURI_(),
        messageName_(),
        stringParams_(),
        errorFlags_(),
        propertiesFile_(),
        lineNumber_(),
        columnNumber_()
    {
    }

    MOZ_IMPLICIT ConsoleReportCollected(
            const uint32_t& _errorFlags,
            const nsCString& _category,
            const uint32_t& _propertiesFile,
            const nsCString& _sourceFileURI,
            const uint32_t& _lineNumber,
            const uint32_t& _columnNumber,
            const nsCString& _messageName,
            const nsTArray<nsString>& _stringParams) :
        category_(_category),
        sourceFileURI_(_sourceFileURI),
        messageName_(_messageName),
        stringParams_(_stringParams),
        errorFlags_(_errorFlags),
        propertiesFile_(_propertiesFile),
        lineNumber_(_lineNumber),
        columnNumber_(_columnNumber)
    {
    }

    bool
    operator==(const ConsoleReportCollected& _o) const;

    bool
    operator!=(const ConsoleReportCollected& _o) const;

    uint32_t&
    errorFlags()
    {
        return errorFlags_;
    }
    const uint32_t&
    errorFlags() const
    {
        return errorFlags_;
    }

    nsCString&
    category()
    {
        return category_;
    }
    const nsCString&
    category() const
    {
        return category_;
    }

    uint32_t&
    propertiesFile()
    {
        return propertiesFile_;
    }
    const uint32_t&
    propertiesFile() const
    {
        return propertiesFile_;
    }

    nsCString&
    sourceFileURI()
    {
        return sourceFileURI_;
    }
    const nsCString&
    sourceFileURI() const
    {
        return sourceFileURI_;
    }

    uint32_t&
    lineNumber()
    {
        return lineNumber_;
    }
    const uint32_t&
    lineNumber() const
    {
        return lineNumber_;
    }

    uint32_t&
    columnNumber()
    {
        return columnNumber_;
    }
    const uint32_t&
    columnNumber() const
    {
        return columnNumber_;
    }

    nsCString&
    messageName()
    {
        return messageName_;
    }
    const nsCString&
    messageName() const
    {
        return messageName_;
    }

    nsTArray<nsString>&
    stringParams()
    {
        return stringParams_;
    }
    const nsTArray<nsString>&
    stringParams() const
    {
        return stringParams_;
    }

private:
    void
    StaticAssertions() const;
    nsCString category_;
    nsCString sourceFileURI_;
    nsCString messageName_;
    CopyableTArray<nsString> stringParams_;
    uint32_t errorFlags_;
    uint32_t propertiesFile_;
    uint32_t lineNumber_;
    uint32_t columnNumber_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ConsoleReportCollected>
{
    typedef mozilla::net::ConsoleReportCollected paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs final
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs() :
        uri_(),
        entityID_(),
        uploadStream_(),
        loadInfo_(),
        startPos_(),
        loadFlags_()
    {
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const mozilla::Maybe<IPCStream>& _uploadStream,
            const mozilla::Maybe<LoadInfoArgs>& _loadInfo,
            const uint32_t& _loadFlags) :
        uri_(_uri),
        entityID_(_entityID),
        uploadStream_(_uploadStream),
        loadInfo_(_loadInfo),
        startPos_(_startPos),
        loadFlags_(_loadFlags)
    {
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    bool
    operator!=(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    mozilla::Maybe<IPCStream>&
    uploadStream()
    {
        return uploadStream_;
    }
    const mozilla::Maybe<IPCStream>&
    uploadStream() const
    {
        return uploadStream_;
    }

    mozilla::Maybe<LoadInfoArgs>&
    loadInfo()
    {
        return loadInfo_;
    }
    const mozilla::Maybe<LoadInfoArgs>&
    loadInfo() const
    {
        return loadInfo_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

private:
    URIParams uri_;
    nsCString entityID_;
    mozilla::Maybe<IPCStream> uploadStream_;
    mozilla::Maybe<LoadInfoArgs> loadInfo_;
    uint64_t startPos_;
    uint32_t loadFlags_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelOpenArgs>
{
    typedef mozilla::net::FTPChannelOpenArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs final
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs() :
        channelId_()
    {
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId) :
        channelId_(_channelId)
    {
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    bool
    operator!=(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelConnectArgs>
{
    typedef mozilla::net::FTPChannelConnectArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs final
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        mozilla::AlignedStorage2<FTPChannelOpenArgs> VFTPChannelOpenArgs;
        mozilla::AlignedStorage2<FTPChannelConnectArgs> VFTPChannelConnectArgs;
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    const FTPChannelOpenArgs*
    constptr_FTPChannelOpenArgs() const
    {
        return ((mValue).VFTPChannelOpenArgs).addr();
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }
    const FTPChannelConnectArgs*
    constptr_FTPChannelConnectArgs() const
    {
        return ((mValue).VFTPChannelConnectArgs).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelOpenArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelConnectArgs&& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(FTPChannelCreationArgs&& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelOpenArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelConnectArgs&& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(FTPChannelCreationArgs&& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::FTPChannelCreationArgs>
{
    typedef mozilla::net::FTPChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class HttpChannelDiverterArgs final
{
private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;

public:
    MOZ_IMPLICIT HttpChannelDiverterArgs() :
        mChannelParent_(),
        mChannelChild_(),
        mApplyConversion_()
    {
    }

    MOZ_IMPLICIT HttpChannelDiverterArgs(
            PHttpChannelParent* _mChannelParent,
            PHttpChannelChild* _mChannelChild,
            const bool& _mApplyConversion) :
        mChannelParent_(_mChannelParent),
        mChannelChild_(_mChannelChild),
        mApplyConversion_(_mApplyConversion)
    {
    }

    bool
    operator==(const HttpChannelDiverterArgs& _o) const;

    bool
    operator!=(const HttpChannelDiverterArgs& _o) const;

    PHttpChannelParent*&
    mChannelParent()
    {
        return mChannelParent_;
    }
    PHttpChannelParent*
    mChannelParent() const
    {
        return mChannelParent_;
    }

    PHttpChannelChild*&
    mChannelChild()
    {
        return mChannelChild_;
    }
    PHttpChannelChild*
    mChannelChild() const
    {
        return mChannelChild_;
    }

    bool&
    mApplyConversion()
    {
        return mApplyConversion_;
    }
    const bool&
    mApplyConversion() const
    {
        return mApplyConversion_;
    }

private:
    PHttpChannelParent* mChannelParent_;
    PHttpChannelChild* mChannelChild_;
    bool mApplyConversion_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpChannelDiverterArgs>
{
    typedef mozilla::net::HttpChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs final
{
public:
    enum Type {
        T__None,
        THttpChannelDiverterArgs = 1,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef HttpChannelDiverterArgs HttpChannelDiverterArgs__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        mozilla::AlignedStorage2<HttpChannelDiverterArgs> VHttpChannelDiverterArgs;
        mozilla::AlignedStorage2<PFTPChannelParent*> VPFTPChannelParent;
        mozilla::AlignedStorage2<PFTPChannelChild*> VPFTPChannelChild;
    };

    HttpChannelDiverterArgs*
    ptr_HttpChannelDiverterArgs()
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    const HttpChannelDiverterArgs*
    constptr_HttpChannelDiverterArgs() const
    {
        return ((mValue).VHttpChannelDiverterArgs).addr();
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return ((mValue).VPFTPChannelParent).addr();
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return ((mValue).VPFTPChannelChild).addr();
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return ((mValue).VPFTPChannelChild).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(const HttpChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(HttpChannelDiverterArgs&& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(ChannelDiverterArgs&& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(const HttpChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(HttpChannelDiverterArgs&& aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    ChannelDiverterArgs&
    operator=(ChannelDiverterArgs&& aRhs);

    bool
    operator==(const HttpChannelDiverterArgs& aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs()
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(ptr_HttpChannelDiverterArgs()));
    }
    const HttpChannelDiverterArgs&
    get_HttpChannelDiverterArgs() const
    {
        AssertSanity(THttpChannelDiverterArgs);
        return (*(constptr_HttpChannelDiverterArgs()));
    }
    operator HttpChannelDiverterArgs&()
    {
        return get_HttpChannelDiverterArgs();
    }
    operator const HttpChannelDiverterArgs&() const
    {
        return get_HttpChannelDiverterArgs();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ChannelDiverterArgs>
{
    typedef mozilla::net::ChannelDiverterArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CookieStruct|
//
namespace mozilla {
namespace net {
class CookieStruct final
{
private:

public:
    MOZ_IMPLICIT CookieStruct() :
        name_(),
        value_(),
        host_(),
        path_(),
        isHttpOnly_(),
        isSession_(),
        isSecure_(),
        expiry_(),
        lastAccessed_(),
        creationTime_(),
        sameSite_(),
        rawSameSite_()
    {
    }

    MOZ_IMPLICIT CookieStruct(
            const nsCString& _name,
            const nsCString& _value,
            const nsCString& _host,
            const nsCString& _path,
            const int64_t& _expiry,
            const int64_t& _lastAccessed,
            const int64_t& _creationTime,
            const bool& _isHttpOnly,
            const bool& _isSession,
            const bool& _isSecure,
            const int32_t& _sameSite,
            const int32_t& _rawSameSite) :
        name_(_name),
        value_(_value),
        host_(_host),
        path_(_path),
        isHttpOnly_(_isHttpOnly),
        isSession_(_isSession),
        isSecure_(_isSecure),
        expiry_(_expiry),
        lastAccessed_(_lastAccessed),
        creationTime_(_creationTime),
        sameSite_(_sameSite),
        rawSameSite_(_rawSameSite)
    {
    }

    bool
    operator==(const CookieStruct& _o) const;

    bool
    operator!=(const CookieStruct& _o) const;

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    nsCString&
    path()
    {
        return path_;
    }
    const nsCString&
    path() const
    {
        return path_;
    }

    int64_t&
    expiry()
    {
        return expiry_;
    }
    const int64_t&
    expiry() const
    {
        return expiry_;
    }

    int64_t&
    lastAccessed()
    {
        return lastAccessed_;
    }
    const int64_t&
    lastAccessed() const
    {
        return lastAccessed_;
    }

    int64_t&
    creationTime()
    {
        return creationTime_;
    }
    const int64_t&
    creationTime() const
    {
        return creationTime_;
    }

    bool&
    isHttpOnly()
    {
        return isHttpOnly_;
    }
    const bool&
    isHttpOnly() const
    {
        return isHttpOnly_;
    }

    bool&
    isSession()
    {
        return isSession_;
    }
    const bool&
    isSession() const
    {
        return isSession_;
    }

    bool&
    isSecure()
    {
        return isSecure_;
    }
    const bool&
    isSecure() const
    {
        return isSecure_;
    }

    int32_t&
    sameSite()
    {
        return sameSite_;
    }
    const int32_t&
    sameSite() const
    {
        return sameSite_;
    }

    int32_t&
    rawSameSite()
    {
        return rawSameSite_;
    }
    const int32_t&
    rawSameSite() const
    {
        return rawSameSite_;
    }

private:
    void
    StaticAssertions() const;
    nsCString name_;
    nsCString value_;
    nsCString host_;
    nsCString path_;
    bool isHttpOnly_;
    bool isSession_;
    bool isSecure_;
    int64_t expiry_;
    int64_t lastAccessed_;
    int64_t creationTime_;
    int32_t sameSite_;
    int32_t rawSameSite_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::CookieStruct>
{
    typedef mozilla::net::CookieStruct paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DocumentChannelCreationArgs|
//
namespace mozilla {
namespace net {
class DocumentChannelCreationArgs final
{
private:
    typedef mozilla::dom::DocShellLoadStateInit DocShellLoadStateInit;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::dom::IPCClientInfo IPCClientInfo;

public:
    MOZ_IMPLICIT DocumentChannelCreationArgs() :
        loadState_(),
        asyncOpenTime_(),
        pluginsAllowed_(),
        timing_(),
        initialClientInfo_(),
        hasValidTransientUserAction_(),
        uriModified_(),
        isXFOError_(),
        channelId_(),
        outerWindowId_(),
        cacheKey_()
    {
    }

    MOZ_IMPLICIT DocumentChannelCreationArgs(
            const DocShellLoadStateInit& _loadState,
            const TimeStamp& _asyncOpenTime,
            const uint64_t& _channelId,
            const uint32_t& _cacheKey,
            const bool& _pluginsAllowed,
            const mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>& _timing,
            const mozilla::Maybe<IPCClientInfo>& _initialClientInfo,
            const uint64_t& _outerWindowId,
            const bool& _hasValidTransientUserAction,
            const bool& _uriModified,
            const bool& _isXFOError) :
        loadState_(_loadState),
        asyncOpenTime_(_asyncOpenTime),
        pluginsAllowed_(_pluginsAllowed),
        timing_(_timing),
        initialClientInfo_(_initialClientInfo),
        hasValidTransientUserAction_(_hasValidTransientUserAction),
        uriModified_(_uriModified),
        isXFOError_(_isXFOError),
        channelId_(_channelId),
        outerWindowId_(_outerWindowId),
        cacheKey_(_cacheKey)
    {
    }

    bool
    operator==(const DocumentChannelCreationArgs& _o) const;

    bool
    operator!=(const DocumentChannelCreationArgs& _o) const;

    DocShellLoadStateInit&
    loadState()
    {
        return loadState_;
    }
    const DocShellLoadStateInit&
    loadState() const
    {
        return loadState_;
    }

    TimeStamp&
    asyncOpenTime()
    {
        return asyncOpenTime_;
    }
    const TimeStamp&
    asyncOpenTime() const
    {
        return asyncOpenTime_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    uint32_t&
    cacheKey()
    {
        return cacheKey_;
    }
    const uint32_t&
    cacheKey() const
    {
        return cacheKey_;
    }

    bool&
    pluginsAllowed()
    {
        return pluginsAllowed_;
    }
    const bool&
    pluginsAllowed() const
    {
        return pluginsAllowed_;
    }

    mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>&
    timing()
    {
        return timing_;
    }
    const mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>&
    timing() const
    {
        return timing_;
    }

    mozilla::Maybe<IPCClientInfo>&
    initialClientInfo()
    {
        return initialClientInfo_;
    }
    const mozilla::Maybe<IPCClientInfo>&
    initialClientInfo() const
    {
        return initialClientInfo_;
    }

    uint64_t&
    outerWindowId()
    {
        return outerWindowId_;
    }
    const uint64_t&
    outerWindowId() const
    {
        return outerWindowId_;
    }

    bool&
    hasValidTransientUserAction()
    {
        return hasValidTransientUserAction_;
    }
    const bool&
    hasValidTransientUserAction() const
    {
        return hasValidTransientUserAction_;
    }

    bool&
    uriModified()
    {
        return uriModified_;
    }
    const bool&
    uriModified() const
    {
        return uriModified_;
    }

    bool&
    isXFOError()
    {
        return isXFOError_;
    }
    const bool&
    isXFOError() const
    {
        return isXFOError_;
    }

private:
    void
    StaticAssertions() const;
    DocShellLoadStateInit loadState_;
    TimeStamp asyncOpenTime_;
    bool pluginsAllowed_;
    mozilla::Maybe<RefPtr<nsDOMNavigationTiming>> timing_;
    mozilla::Maybe<IPCClientInfo> initialClientInfo_;
    bool hasValidTransientUserAction_;
    bool uriModified_;
    bool isXFOError_;
    uint64_t channelId_;
    uint64_t outerWindowId_;
    uint32_t cacheKey_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::DocumentChannelCreationArgs>
{
    typedef mozilla::net::DocumentChannelCreationArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RedirectToRealChannelArgs|
//
namespace mozilla {
namespace net {
class RedirectToRealChannelArgs final
{
private:
    typedef mozilla::dom::ReplacementChannelConfigInit ReplacementChannelConfigInit;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef mozilla::dom::SessionHistoryInfoAndId SessionHistoryInfoAndId;

public:
    MOZ_IMPLICIT RedirectToRealChannelArgs() :
        uri_(),
        init_(),
        loadInfo_(),
        originalURI_(),
        contentDisposition_(),
        contentDispositionFilename_(),
        properties_(),
        timing_(),
        srcdocData_(),
        baseUri_(),
        sessionHistoryInfo_(),
        channelId_(),
        redirectIdentifier_(),
        registrarId_(),
        newLoadFlags_(),
        redirectMode_(),
        redirectFlags_(),
        loadStateLoadFlags_(),
        loadStateLoadType_()
    {
    }

    MOZ_IMPLICIT RedirectToRealChannelArgs(
            const uint32_t& _registrarId,
            nsIURI* _uri,
            const uint32_t& _newLoadFlags,
            const mozilla::Maybe<ReplacementChannelConfigInit>& _init,
            const mozilla::Maybe<LoadInfoArgs>& _loadInfo,
            const uint64_t& _channelId,
            nsIURI* _originalURI,
            const uint32_t& _redirectMode,
            const uint32_t& _redirectFlags,
            const mozilla::Maybe<uint32_t>& _contentDisposition,
            const mozilla::Maybe<nsString>& _contentDispositionFilename,
            const uint64_t& _redirectIdentifier,
            nsIPropertyBag2* _properties,
            const uint32_t& _loadStateLoadFlags,
            const uint32_t& _loadStateLoadType,
            const mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>& _timing,
            const nsString& _srcdocData,
            nsIURI* _baseUri,
            mozilla::Maybe<SessionHistoryInfoAndId>&& _sessionHistoryInfo) :
        uri_(_uri),
        init_(_init),
        loadInfo_(_loadInfo),
        originalURI_(_originalURI),
        contentDisposition_(_contentDisposition),
        contentDispositionFilename_(_contentDispositionFilename),
        properties_(_properties),
        timing_(_timing),
        srcdocData_(_srcdocData),
        baseUri_(_baseUri),
        sessionHistoryInfo_(std::move(_sessionHistoryInfo)),
        channelId_(_channelId),
        redirectIdentifier_(_redirectIdentifier),
        registrarId_(_registrarId),
        newLoadFlags_(_newLoadFlags),
        redirectMode_(_redirectMode),
        redirectFlags_(_redirectFlags),
        loadStateLoadFlags_(_loadStateLoadFlags),
        loadStateLoadType_(_loadStateLoadType)
    {
    }

    bool
    operator==(const RedirectToRealChannelArgs& _o) const;

    bool
    operator!=(const RedirectToRealChannelArgs& _o) const;

    uint32_t&
    registrarId()
    {
        return registrarId_;
    }
    const uint32_t&
    registrarId() const
    {
        return registrarId_;
    }

    RefPtr<nsIURI>&
    uri()
    {
        return uri_;
    }
    nsIURI*
    uri() const
    {
        return uri_;
    }

    uint32_t&
    newLoadFlags()
    {
        return newLoadFlags_;
    }
    const uint32_t&
    newLoadFlags() const
    {
        return newLoadFlags_;
    }

    mozilla::Maybe<ReplacementChannelConfigInit>&
    init()
    {
        return init_;
    }
    const mozilla::Maybe<ReplacementChannelConfigInit>&
    init() const
    {
        return init_;
    }

    mozilla::Maybe<LoadInfoArgs>&
    loadInfo()
    {
        return loadInfo_;
    }
    const mozilla::Maybe<LoadInfoArgs>&
    loadInfo() const
    {
        return loadInfo_;
    }

    uint64_t&
    channelId()
    {
        return channelId_;
    }
    const uint64_t&
    channelId() const
    {
        return channelId_;
    }

    RefPtr<nsIURI>&
    originalURI()
    {
        return originalURI_;
    }
    nsIURI*
    originalURI() const
    {
        return originalURI_;
    }

    uint32_t&
    redirectMode()
    {
        return redirectMode_;
    }
    const uint32_t&
    redirectMode() const
    {
        return redirectMode_;
    }

    uint32_t&
    redirectFlags()
    {
        return redirectFlags_;
    }
    const uint32_t&
    redirectFlags() const
    {
        return redirectFlags_;
    }

    mozilla::Maybe<uint32_t>&
    contentDisposition()
    {
        return contentDisposition_;
    }
    const mozilla::Maybe<uint32_t>&
    contentDisposition() const
    {
        return contentDisposition_;
    }

    mozilla::Maybe<nsString>&
    contentDispositionFilename()
    {
        return contentDispositionFilename_;
    }
    const mozilla::Maybe<nsString>&
    contentDispositionFilename() const
    {
        return contentDispositionFilename_;
    }

    uint64_t&
    redirectIdentifier()
    {
        return redirectIdentifier_;
    }
    const uint64_t&
    redirectIdentifier() const
    {
        return redirectIdentifier_;
    }

    RefPtr<nsIPropertyBag2>&
    properties()
    {
        return properties_;
    }
    nsIPropertyBag2*
    properties() const
    {
        return properties_;
    }

    uint32_t&
    loadStateLoadFlags()
    {
        return loadStateLoadFlags_;
    }
    const uint32_t&
    loadStateLoadFlags() const
    {
        return loadStateLoadFlags_;
    }

    uint32_t&
    loadStateLoadType()
    {
        return loadStateLoadType_;
    }
    const uint32_t&
    loadStateLoadType() const
    {
        return loadStateLoadType_;
    }

    mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>&
    timing()
    {
        return timing_;
    }
    const mozilla::Maybe<RefPtr<nsDOMNavigationTiming>>&
    timing() const
    {
        return timing_;
    }

    nsString&
    srcdocData()
    {
        return srcdocData_;
    }
    const nsString&
    srcdocData() const
    {
        return srcdocData_;
    }

    RefPtr<nsIURI>&
    baseUri()
    {
        return baseUri_;
    }
    nsIURI*
    baseUri() const
    {
        return baseUri_;
    }

    mozilla::Maybe<SessionHistoryInfoAndId>&
    sessionHistoryInfo()
    {
        return sessionHistoryInfo_;
    }
    const mozilla::Maybe<SessionHistoryInfoAndId>&
    sessionHistoryInfo() const
    {
        return sessionHistoryInfo_;
    }

private:
    void
    StaticAssertions() const;
    RefPtr<nsIURI> uri_;
    mozilla::Maybe<ReplacementChannelConfigInit> init_;
    mozilla::Maybe<LoadInfoArgs> loadInfo_;
    RefPtr<nsIURI> originalURI_;
    mozilla::Maybe<uint32_t> contentDisposition_;
    mozilla::Maybe<nsString> contentDispositionFilename_;
    RefPtr<nsIPropertyBag2> properties_;
    mozilla::Maybe<RefPtr<nsDOMNavigationTiming>> timing_;
    nsString srcdocData_;
    RefPtr<nsIURI> baseUri_;
    mozilla::Maybe<SessionHistoryInfoAndId> sessionHistoryInfo_;
    uint64_t channelId_;
    uint64_t redirectIdentifier_;
    uint32_t registrarId_;
    uint32_t newLoadFlags_;
    uint32_t redirectMode_;
    uint32_t redirectFlags_;
    uint32_t loadStateLoadFlags_;
    uint32_t loadStateLoadType_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::RedirectToRealChannelArgs>
{
    typedef mozilla::net::RedirectToRealChannelArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TimingStructArgs|
//
namespace mozilla {
namespace net {
class TimingStructArgs final
{
private:
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT TimingStructArgs() :
        domainLookupStart_(),
        domainLookupEnd_(),
        connectStart_(),
        tcpConnectEnd_(),
        secureConnectionStart_(),
        connectEnd_(),
        requestStart_(),
        responseStart_(),
        responseEnd_()
    {
    }

    MOZ_IMPLICIT TimingStructArgs(
            const TimeStamp& _domainLookupStart,
            const TimeStamp& _domainLookupEnd,
            const TimeStamp& _connectStart,
            const TimeStamp& _tcpConnectEnd,
            const TimeStamp& _secureConnectionStart,
            const TimeStamp& _connectEnd,
            const TimeStamp& _requestStart,
            const TimeStamp& _responseStart,
            const TimeStamp& _responseEnd) :
        domainLookupStart_(_domainLookupStart),
        domainLookupEnd_(_domainLookupEnd),
        connectStart_(_connectStart),
        tcpConnectEnd_(_tcpConnectEnd),
        secureConnectionStart_(_secureConnectionStart),
        connectEnd_(_connectEnd),
        requestStart_(_requestStart),
        responseStart_(_responseStart),
        responseEnd_(_responseEnd)
    {
    }

    bool
    operator==(const TimingStructArgs& _o) const;

    bool
    operator!=(const TimingStructArgs& _o) const;

    TimeStamp&
    domainLookupStart()
    {
        return domainLookupStart_;
    }
    const TimeStamp&
    domainLookupStart() const
    {
        return domainLookupStart_;
    }

    TimeStamp&
    domainLookupEnd()
    {
        return domainLookupEnd_;
    }
    const TimeStamp&
    domainLookupEnd() const
    {
        return domainLookupEnd_;
    }

    TimeStamp&
    connectStart()
    {
        return connectStart_;
    }
    const TimeStamp&
    connectStart() const
    {
        return connectStart_;
    }

    TimeStamp&
    tcpConnectEnd()
    {
        return tcpConnectEnd_;
    }
    const TimeStamp&
    tcpConnectEnd() const
    {
        return tcpConnectEnd_;
    }

    TimeStamp&
    secureConnectionStart()
    {
        return secureConnectionStart_;
    }
    const TimeStamp&
    secureConnectionStart() const
    {
        return secureConnectionStart_;
    }

    TimeStamp&
    connectEnd()
    {
        return connectEnd_;
    }
    const TimeStamp&
    connectEnd() const
    {
        return connectEnd_;
    }

    TimeStamp&
    requestStart()
    {
        return requestStart_;
    }
    const TimeStamp&
    requestStart() const
    {
        return requestStart_;
    }

    TimeStamp&
    responseStart()
    {
        return responseStart_;
    }
    const TimeStamp&
    responseStart() const
    {
        return responseStart_;
    }

    TimeStamp&
    responseEnd()
    {
        return responseEnd_;
    }
    const TimeStamp&
    responseEnd() const
    {
        return responseEnd_;
    }

private:
    TimeStamp domainLookupStart_;
    TimeStamp domainLookupEnd_;
    TimeStamp connectStart_;
    TimeStamp tcpConnectEnd_;
    TimeStamp secureConnectionStart_;
    TimeStamp connectEnd_;
    TimeStamp requestStart_;
    TimeStamp responseStart_;
    TimeStamp responseEnd_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::TimingStructArgs>
{
    typedef mozilla::net::TimingStructArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ResourceTimingStructArgs|
//
namespace mozilla {
namespace net {
class ResourceTimingStructArgs final
{
private:
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ResourceTimingStructArgs() :
        domainLookupStart_(),
        domainLookupEnd_(),
        connectStart_(),
        tcpConnectEnd_(),
        secureConnectionStart_(),
        connectEnd_(),
        requestStart_(),
        responseStart_(),
        responseEnd_(),
        fetchStart_(),
        redirectStart_(),
        redirectEnd_(),
        protocolVersion_(),
        cacheReadStart_(),
        cacheReadEnd_(),
        transferSize_(),
        encodedBodySize_()
    {
    }

    MOZ_IMPLICIT ResourceTimingStructArgs(
            const TimeStamp& _domainLookupStart,
            const TimeStamp& _domainLookupEnd,
            const TimeStamp& _connectStart,
            const TimeStamp& _tcpConnectEnd,
            const TimeStamp& _secureConnectionStart,
            const TimeStamp& _connectEnd,
            const TimeStamp& _requestStart,
            const TimeStamp& _responseStart,
            const TimeStamp& _responseEnd,
            const TimeStamp& _fetchStart,
            const TimeStamp& _redirectStart,
            const TimeStamp& _redirectEnd,
            const uint64_t& _transferSize,
            const uint64_t& _encodedBodySize,
            const nsCString& _protocolVersion,
            const TimeStamp& _cacheReadStart,
            const TimeStamp& _cacheReadEnd) :
        domainLookupStart_(_domainLookupStart),
        domainLookupEnd_(_domainLookupEnd),
        connectStart_(_connectStart),
        tcpConnectEnd_(_tcpConnectEnd),
        secureConnectionStart_(_secureConnectionStart),
        connectEnd_(_connectEnd),
        requestStart_(_requestStart),
        responseStart_(_responseStart),
        responseEnd_(_responseEnd),
        fetchStart_(_fetchStart),
        redirectStart_(_redirectStart),
        redirectEnd_(_redirectEnd),
        protocolVersion_(_protocolVersion),
        cacheReadStart_(_cacheReadStart),
        cacheReadEnd_(_cacheReadEnd),
        transferSize_(_transferSize),
        encodedBodySize_(_encodedBodySize)
    {
    }

    bool
    operator==(const ResourceTimingStructArgs& _o) const;

    bool
    operator!=(const ResourceTimingStructArgs& _o) const;

    TimeStamp&
    domainLookupStart()
    {
        return domainLookupStart_;
    }
    const TimeStamp&
    domainLookupStart() const
    {
        return domainLookupStart_;
    }

    TimeStamp&
    domainLookupEnd()
    {
        return domainLookupEnd_;
    }
    const TimeStamp&
    domainLookupEnd() const
    {
        return domainLookupEnd_;
    }

    TimeStamp&
    connectStart()
    {
        return connectStart_;
    }
    const TimeStamp&
    connectStart() const
    {
        return connectStart_;
    }

    TimeStamp&
    tcpConnectEnd()
    {
        return tcpConnectEnd_;
    }
    const TimeStamp&
    tcpConnectEnd() const
    {
        return tcpConnectEnd_;
    }

    TimeStamp&
    secureConnectionStart()
    {
        return secureConnectionStart_;
    }
    const TimeStamp&
    secureConnectionStart() const
    {
        return secureConnectionStart_;
    }

    TimeStamp&
    connectEnd()
    {
        return connectEnd_;
    }
    const TimeStamp&
    connectEnd() const
    {
        return connectEnd_;
    }

    TimeStamp&
    requestStart()
    {
        return requestStart_;
    }
    const TimeStamp&
    requestStart() const
    {
        return requestStart_;
    }

    TimeStamp&
    responseStart()
    {
        return responseStart_;
    }
    const TimeStamp&
    responseStart() const
    {
        return responseStart_;
    }

    TimeStamp&
    responseEnd()
    {
        return responseEnd_;
    }
    const TimeStamp&
    responseEnd() const
    {
        return responseEnd_;
    }

    TimeStamp&
    fetchStart()
    {
        return fetchStart_;
    }
    const TimeStamp&
    fetchStart() const
    {
        return fetchStart_;
    }

    TimeStamp&
    redirectStart()
    {
        return redirectStart_;
    }
    const TimeStamp&
    redirectStart() const
    {
        return redirectStart_;
    }

    TimeStamp&
    redirectEnd()
    {
        return redirectEnd_;
    }
    const TimeStamp&
    redirectEnd() const
    {
        return redirectEnd_;
    }

    uint64_t&
    transferSize()
    {
        return transferSize_;
    }
    const uint64_t&
    transferSize() const
    {
        return transferSize_;
    }

    uint64_t&
    encodedBodySize()
    {
        return encodedBodySize_;
    }
    const uint64_t&
    encodedBodySize() const
    {
        return encodedBodySize_;
    }

    nsCString&
    protocolVersion()
    {
        return protocolVersion_;
    }
    const nsCString&
    protocolVersion() const
    {
        return protocolVersion_;
    }

    TimeStamp&
    cacheReadStart()
    {
        return cacheReadStart_;
    }
    const TimeStamp&
    cacheReadStart() const
    {
        return cacheReadStart_;
    }

    TimeStamp&
    cacheReadEnd()
    {
        return cacheReadEnd_;
    }
    const TimeStamp&
    cacheReadEnd() const
    {
        return cacheReadEnd_;
    }

private:
    void
    StaticAssertions() const;
    TimeStamp domainLookupStart_;
    TimeStamp domainLookupEnd_;
    TimeStamp connectStart_;
    TimeStamp tcpConnectEnd_;
    TimeStamp secureConnectionStart_;
    TimeStamp connectEnd_;
    TimeStamp requestStart_;
    TimeStamp responseStart_;
    TimeStamp responseEnd_;
    TimeStamp fetchStart_;
    TimeStamp redirectStart_;
    TimeStamp redirectEnd_;
    nsCString protocolVersion_;
    TimeStamp cacheReadStart_;
    TimeStamp cacheReadEnd_;
    uint64_t transferSize_;
    uint64_t encodedBodySize_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::ResourceTimingStructArgs>
{
    typedef mozilla::net::ResourceTimingStructArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpActivity|
//
namespace mozilla {
namespace net {
class HttpActivity final
{
private:

public:
    MOZ_IMPLICIT HttpActivity() :
        host_(),
        endToEndSSL_(),
        port_()
    {
    }

    MOZ_IMPLICIT HttpActivity(
            const nsCString& _host,
            const int32_t& _port,
            const bool& _endToEndSSL) :
        host_(_host),
        endToEndSSL_(_endToEndSSL),
        port_(_port)
    {
    }

    bool
    operator==(const HttpActivity& _o) const;

    bool
    operator!=(const HttpActivity& _o) const;

    nsCString&
    host()
    {
        return host_;
    }
    const nsCString&
    host() const
    {
        return host_;
    }

    int32_t&
    port()
    {
        return port_;
    }
    const int32_t&
    port() const
    {
        return port_;
    }

    bool&
    endToEndSSL()
    {
        return endToEndSSL_;
    }
    const bool&
    endToEndSSL() const
    {
        return endToEndSSL_;
    }

private:
    nsCString host_;
    bool endToEndSSL_;
    int32_t port_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpActivity>
{
    typedef mozilla::net::HttpActivity paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpActivityArgs|
//
namespace mozilla {
namespace net {
class HttpActivityArgs final
{
public:
    enum Type {
        T__None,
        Tuint64_t = 1,
        THttpActivity,
        T__Last = THttpActivity
    };

private:
    typedef mozilla::net::HttpActivity HttpActivity;
    typedef uint64_t uint64_t__tdef;
    typedef HttpActivity HttpActivity__tdef;

    union Value {
        mozilla::AlignedStorage2<uint64_t> Vuint64_t;
        mozilla::AlignedStorage2<HttpActivity> VHttpActivity;
    };

    uint64_t*
    ptr_uint64_t()
    {
        return ((mValue).Vuint64_t).addr();
    }
    const uint64_t*
    constptr_uint64_t() const
    {
        return ((mValue).Vuint64_t).addr();
    }
    HttpActivity*
    ptr_HttpActivity()
    {
        return ((mValue).VHttpActivity).addr();
    }
    const HttpActivity*
    constptr_HttpActivity() const
    {
        return ((mValue).VHttpActivity).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpActivityArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpActivityArgs(const uint64_t& aOther);

    MOZ_IMPLICIT HttpActivityArgs(uint64_t&& aOther);

    MOZ_IMPLICIT HttpActivityArgs(const HttpActivity& aOther);

    MOZ_IMPLICIT HttpActivityArgs(HttpActivity&& aOther);

    MOZ_IMPLICIT HttpActivityArgs(const HttpActivityArgs& aOther);

    MOZ_IMPLICIT HttpActivityArgs(HttpActivityArgs&& aOther);

    ~HttpActivityArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpActivityArgs&
    operator=(const uint64_t& aRhs);

    HttpActivityArgs&
    operator=(uint64_t&& aRhs);

    HttpActivityArgs&
    operator=(const HttpActivity& aRhs);

    HttpActivityArgs&
    operator=(HttpActivity&& aRhs);

    HttpActivityArgs&
    operator=(const HttpActivityArgs& aRhs);

    HttpActivityArgs&
    operator=(HttpActivityArgs&& aRhs);

    bool
    operator==(const uint64_t& aRhs) const;

    bool
    operator==(const HttpActivity& aRhs) const;

    bool
    operator==(const HttpActivityArgs& aRhs) const;

    uint64_t&
    get_uint64_t()
    {
        AssertSanity(Tuint64_t);
        return (*(ptr_uint64_t()));
    }
    const uint64_t&
    get_uint64_t() const
    {
        AssertSanity(Tuint64_t);
        return (*(constptr_uint64_t()));
    }
    operator uint64_t&()
    {
        return get_uint64_t();
    }
    operator const uint64_t&() const
    {
        return get_uint64_t();
    }

    HttpActivity&
    get_HttpActivity()
    {
        AssertSanity(THttpActivity);
        return (*(ptr_HttpActivity()));
    }
    const HttpActivity&
    get_HttpActivity() const
    {
        AssertSanity(THttpActivity);
        return (*(constptr_HttpActivity()));
    }
    operator HttpActivity&()
    {
        return get_HttpActivity();
    }
    operator const HttpActivity&() const
    {
        return get_HttpActivity();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::HttpActivityArgs>
{
    typedef mozilla::net::HttpActivityArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransactionObserverResult|
//
namespace mozilla {
namespace net {
class TransactionObserverResult final
{
private:

public:
    MOZ_IMPLICIT TransactionObserverResult() :
        versionOk_(),
        authOk_(),
        closeReason_()
    {
    }

    MOZ_IMPLICIT TransactionObserverResult(
            const bool& _versionOk,
            const bool& _authOk,
            const nsresult& _closeReason) :
        versionOk_(_versionOk),
        authOk_(_authOk),
        closeReason_(_closeReason)
    {
    }

    bool
    operator==(const TransactionObserverResult& _o) const;

    bool
    operator!=(const TransactionObserverResult& _o) const;

    bool&
    versionOk()
    {
        return versionOk_;
    }
    const bool&
    versionOk() const
    {
        return versionOk_;
    }

    bool&
    authOk()
    {
        return authOk_;
    }
    const bool&
    authOk() const
    {
        return authOk_;
    }

    nsresult&
    closeReason()
    {
        return closeReason_;
    }
    const nsresult&
    closeReason() const
    {
        return closeReason_;
    }

private:
    bool versionOk_;
    bool authOk_;
    nsresult closeReason_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::TransactionObserverResult>
{
    typedef mozilla::net::TransactionObserverResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SpeculativeConnectionOverriderArgs|
//
namespace mozilla {
namespace net {
class SpeculativeConnectionOverriderArgs final
{
private:

public:
    MOZ_IMPLICIT SpeculativeConnectionOverriderArgs() :
        ignoreIdle_(),
        isFromPredictor_(),
        allow1918_(),
        parallelSpeculativeConnectLimit_()
    {
    }

    MOZ_IMPLICIT SpeculativeConnectionOverriderArgs(
            const uint32_t& _parallelSpeculativeConnectLimit,
            const bool& _ignoreIdle,
            const bool& _isFromPredictor,
            const bool& _allow1918) :
        ignoreIdle_(_ignoreIdle),
        isFromPredictor_(_isFromPredictor),
        allow1918_(_allow1918),
        parallelSpeculativeConnectLimit_(_parallelSpeculativeConnectLimit)
    {
    }

    bool
    operator==(const SpeculativeConnectionOverriderArgs& _o) const;

    bool
    operator!=(const SpeculativeConnectionOverriderArgs& _o) const;

    uint32_t&
    parallelSpeculativeConnectLimit()
    {
        return parallelSpeculativeConnectLimit_;
    }
    const uint32_t&
    parallelSpeculativeConnectLimit() const
    {
        return parallelSpeculativeConnectLimit_;
    }

    bool&
    ignoreIdle()
    {
        return ignoreIdle_;
    }
    const bool&
    ignoreIdle() const
    {
        return ignoreIdle_;
    }

    bool&
    isFromPredictor()
    {
        return isFromPredictor_;
    }
    const bool&
    isFromPredictor() const
    {
        return isFromPredictor_;
    }

    bool&
    allow1918()
    {
        return allow1918_;
    }
    const bool&
    allow1918() const
    {
        return allow1918_;
    }

private:
    bool ignoreIdle_;
    bool isFromPredictor_;
    bool allow1918_;
    uint32_t parallelSpeculativeConnectLimit_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::SpeculativeConnectionOverriderArgs>
{
    typedef mozilla::net::SpeculativeConnectionOverriderArgs paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
