//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebGPUChild_h
#define PWebGPUChild_h

#include "mozilla/webgpu/PWebGPU.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/WeakPtr.h"
// Headers for things that cannot be forward declared
#include "mozilla/dom/WebGPUBinding.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/webgpu/WebGPUSerialize.h"
#include "mozilla/webgpu/WebGPUTypes.h"
#include "mozilla/webgpu/ffi/wgpu.h"
#include "mozilla/webrender/WebRenderAPI.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace webgpu {


class PWebGPUChild :
    public mozilla::ipc::IProtocol,
    public SupportsWeakPtr<PWebGPUChild>
{
public:
    MOZ_DECLARE_WEAKREFERENCE_TYPENAME(PWebGPUChild)
private:
    friend class mozilla::layers::PCompositorBridgeChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef wr::ExternalImageId ExternalImageId;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef dom::GPUCommandBufferDescriptor GPUCommandBufferDescriptor;
    typedef dom::GPUCommandEncoderDescriptor GPUCommandEncoderDescriptor;
    typedef dom::GPUDeviceDescriptor GPUDeviceDescriptor;
    typedef dom::GPUPipelineLayoutDescriptor GPUPipelineLayoutDescriptor;
    typedef dom::GPURequestAdapterOptions GPURequestAdapterOptions;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef layers::RGBDescriptor RGBDescriptor;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef webgpu::ffi::WGPUBufferCopyView WGPUBufferCopyView;
    typedef webgpu::ffi::WGPUBufferDescriptor WGPUBufferDescriptor;
    typedef webgpu::ffi::WGPUExtent3d WGPUExtent3d;
    typedef webgpu::ffi::WGPUSamplerDescriptor WGPUSamplerDescriptor;
    typedef webgpu::ffi::WGPUTextureCopyView WGPUTextureCopyView;
    typedef webgpu::ffi::WGPUTextureDescriptor WGPUTextureDescriptor;
    typedef webgpu::ffi::WGPUTextureViewDescriptor WGPUTextureViewDescriptor;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;

public:
    typedef MozPromise<RawId, ResponseRejectReason, true> InstanceRequestAdapterPromise;
    typedef MozPromise<Shmem, ResponseRejectReason, true> BufferMapReadPromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebGPUChild();

    virtual ~PWebGPUChild();

public:
    PCompositorBridgeChild*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    void
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            const nsTArray<RawId>& ids,
            mozilla::ipc::ResolveCallback<RawId>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<InstanceRequestAdapterPromise>
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            const nsTArray<RawId>& ids);

    bool
    SendAdapterRequestDevice(
            const RawId& selfId,
            const GPUDeviceDescriptor& desc,
            const RawId& newId);

    bool
    SendAdapterDestroy(const RawId& selfId);

    bool
    SendDeviceCreateBuffer(
            const RawId& selfId,
            const WGPUBufferDescriptor& desc,
            const nsCString& label,
            const RawId& newId);

    bool
    SendDeviceDestroy(const RawId& selfId);

    bool
    SendDeviceUnmapBuffer(
            const RawId& selfId,
            const RawId& bufferId,
            Shmem&& shmem,
            const bool& flush);

    void
    SendBufferMapRead(
            const RawId& selfId,
            Shmem&& shmem,
            mozilla::ipc::ResolveCallback<Shmem>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<BufferMapReadPromise>
    SendBufferMapRead(
            const RawId& selfId,
            Shmem&& shmem);

    bool
    SendBufferDestroy(const RawId& selfId);

    bool
    SendDeviceCreateTexture(
            const RawId& selfId,
            const WGPUTextureDescriptor& desc,
            const nsCString& label,
            const RawId& newId);

    bool
    SendTextureCreateView(
            const RawId& selfId,
            const WGPUTextureViewDescriptor& desc,
            const nsCString& label,
            const RawId& newId);

    bool
    SendTextureDestroy(const RawId& selfId);

    bool
    SendTextureViewDestroy(const RawId& selfId);

    bool
    SendDeviceCreateSampler(
            const RawId& selfId,
            const WGPUSamplerDescriptor& desc,
            const nsCString& label,
            const RawId& newId);

    bool
    SendSamplerDestroy(const RawId& selfId);

    bool
    SendDeviceCreateCommandEncoder(
            const RawId& selfId,
            const GPUCommandEncoderDescriptor& desc,
            const RawId& newId);

    bool
    SendCommandEncoderCopyBufferToBuffer(
            const RawId& selfId,
            const RawId& sourceId,
            const BufferAddress& sourceOffset,
            const RawId& destinationId,
            const BufferAddress& destinationOffset,
            const BufferAddress& size);

    bool
    SendCommandEncoderCopyBufferToTexture(
            const RawId& selfId,
            const WGPUBufferCopyView& source,
            const WGPUTextureCopyView& destination,
            const WGPUExtent3d& extent);

    bool
    SendCommandEncoderCopyTextureToBuffer(
            const RawId& selfId,
            const WGPUTextureCopyView& source,
            const WGPUBufferCopyView& destination,
            const WGPUExtent3d& extent);

    bool
    SendCommandEncoderCopyTextureToTexture(
            const RawId& selfId,
            const WGPUTextureCopyView& source,
            const WGPUTextureCopyView& destination,
            const WGPUExtent3d& extent);

    bool
    SendCommandEncoderRunComputePass(
            const RawId& selfId,
            Shmem&& shmem);

    bool
    SendCommandEncoderRunRenderPass(
            const RawId& selfId,
            Shmem&& shmem);

    bool
    SendCommandEncoderFinish(
            const RawId& selfId,
            const GPUCommandBufferDescriptor& desc);

    bool
    SendCommandEncoderDestroy(const RawId& selfId);

    bool
    SendCommandBufferDestroy(const RawId& selfId);

    bool
    SendQueueSubmit(
            const RawId& selfId,
            const nsTArray<RawId>& commandBuffers);

    bool
    SendDeviceCreateBindGroupLayout(
            const RawId& selfId,
            const SerialBindGroupLayoutDescriptor& desc,
            const RawId& newId);

    bool
    SendBindGroupLayoutDestroy(const RawId& selfId);

    bool
    SendDeviceCreatePipelineLayout(
            const RawId& selfId,
            const SerialPipelineLayoutDescriptor& desc,
            const RawId& newId);

    bool
    SendPipelineLayoutDestroy(const RawId& selfId);

    bool
    SendDeviceCreateBindGroup(
            const RawId& selfId,
            const SerialBindGroupDescriptor& desc,
            const RawId& newId);

    bool
    SendBindGroupDestroy(const RawId& selfId);

    bool
    SendDeviceCreateShaderModule(
            const RawId& selfId,
            const nsTArray<uint32_t>& data,
            const RawId& newId);

    bool
    SendShaderModuleDestroy(const RawId& selfId);

    bool
    SendDeviceCreateComputePipeline(
            const RawId& selfId,
            const SerialComputePipelineDescriptor& desc,
            const RawId& newId);

    bool
    SendComputePipelineDestroy(const RawId& selfId);

    bool
    SendDeviceCreateRenderPipeline(
            const RawId& selfId,
            const SerialRenderPipelineDescriptor& desc,
            const RawId& newId);

    bool
    SendRenderPipelineDestroy(const RawId& selfId);

    bool
    SendDeviceCreateSwapChain(
            const RawId& selfId,
            const RawId& queueId,
            const RGBDescriptor& desc,
            const nsTArray<RawId>& bufferIds,
            const ExternalImageId& externalId);

    bool
    SendSwapChainPresent(
            const ExternalImageId& externalId,
            const RawId& textureId,
            const RawId& commandEncoderId);

    bool
    SendSwapChainDestroy(const ExternalImageId& externalId);

    bool
    SendShutdown();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

private:
    void
    ClearSubtree();

};


} // namespace webgpu
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::webgpu::PWebGPUChild*>
{
    typedef mozilla::webgpu::PWebGPUChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PWebGPUChild_h
