struct brush_image_TEXTURE_RECT_common {
struct Samplers {
 sampler2DRect_impl sColor0_impl;
 int sColor0_slot;
 sampler2D_impl sGpuCache_impl;
 int sGpuCache_slot;
 sampler2DArray_impl sPrevPassAlpha_impl;
 int sPrevPassAlpha_slot;
 sampler2D_impl sPrimitiveHeadersF_impl;
 int sPrimitiveHeadersF_slot;
 isampler2D_impl sPrimitiveHeadersI_impl;
 int sPrimitiveHeadersI_slot;
 sampler2D_impl sRenderTasks_impl;
 int sRenderTasks_slot;
 sampler2D_impl sTransformPalette_impl;
 int sTransformPalette_slot;
 bool set_slot(int index, int value) {
  switch (index) {
  case 7:
   sColor0_slot = value;
   return true;
  case 2:
   sGpuCache_slot = value;
   return true;
  case 8:
   sPrevPassAlpha_slot = value;
   return true;
  case 4:
   sPrimitiveHeadersF_slot = value;
   return true;
  case 5:
   sPrimitiveHeadersI_slot = value;
   return true;
  case 1:
   sRenderTasks_slot = value;
   return true;
  case 3:
   sTransformPalette_slot = value;
   return true;
  }
  return false;
 }
} samplers;
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aData = NULL_ATTRIB;
 void bind_loc(const char* name, int index) {
  if (strcmp("aPosition", name) == 0) { aPosition = index; return; }
  if (strcmp("aData", name) == 0) { aData = index; return; }
 }
 int get_loc(const char* name) const {
  if (strcmp("aPosition", name) == 0) { return aPosition != NULL_ATTRIB ? aPosition : -1; }
  if (strcmp("aData", name) == 0) { return aData != NULL_ATTRIB ? aData : -1; }
  return -1;
 }
} attrib_locations;
vec4_scalar vTransformBounds;
vec4_scalar vClipMaskUvBounds;
vec4_scalar flat_varying_vec4_2;
vec4_scalar flat_varying_vec4_3;
vec4_scalar flat_varying_vec4_4;
sampler2DRect sColor0;
sampler2D sGpuCache;
sampler2DArray sPrevPassAlpha;
sampler2D sPrimitiveHeadersF;
isampler2D sPrimitiveHeadersI;
sampler2D sRenderTasks;
sampler2D sTransformPalette;
mat4_scalar uTransform;
void bind_textures() {
 sColor0 = lookup_sampler(&samplers.sColor0_impl, samplers.sColor0_slot);
 sGpuCache = lookup_sampler(&samplers.sGpuCache_impl, samplers.sGpuCache_slot);
 sPrevPassAlpha = lookup_sampler_array(&samplers.sPrevPassAlpha_impl, samplers.sPrevPassAlpha_slot);
 sPrimitiveHeadersF = lookup_sampler(&samplers.sPrimitiveHeadersF_impl, samplers.sPrimitiveHeadersF_slot);
 sPrimitiveHeadersI = lookup_isampler(&samplers.sPrimitiveHeadersI_impl, samplers.sPrimitiveHeadersI_slot);
 sRenderTasks = lookup_sampler(&samplers.sRenderTasks_impl, samplers.sRenderTasks_slot);
 sTransformPalette = lookup_sampler(&samplers.sTransformPalette_impl, samplers.sTransformPalette_slot);
}
};
struct brush_image_TEXTURE_RECT_vert : VertexShaderImpl, brush_image_TEXTURE_RECT_common {
private:
typedef brush_image_TEXTURE_RECT_vert Self;
// int32_t uMode;
// mat4_scalar uTransform;
vec2 aPosition;
// sampler2DRect sColor0;
// sampler2DRect sColor1;
// sampler2DRect sColor2;
struct RectWithSize_scalar {
vec2_scalar p0;
vec2_scalar size;
RectWithSize_scalar() = default;
RectWithSize_scalar(vec2_scalar p0, vec2_scalar size) : p0(p0), size(size){}
};
struct RectWithSize {
vec2 p0;
vec2 size;
RectWithSize() = default;
RectWithSize(vec2 p0, vec2 size) : p0(p0), size(size){}
RectWithSize(vec2_scalar p0, vec2_scalar size):p0(p0),size(size){
}
IMPLICIT RectWithSize(RectWithSize_scalar s):p0(s.p0),size(s.size){
}
friend RectWithSize if_then_else(I32 c, RectWithSize t, RectWithSize e) { return RectWithSize(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.size, e.size));
}};
struct RectWithEndpoint_scalar {
vec2_scalar p0;
vec2_scalar p1;
RectWithEndpoint_scalar() = default;
RectWithEndpoint_scalar(vec2_scalar p0, vec2_scalar p1) : p0(p0), p1(p1){}
};
struct RectWithEndpoint {
vec2 p0;
vec2 p1;
RectWithEndpoint() = default;
RectWithEndpoint(vec2 p0, vec2 p1) : p0(p0), p1(p1){}
RectWithEndpoint(vec2_scalar p0, vec2_scalar p1):p0(p0),p1(p1){
}
IMPLICIT RectWithEndpoint(RectWithEndpoint_scalar s):p0(s.p0),p1(s.p1){
}
friend RectWithEndpoint if_then_else(I32 c, RectWithEndpoint t, RectWithEndpoint e) { return RectWithEndpoint(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.p1, e.p1));
}};
// sampler2D sRenderTasks;
struct RenderTaskCommonData_scalar {
RectWithSize_scalar task_rect;
float texture_layer_index;
RenderTaskCommonData_scalar() = default;
RenderTaskCommonData_scalar(RectWithSize_scalar task_rect, float texture_layer_index) : task_rect(task_rect), texture_layer_index(texture_layer_index){}
};
struct RenderTaskCommonData {
RectWithSize task_rect;
Float texture_layer_index;
RenderTaskCommonData() = default;
RenderTaskCommonData(RectWithSize task_rect, Float texture_layer_index) : task_rect(task_rect), texture_layer_index(texture_layer_index){}
RenderTaskCommonData(RectWithSize_scalar task_rect, float texture_layer_index):task_rect(task_rect),texture_layer_index(texture_layer_index){
}
IMPLICIT RenderTaskCommonData(RenderTaskCommonData_scalar s):task_rect(s.task_rect),texture_layer_index(s.texture_layer_index){
}
friend RenderTaskCommonData if_then_else(I32 c, RenderTaskCommonData t, RenderTaskCommonData e) { return RenderTaskCommonData(
if_then_else(c, t.task_rect, e.task_rect), if_then_else(c, t.texture_layer_index, e.texture_layer_index));
}};
struct RenderTaskData_scalar {
RenderTaskCommonData_scalar common_data;
vec3_scalar user_data;
RenderTaskData_scalar() = default;
RenderTaskData_scalar(RenderTaskCommonData_scalar common_data, vec3_scalar user_data) : common_data(common_data), user_data(user_data){}
};
struct RenderTaskData {
RenderTaskCommonData common_data;
vec3 user_data;
RenderTaskData() = default;
RenderTaskData(RenderTaskCommonData common_data, vec3 user_data) : common_data(common_data), user_data(user_data){}
RenderTaskData(RenderTaskCommonData_scalar common_data, vec3_scalar user_data):common_data(common_data),user_data(user_data){
}
IMPLICIT RenderTaskData(RenderTaskData_scalar s):common_data(s.common_data),user_data(s.user_data){
}
friend RenderTaskData if_then_else(I32 c, RenderTaskData t, RenderTaskData e) { return RenderTaskData(
if_then_else(c, t.common_data, e.common_data), if_then_else(c, t.user_data, e.user_data));
}};
struct PictureTask_scalar {
RenderTaskCommonData_scalar common_data;
float device_pixel_scale;
vec2_scalar content_origin;
PictureTask_scalar() = default;
PictureTask_scalar(RenderTaskCommonData_scalar common_data, float device_pixel_scale, vec2_scalar content_origin) : common_data(common_data), device_pixel_scale(device_pixel_scale), content_origin(content_origin){}
};
struct PictureTask {
RenderTaskCommonData common_data;
Float device_pixel_scale;
vec2 content_origin;
PictureTask() = default;
PictureTask(RenderTaskCommonData common_data, Float device_pixel_scale, vec2 content_origin) : common_data(common_data), device_pixel_scale(device_pixel_scale), content_origin(content_origin){}
PictureTask(RenderTaskCommonData_scalar common_data, float device_pixel_scale, vec2_scalar content_origin):common_data(common_data),device_pixel_scale(device_pixel_scale),content_origin(content_origin){
}
IMPLICIT PictureTask(PictureTask_scalar s):common_data(s.common_data),device_pixel_scale(s.device_pixel_scale),content_origin(s.content_origin){
}
friend PictureTask if_then_else(I32 c, PictureTask t, PictureTask e) { return PictureTask(
if_then_else(c, t.common_data, e.common_data), if_then_else(c, t.device_pixel_scale, e.device_pixel_scale), if_then_else(c, t.content_origin, e.content_origin));
}};
struct ClipArea_scalar {
RenderTaskCommonData_scalar common_data;
float device_pixel_scale;
vec2_scalar screen_origin;
ClipArea_scalar() = default;
ClipArea_scalar(RenderTaskCommonData_scalar common_data, float device_pixel_scale, vec2_scalar screen_origin) : common_data(common_data), device_pixel_scale(device_pixel_scale), screen_origin(screen_origin){}
};
struct ClipArea {
RenderTaskCommonData common_data;
Float device_pixel_scale;
vec2 screen_origin;
ClipArea() = default;
ClipArea(RenderTaskCommonData common_data, Float device_pixel_scale, vec2 screen_origin) : common_data(common_data), device_pixel_scale(device_pixel_scale), screen_origin(screen_origin){}
ClipArea(RenderTaskCommonData_scalar common_data, float device_pixel_scale, vec2_scalar screen_origin):common_data(common_data),device_pixel_scale(device_pixel_scale),screen_origin(screen_origin){
}
IMPLICIT ClipArea(ClipArea_scalar s):common_data(s.common_data),device_pixel_scale(s.device_pixel_scale),screen_origin(s.screen_origin){
}
friend ClipArea if_then_else(I32 c, ClipArea t, ClipArea e) { return ClipArea(
if_then_else(c, t.common_data, e.common_data), if_then_else(c, t.device_pixel_scale, e.device_pixel_scale), if_then_else(c, t.screen_origin, e.screen_origin));
}};
// sampler2D sGpuCache;
struct ImageResource_scalar {
RectWithEndpoint_scalar uv_rect;
float layer;
vec3_scalar user_data;
ImageResource_scalar() = default;
ImageResource_scalar(RectWithEndpoint_scalar uv_rect, float layer, vec3_scalar user_data) : uv_rect(uv_rect), layer(layer), user_data(user_data){}
};
struct ImageResource {
RectWithEndpoint uv_rect;
Float layer;
vec3 user_data;
ImageResource() = default;
ImageResource(RectWithEndpoint uv_rect, Float layer, vec3 user_data) : uv_rect(uv_rect), layer(layer), user_data(user_data){}
ImageResource(RectWithEndpoint_scalar uv_rect, float layer, vec3_scalar user_data):uv_rect(uv_rect),layer(layer),user_data(user_data){
}
IMPLICIT ImageResource(ImageResource_scalar s):uv_rect(s.uv_rect),layer(s.layer),user_data(s.user_data){
}
friend ImageResource if_then_else(I32 c, ImageResource t, ImageResource e) { return ImageResource(
if_then_else(c, t.uv_rect, e.uv_rect), if_then_else(c, t.layer, e.layer), if_then_else(c, t.user_data, e.user_data));
}};
struct ImageResourceExtra_scalar {
vec4_scalar st_tl;
vec4_scalar st_tr;
vec4_scalar st_bl;
vec4_scalar st_br;
ImageResourceExtra_scalar() = default;
ImageResourceExtra_scalar(vec4_scalar st_tl, vec4_scalar st_tr, vec4_scalar st_bl, vec4_scalar st_br) : st_tl(st_tl), st_tr(st_tr), st_bl(st_bl), st_br(st_br){}
};
struct ImageResourceExtra {
vec4 st_tl;
vec4 st_tr;
vec4 st_bl;
vec4 st_br;
ImageResourceExtra() = default;
ImageResourceExtra(vec4 st_tl, vec4 st_tr, vec4 st_bl, vec4 st_br) : st_tl(st_tl), st_tr(st_tr), st_bl(st_bl), st_br(st_br){}
ImageResourceExtra(vec4_scalar st_tl, vec4_scalar st_tr, vec4_scalar st_bl, vec4_scalar st_br):st_tl(st_tl),st_tr(st_tr),st_bl(st_bl),st_br(st_br){
}
IMPLICIT ImageResourceExtra(ImageResourceExtra_scalar s):st_tl(s.st_tl),st_tr(s.st_tr),st_bl(s.st_bl),st_br(s.st_br){
}
friend ImageResourceExtra if_then_else(I32 c, ImageResourceExtra t, ImageResourceExtra e) { return ImageResourceExtra(
if_then_else(c, t.st_tl, e.st_tl), if_then_else(c, t.st_tr, e.st_tr), if_then_else(c, t.st_bl, e.st_bl), if_then_else(c, t.st_br, e.st_br));
}};
// vec4_scalar vTransformBounds;
// sampler2D sTransformPalette;
struct Transform_scalar {
mat4_scalar m;
mat4_scalar inv_m;
bool is_axis_aligned;
Transform_scalar() = default;
Transform_scalar(mat4_scalar m, mat4_scalar inv_m, bool is_axis_aligned) : m(m), inv_m(inv_m), is_axis_aligned(is_axis_aligned){}
};
struct Transform {
mat4 m;
mat4 inv_m;
Bool is_axis_aligned;
Transform() = default;
Transform(mat4 m, mat4 inv_m, Bool is_axis_aligned) : m(m), inv_m(inv_m), is_axis_aligned(is_axis_aligned){}
Transform(mat4_scalar m, mat4_scalar inv_m, bool is_axis_aligned):m(m),inv_m(inv_m),is_axis_aligned(is_axis_aligned){
}
IMPLICIT Transform(Transform_scalar s):m(s.m),inv_m(s.inv_m),is_axis_aligned(s.is_axis_aligned){
}
friend Transform if_then_else(I32 c, Transform t, Transform e) { return Transform(
if_then_else(c, t.m, e.m), if_then_else(c, t.inv_m, e.inv_m), if_then_else(c, t.is_axis_aligned, e.is_axis_aligned));
}};
// sampler2DArray sPrevPassAlpha;
// sampler2DArray sPrevPassColor;
// vec4_scalar vClipMaskUvBounds;
vec4 vClipMaskUv;
// sampler2D sPrimitiveHeadersF;
// isampler2D sPrimitiveHeadersI;
ivec4_scalar aData;
struct Instance_scalar {
int32_t prim_header_address;
int32_t picture_task_address;
int32_t clip_address;
int32_t segment_index;
int32_t flags;
int32_t resource_address;
int32_t brush_kind;
Instance_scalar() = default;
Instance_scalar(int32_t prim_header_address, int32_t picture_task_address, int32_t clip_address, int32_t segment_index, int32_t flags, int32_t resource_address, int32_t brush_kind) : prim_header_address(prim_header_address), picture_task_address(picture_task_address), clip_address(clip_address), segment_index(segment_index), flags(flags), resource_address(resource_address), brush_kind(brush_kind){}
};
struct Instance {
I32 prim_header_address;
I32 picture_task_address;
I32 clip_address;
I32 segment_index;
I32 flags;
I32 resource_address;
I32 brush_kind;
Instance() = default;
Instance(I32 prim_header_address, I32 picture_task_address, I32 clip_address, I32 segment_index, I32 flags, I32 resource_address, I32 brush_kind) : prim_header_address(prim_header_address), picture_task_address(picture_task_address), clip_address(clip_address), segment_index(segment_index), flags(flags), resource_address(resource_address), brush_kind(brush_kind){}
Instance(int32_t prim_header_address, int32_t picture_task_address, int32_t clip_address, int32_t segment_index, int32_t flags, int32_t resource_address, int32_t brush_kind):prim_header_address(prim_header_address),picture_task_address(picture_task_address),clip_address(clip_address),segment_index(segment_index),flags(flags),resource_address(resource_address),brush_kind(brush_kind){
}
IMPLICIT Instance(Instance_scalar s):prim_header_address(s.prim_header_address),picture_task_address(s.picture_task_address),clip_address(s.clip_address),segment_index(s.segment_index),flags(s.flags),resource_address(s.resource_address),brush_kind(s.brush_kind){
}
friend Instance if_then_else(I32 c, Instance t, Instance e) { return Instance(
if_then_else(c, t.prim_header_address, e.prim_header_address), if_then_else(c, t.picture_task_address, e.picture_task_address), if_then_else(c, t.clip_address, e.clip_address), if_then_else(c, t.segment_index, e.segment_index), if_then_else(c, t.flags, e.flags), if_then_else(c, t.resource_address, e.resource_address), if_then_else(c, t.brush_kind, e.brush_kind));
}};
struct PrimitiveHeader_scalar {
RectWithSize_scalar local_rect;
RectWithSize_scalar local_clip_rect;
float z;
int32_t specific_prim_address;
int32_t transform_id;
ivec4_scalar user_data;
PrimitiveHeader_scalar() = default;
PrimitiveHeader_scalar(RectWithSize_scalar local_rect, RectWithSize_scalar local_clip_rect, float z, int32_t specific_prim_address, int32_t transform_id, ivec4_scalar user_data) : local_rect(local_rect), local_clip_rect(local_clip_rect), z(z), specific_prim_address(specific_prim_address), transform_id(transform_id), user_data(user_data){}
};
struct PrimitiveHeader {
RectWithSize local_rect;
RectWithSize local_clip_rect;
Float z;
I32 specific_prim_address;
I32 transform_id;
ivec4 user_data;
PrimitiveHeader() = default;
PrimitiveHeader(RectWithSize local_rect, RectWithSize local_clip_rect, Float z, I32 specific_prim_address, I32 transform_id, ivec4 user_data) : local_rect(local_rect), local_clip_rect(local_clip_rect), z(z), specific_prim_address(specific_prim_address), transform_id(transform_id), user_data(user_data){}
PrimitiveHeader(RectWithSize_scalar local_rect, RectWithSize_scalar local_clip_rect, float z, int32_t specific_prim_address, int32_t transform_id, ivec4_scalar user_data):local_rect(local_rect),local_clip_rect(local_clip_rect),z(z),specific_prim_address(specific_prim_address),transform_id(transform_id),user_data(user_data){
}
IMPLICIT PrimitiveHeader(PrimitiveHeader_scalar s):local_rect(s.local_rect),local_clip_rect(s.local_clip_rect),z(s.z),specific_prim_address(s.specific_prim_address),transform_id(s.transform_id),user_data(s.user_data){
}
friend PrimitiveHeader if_then_else(I32 c, PrimitiveHeader t, PrimitiveHeader e) { return PrimitiveHeader(
if_then_else(c, t.local_rect, e.local_rect), if_then_else(c, t.local_clip_rect, e.local_clip_rect), if_then_else(c, t.z, e.z), if_then_else(c, t.specific_prim_address, e.specific_prim_address), if_then_else(c, t.transform_id, e.transform_id), if_then_else(c, t.user_data, e.user_data));
}};
struct VertexInfo_scalar {
vec2_scalar local_pos;
vec4_scalar world_pos;
VertexInfo_scalar() = default;
VertexInfo_scalar(vec2_scalar local_pos, vec4_scalar world_pos) : local_pos(local_pos), world_pos(world_pos){}
};
struct VertexInfo {
vec2 local_pos;
vec4 world_pos;
VertexInfo() = default;
VertexInfo(vec2 local_pos, vec4 world_pos) : local_pos(local_pos), world_pos(world_pos){}
VertexInfo(vec2_scalar local_pos, vec4_scalar world_pos):local_pos(local_pos),world_pos(world_pos){
}
IMPLICIT VertexInfo(VertexInfo_scalar s):local_pos(s.local_pos),world_pos(s.world_pos){
}
friend VertexInfo if_then_else(I32 c, VertexInfo t, VertexInfo e) { return VertexInfo(
if_then_else(c, t.local_pos, e.local_pos), if_then_else(c, t.world_pos, e.world_pos));
}};
// vec4_scalar flat_varying_vec4_0;
// vec4_scalar flat_varying_vec4_1;
// vec4_scalar flat_varying_vec4_2;
// vec4_scalar flat_varying_vec4_3;
// vec4_scalar flat_varying_vec4_4;
// ivec4_scalar flat_varying_ivec4_0;
vec4 varying_vec4_0;
vec4 varying_vec4_1;
// int32_t flat_varying_highp_int_address_0;
struct ImageBrushData_scalar {
vec4_scalar color;
vec4_scalar background_color;
vec2_scalar stretch_size;
ImageBrushData_scalar() = default;
ImageBrushData_scalar(vec4_scalar color, vec4_scalar background_color, vec2_scalar stretch_size) : color(color), background_color(background_color), stretch_size(stretch_size){}
};
struct ImageBrushData {
vec4 color;
vec4 background_color;
vec2 stretch_size;
ImageBrushData() = default;
ImageBrushData(vec4 color, vec4 background_color, vec2 stretch_size) : color(color), background_color(background_color), stretch_size(stretch_size){}
ImageBrushData(vec4_scalar color, vec4_scalar background_color, vec2_scalar stretch_size):color(color),background_color(background_color),stretch_size(stretch_size){
}
IMPLICIT ImageBrushData(ImageBrushData_scalar s):color(s.color),background_color(s.background_color),stretch_size(s.stretch_size){
}
friend ImageBrushData if_then_else(I32 c, ImageBrushData t, ImageBrushData e) { return ImageBrushData(
if_then_else(c, t.color, e.color), if_then_else(c, t.background_color, e.background_color), if_then_else(c, t.stretch_size, e.stretch_size));
}};
Instance_scalar decode_instance_attributes() {
 Instance_scalar instance;
 (instance).prim_header_address = (aData).sel(X);
 (instance).picture_task_address = ((aData).sel(Y))>>(16);
 (instance).clip_address = ((aData).sel(Y))&(65535);
 (instance).segment_index = ((aData).sel(Z))&(65535);
 (instance).flags = ((aData).sel(Z))>>(16);
 (instance).resource_address = ((aData).sel(W))&(16777215);
 (instance).brush_kind = ((aData).sel(W))>>(24);
 return instance;
}
PrimitiveHeader_scalar fetch_prim_header(int32_t index) {
 PrimitiveHeader_scalar ph;
 ivec2_scalar uv_f = make_ivec2(make_int((2u)*((make_uint(index))%((1024u)/(2u)))), make_int((make_uint(index))/((1024u)/(2u))));
 vec4_scalar* sPrimitiveHeadersF_uv_f_fetch = texelFetchPtr(sPrimitiveHeadersF, uv_f, 0, 1, 0, 0);
 vec4_scalar local_rect = sPrimitiveHeadersF_uv_f_fetch[0];
 vec4_scalar local_clip_rect = sPrimitiveHeadersF_uv_f_fetch[1];
 (ph).local_rect = RectWithSize_scalar((local_rect).sel(X, Y), (local_rect).sel(Z, W));
 (ph).local_clip_rect = RectWithSize_scalar((local_clip_rect).sel(X, Y), (local_clip_rect).sel(Z, W));
 ivec2_scalar uv_i = make_ivec2(make_int((2u)*((make_uint(index))%((1024u)/(2u)))), make_int((make_uint(index))/((1024u)/(2u))));
 ivec4_scalar* sPrimitiveHeadersI_uv_i_fetch = texelFetchPtr(sPrimitiveHeadersI, uv_i, 0, 1, 0, 0);
 ivec4_scalar data0 = sPrimitiveHeadersI_uv_i_fetch[0];
 ivec4_scalar data1 = sPrimitiveHeadersI_uv_i_fetch[1];
 (ph).z = make_float((data0).sel(X));
 (ph).specific_prim_address = (data0).sel(Y);
 (ph).transform_id = (data0).sel(Z);
 (ph).user_data = data1;
 return ph;
}
Transform_scalar fetch_transform(int32_t id) {
 Transform_scalar transform;
 (transform).is_axis_aligned = ((id)>>(24))==(0);
 int32_t index = (id)&(16777215);
 ivec2_scalar uv = make_ivec2(make_int((8u)*((make_uint(index))%((1024u)/(8u)))), make_int((make_uint(index))/((1024u)/(8u))));
 ivec2_scalar uv0 = make_ivec2(((uv).sel(X))+(0), (uv).sel(Y));
 vec4_scalar* sTransformPalette_uv0_fetch = texelFetchPtr(sTransformPalette, uv0, 0, 7, 0, 0);
 (transform).m[0] = sTransformPalette_uv0_fetch[0];
 (transform).m[1] = sTransformPalette_uv0_fetch[1];
 (transform).m[2] = sTransformPalette_uv0_fetch[2];
 (transform).m[3] = sTransformPalette_uv0_fetch[3];
 (transform).inv_m[0] = sTransformPalette_uv0_fetch[4];
 (transform).inv_m[1] = sTransformPalette_uv0_fetch[5];
 (transform).inv_m[2] = sTransformPalette_uv0_fetch[6];
 (transform).inv_m[3] = sTransformPalette_uv0_fetch[7];
 return transform;
}
RenderTaskData_scalar fetch_render_task_data(int32_t index) {
 ivec2_scalar uv = make_ivec2(make_int((2u)*((make_uint(index))%((1024u)/(2u)))), make_int((make_uint(index))/((1024u)/(2u))));
 vec4_scalar* sRenderTasks_uv_fetch = texelFetchPtr(sRenderTasks, uv, 0, 1, 0, 0);
 vec4_scalar texel0 = sRenderTasks_uv_fetch[0];
 vec4_scalar texel1 = sRenderTasks_uv_fetch[1];
 RectWithSize_scalar task_rect = RectWithSize_scalar((texel0).sel(X, Y), (texel0).sel(Z, W));
 RenderTaskCommonData_scalar common_data = RenderTaskCommonData_scalar(task_rect, (texel1).sel(X));
 RenderTaskData_scalar data = RenderTaskData_scalar(common_data, (texel1).sel(Y, Z, W));
 return data;
}
PictureTask_scalar fetch_picture_task(int32_t address) {
 RenderTaskData_scalar task_data = fetch_render_task_data(address);
 PictureTask_scalar task = PictureTask_scalar((task_data).common_data, ((task_data).user_data).sel(X), ((task_data).user_data).sel(Y, Z));
 return task;
}
ClipArea_scalar fetch_clip_area(int32_t index) {
 ClipArea_scalar area;
 if ((index)>=(32767)) {
  {
   RectWithSize_scalar rect = RectWithSize_scalar(make_vec2(0.f), make_vec2(0.f));
   (area).common_data = RenderTaskCommonData_scalar(rect, 0.f);
   (area).device_pixel_scale = 0.f;
   (area).screen_origin = make_vec2(0.f);
  }
 } else  {
  RenderTaskData_scalar task_data = fetch_render_task_data(index);
  (area).common_data = (task_data).common_data;
  (area).device_pixel_scale = ((task_data).user_data).sel(X);
  (area).screen_origin = ((task_data).user_data).sel(Y, Z);
 }
 return area;
}
ivec2_scalar get_gpu_cache_uv(int32_t address) {
 return make_ivec2((make_uint(address))%(1024u), (make_uint(address))/(1024u));
}
Array<vec4_scalar,2> fetch_from_gpu_cache_2(int32_t address) {
 ivec2_scalar uv = get_gpu_cache_uv(address);
 vec4_scalar* sGpuCache_uv_fetch = texelFetchPtr(sGpuCache, uv, 0, 1, 0, 0);
 return Array<vec4_scalar,2>{{sGpuCache_uv_fetch[0], sGpuCache_uv_fetch[1]}};
}
vec2 clamp_rect(vec2 pt, RectWithSize_scalar rect) {
 return clamp(pt, (rect).p0, ((rect).p0)+((rect).size));
}
VertexInfo write_vertex(vec2 local_pos, RectWithSize_scalar local_clip_rect, float z, Transform_scalar transform, PictureTask_scalar task) {
 vec2 clamped_local_pos = clamp_rect(local_pos, local_clip_rect);
 vec4 world_pos = ((transform).m)*(make_vec4(clamped_local_pos, 0.f, 1.f));
 vec2 device_pos = ((world_pos).sel(X, Y))*((task).device_pixel_scale);
 vec2_scalar final_offset = (-((task).content_origin))+((((task).common_data).task_rect).p0);
 gl_Position = (uTransform)*(make_vec4((device_pos)+((final_offset)*((world_pos).sel(W))), (z)*((world_pos).sel(W)), (world_pos).sel(W)));
 VertexInfo vi = VertexInfo(clamped_local_pos, world_pos);
 return vi;
}
RectWithEndpoint_scalar to_rect_with_endpoint(RectWithSize_scalar rect) {
 RectWithEndpoint_scalar result;
 (result).p0 = (rect).p0;
 (result).p1 = ((rect).p0)+((rect).size);
 return result;
}
void init_transform_vs(vec4_scalar local_bounds) {
 vTransformBounds = local_bounds;
}
VertexInfo write_transform_vertex(RectWithSize_scalar local_segment_rect, RectWithSize_scalar local_prim_rect, RectWithSize_scalar local_clip_rect, vec4_scalar clip_edge_mask, float z, Transform_scalar transform, PictureTask_scalar task) {
 RectWithEndpoint_scalar clip_rect = to_rect_with_endpoint(local_clip_rect);
 RectWithEndpoint_scalar segment_rect = to_rect_with_endpoint(local_segment_rect);
 (segment_rect).p0 = clamp((segment_rect).p0, (clip_rect).p0, (clip_rect).p1);
 (segment_rect).p1 = clamp((segment_rect).p1, (clip_rect).p0, (clip_rect).p1);
 RectWithEndpoint_scalar prim_rect = to_rect_with_endpoint(local_prim_rect);
 (prim_rect).p0 = clamp((prim_rect).p0, (clip_rect).p0, (clip_rect).p1);
 (prim_rect).p1 = clamp((prim_rect).p1, (clip_rect).p0, (clip_rect).p1);
 float extrude_amount = 2.f;
 vec4_scalar extrude_distance = (make_vec4(extrude_amount))*(clip_edge_mask);
 (local_segment_rect).p0 -= (extrude_distance).sel(X, Y);
 (local_segment_rect).size += ((extrude_distance).sel(X, Y))+((extrude_distance).sel(Z, W));
 vec2 local_pos = ((local_segment_rect).p0)+(((local_segment_rect).size)*((aPosition).sel(X, Y)));
 vec2_scalar task_offset = ((((task).common_data).task_rect).p0)-((task).content_origin);
 vec4 world_pos = ((transform).m)*(make_vec4(local_pos, 0.f, 1.f));
 vec4 final_pos = make_vec4((((world_pos).sel(X, Y))*((task).device_pixel_scale))+((task_offset)*((world_pos).sel(W))), (z)*((world_pos).sel(W)), (world_pos).sel(W));
 gl_Position = (uTransform)*(final_pos);
 init_transform_vs(mix(make_vec4((prim_rect).p0, (prim_rect).p1), make_vec4((segment_rect).p0, (segment_rect).p1), clip_edge_mask));
 VertexInfo vi = VertexInfo(local_pos, world_pos);
 return vi;
}
Array<vec4_scalar,3> fetch_from_gpu_cache_3(int32_t address) {
 ivec2_scalar uv = get_gpu_cache_uv(address);
 vec4_scalar* sGpuCache_uv_fetch = texelFetchPtr(sGpuCache, uv, 0, 2, 0, 0);
 return Array<vec4_scalar,3>{{sGpuCache_uv_fetch[0], sGpuCache_uv_fetch[1], sGpuCache_uv_fetch[2]}};
}
ImageBrushData_scalar fetch_image_data(int32_t address) {
 Array<vec4_scalar,3> raw_data = fetch_from_gpu_cache_3(address);
 ImageBrushData_scalar data = ImageBrushData_scalar(raw_data[0], raw_data[1], (raw_data[2]).sel(X, Y));
 return data;
}
ImageResource_scalar fetch_image_resource(int32_t address) {
 Array<vec4_scalar,2> data = fetch_from_gpu_cache_2(address);
 RectWithEndpoint_scalar uv_rect = RectWithEndpoint_scalar((data[0]).sel(X, Y), (data[0]).sel(Z, W));
 return ImageResource_scalar(uv_rect, (data[1]).sel(X), (data[1]).sel(Y, Z, W));
}
void image_brush_vs(VertexInfo vi, int32_t prim_address, RectWithSize_scalar prim_rect, RectWithSize_scalar segment_rect, ivec4_scalar prim_user_data, int32_t specific_resource_address, mat4_scalar transform, PictureTask_scalar pic_task, int32_t brush_flags, vec4_scalar segment_data) {
 ImageBrushData_scalar image_data = fetch_image_data(prim_address);
 vec2_scalar texture_size = make_vec2(1, 1);
 ImageResource_scalar res = fetch_image_resource(specific_resource_address);
 vec2_scalar uv0 = ((res).uv_rect).p0;
 vec2_scalar uv1 = ((res).uv_rect).p1;
 RectWithSize_scalar local_rect = prim_rect;
 vec2_scalar stretch_size = (image_data).stretch_size;
 if (((stretch_size).sel(X))<(0.f)) {
  {
   stretch_size = (local_rect).size;
  }
 }
 if (((brush_flags)&(2))!=(0)) {
  {
   local_rect = segment_rect;
   stretch_size = (local_rect).size;
   if (((brush_flags)&(128))!=(0)) {
    {
     vec2_scalar uv_size = (((res).uv_rect).p1)-(((res).uv_rect).p0);
     uv0 = (((res).uv_rect).p0)+(((segment_data).sel(X, Y))*(uv_size));
     uv1 = (((res).uv_rect).p0)+(((segment_data).sel(Z, W))*(uv_size));
     vec2_scalar segment_uv_size = (uv1)-(uv0);
    }
   } else    {
   }
  }
 }
 float perspective_interpolate = ((brush_flags)&(1))!=(0) ? 1.f : 0.f;
 (flat_varying_vec4_4).sel(X) = (res).layer;
 (flat_varying_vec4_4).sel(Y) = perspective_interpolate;
 vec2_scalar min_uv = min(uv0, uv1);
 vec2_scalar max_uv = max(uv0, uv1);
 flat_varying_vec4_3 = (make_vec4((min_uv)+(make_vec2(0.5f)), (max_uv)-(make_vec2(0.5f))))/((texture_size).sel(X, Y, X, Y));
 vec2 f = (((vi).local_pos)-((local_rect).p0))/((local_rect).size);
 vec2_scalar repeat = ((local_rect).size)/(stretch_size);
 (varying_vec4_0).lsel(Z, W) = (mix(uv0, uv1, f))-(min_uv);
 (varying_vec4_0).lsel(Z, W) /= texture_size;
 (varying_vec4_0).lsel(Z, W) *= (repeat).sel(X, Y);
 if ((perspective_interpolate)==(0.f)) {
  {
   (varying_vec4_0).lsel(Z, W) *= ((vi).world_pos).sel(W);
  }
 }
 flat_varying_vec4_2 = make_vec4(0.f, 0.f, make_vec2(textureSize(sColor0)));
}
void brush_shader_main_vs(Instance_scalar instance, PrimitiveHeader_scalar ph, Transform_scalar transform, PictureTask_scalar pic_task, ClipArea_scalar clip_area) {
 int32_t edge_flags = ((instance).flags)&(255);
 int32_t brush_flags = (((instance).flags)>>(8))&(255);
 vec4_scalar segment_data;
 RectWithSize_scalar segment_rect;
 if (((instance).segment_index)==(65535)) {
  {
   segment_rect = (ph).local_rect;
   segment_data = make_vec4(0.f);
  }
 } else  {
  int32_t segment_address = (((ph).specific_prim_address)+(3))+(((instance).segment_index)*(2));
  Array<vec4_scalar,2> segment_info = fetch_from_gpu_cache_2(segment_address);
  segment_rect = RectWithSize_scalar((segment_info[0]).sel(X, Y), (segment_info[0]).sel(Z, W));
  (segment_rect).p0 += ((ph).local_rect).p0;
  segment_data = segment_info[1];
 }
 VertexInfo vi;
 if ((transform).is_axis_aligned) {
  {
   vec2 local_pos = ((segment_rect).p0)+(((segment_rect).size)*((aPosition).sel(X, Y)));
   vi = write_vertex(local_pos, (ph).local_clip_rect, (ph).z, transform, pic_task);
  }
 } else  {
  bvec4_scalar edge_mask = notEqual((edge_flags)&(make_ivec4(1, 2, 4, 8)), make_ivec4(0));
  vi = write_transform_vertex(segment_rect, (ph).local_rect, (ph).local_clip_rect, mix(make_vec4(0.f), make_vec4(1.f), edge_mask), (ph).z, transform, pic_task);
 }
 image_brush_vs(vi, (ph).specific_prim_address, (ph).local_rect, segment_rect, (ph).user_data, (instance).resource_address, (transform).m, pic_task, brush_flags, segment_data);
}
ALWAYS_INLINE void main(void) {
 Instance_scalar instance = decode_instance_attributes();
 PrimitiveHeader_scalar ph = fetch_prim_header((instance).prim_header_address);
 Transform_scalar transform = fetch_transform((ph).transform_id);
 PictureTask_scalar task = fetch_picture_task((instance).picture_task_address);
 ClipArea_scalar clip_area = fetch_clip_area((instance).clip_address);
 brush_shader_main_vs(instance, ph, transform, task, clip_area);
}
static void set_uniform_1i(Self *self, int index, int value) {
 if (self->samplers.set_slot(index, value)) return;
 switch (index) {
 case 7:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 8:
  assert(0); // sPrevPassAlpha
  break;
 case 4:
  assert(0); // sPrimitiveHeadersF
  break;
 case 5:
  assert(0); // sPrimitiveHeadersI
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 6:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 7:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 8:
  assert(0); // sPrevPassAlpha
  break;
 case 4:
  assert(0); // sPrimitiveHeadersF
  break;
 case 5:
  assert(0); // sPrimitiveHeadersI
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 6:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 7:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sGpuCache
  break;
 case 8:
  assert(0); // sPrevPassAlpha
  break;
 case 4:
  assert(0); // sPrimitiveHeadersF
  break;
 case 5:
  assert(0); // sPrimitiveHeadersI
  break;
 case 1:
  assert(0); // sRenderTasks
  break;
 case 3:
  assert(0); // sTransformPalette
  break;
 case 6:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, VertexAttrib *attribs, uint32_t start, int instance, int count) {
 load_attrib(self->aPosition, attribs[self->attrib_locations.aPosition], start, instance, count);
 load_flat_attrib(self->aData, attribs[self->attrib_locations.aData], start, instance, count);
}
public:
struct InterpOutputs {
vec4_scalar vClipMaskUv;
vec4_scalar varying_vec4_0;
};
private:
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vClipMaskUv = get_nth(vClipMaskUv, n);
    dest->varying_vec4_0 = get_nth(varying_vec4_0, n);
    dest_ptr += stride;
  }
}
static void run(Self* self, char* interps, size_t interp_stride) {
 self->main();
 self->store_interp_outputs(interps, interp_stride);
}
static void init_batch(Self *self) { self->bind_textures(); }
public:
brush_image_TEXTURE_RECT_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&init_batch;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_primitive_func = (RunPrimitiveFunc)&run;
}
};


struct brush_image_TEXTURE_RECT_frag : FragmentShaderImpl, brush_image_TEXTURE_RECT_vert {
private:
typedef brush_image_TEXTURE_RECT_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
// sampler2DRect sColor0;
// sampler2DRect sColor1;
// sampler2DRect sColor2;
struct RectWithSize_scalar {
vec2_scalar p0;
vec2_scalar size;
RectWithSize_scalar() = default;
RectWithSize_scalar(vec2_scalar p0, vec2_scalar size) : p0(p0), size(size){}
};
struct RectWithSize {
vec2 p0;
vec2 size;
RectWithSize() = default;
RectWithSize(vec2 p0, vec2 size) : p0(p0), size(size){}
RectWithSize(vec2_scalar p0, vec2_scalar size):p0(p0),size(size){
}
IMPLICIT RectWithSize(RectWithSize_scalar s):p0(s.p0),size(s.size){
}
friend RectWithSize if_then_else(I32 c, RectWithSize t, RectWithSize e) { return RectWithSize(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.size, e.size));
}};
struct RectWithEndpoint_scalar {
vec2_scalar p0;
vec2_scalar p1;
RectWithEndpoint_scalar() = default;
RectWithEndpoint_scalar(vec2_scalar p0, vec2_scalar p1) : p0(p0), p1(p1){}
};
struct RectWithEndpoint {
vec2 p0;
vec2 p1;
RectWithEndpoint() = default;
RectWithEndpoint(vec2 p0, vec2 p1) : p0(p0), p1(p1){}
RectWithEndpoint(vec2_scalar p0, vec2_scalar p1):p0(p0),p1(p1){
}
IMPLICIT RectWithEndpoint(RectWithEndpoint_scalar s):p0(s.p0),p1(s.p1){
}
friend RectWithEndpoint if_then_else(I32 c, RectWithEndpoint t, RectWithEndpoint e) { return RectWithEndpoint(
if_then_else(c, t.p0, e.p0), if_then_else(c, t.p1, e.p1));
}};
// sampler2D sGpuCache;
// vec4_scalar vTransformBounds;
// sampler2DArray sPrevPassAlpha;
// sampler2DArray sPrevPassColor;
// vec4_scalar vClipMaskUvBounds;
vec4 vClipMaskUv;
struct Fragment_scalar {
vec4_scalar color;
Fragment_scalar() = default;
explicit Fragment_scalar(vec4_scalar color) : color(color){}
};
struct Fragment {
vec4 color;
Fragment() = default;
explicit Fragment(vec4 color) : color(color){}
explicit Fragment(vec4_scalar color):color(color){
}
IMPLICIT Fragment(Fragment_scalar s):color(s.color){
}
friend Fragment if_then_else(I32 c, Fragment t, Fragment e) { return Fragment(
if_then_else(c, t.color, e.color));
}};
// vec4_scalar flat_varying_vec4_0;
// vec4_scalar flat_varying_vec4_1;
// vec4_scalar flat_varying_vec4_2;
// vec4_scalar flat_varying_vec4_3;
// vec4_scalar flat_varying_vec4_4;
// ivec4_scalar flat_varying_ivec4_0;
vec4 varying_vec4_0;
vec4 varying_vec4_1;
// int32_t flat_varying_highp_int_address_0;
Fragment image_brush_fs() {
 Float perspective_divisor = mix((gl_FragCoord).sel(W), 1.f, (flat_varying_vec4_4).sel(Y));
 vec2 repeated_uv = (((varying_vec4_0).sel(Z, W))*(perspective_divisor))+((flat_varying_vec4_2).sel(X, Y));
 vec2 uv = clamp(repeated_uv, (flat_varying_vec4_3).sel(X, Y), (flat_varying_vec4_3).sel(Z, W));
 vec4 texel = texture(sColor0, (make_vec3(uv, (flat_varying_vec4_4).sel(X))).sel(X, Y));
 Fragment frag;
 (frag).color = texel;
 return frag;
}
void write_output(vec4 color) {
 oFragColor = color;
}
ALWAYS_INLINE void main(void) {
 Fragment frag = image_brush_fs();
 write_output((frag).color);
}
typedef brush_image_TEXTURE_RECT_vert::InterpOutputs InterpInputs;
InterpInputs interp_step;
struct InterpPerspective {
vec4 varying_vec4_0;
};
InterpPerspective interp_perspective;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->varying_vec4_0 = init_interp(init->varying_vec4_0, step->varying_vec4_0);
  self->interp_step.varying_vec4_0 = step->varying_vec4_0 * step_width;
}
static void read_perspective_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  Float w = 1.0f / self->gl_FragCoord.w;
  self->interp_perspective.varying_vec4_0 = init_interp(init->varying_vec4_0, step->varying_vec4_0);
  self->varying_vec4_0 = self->interp_perspective.varying_vec4_0 * w;
  self->interp_step.varying_vec4_0 = step->varying_vec4_0 * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  varying_vec4_0 += interp_step.varying_vec4_0;
}
ALWAYS_INLINE void step_perspective_inputs() {
  step_perspective();
  Float w = 1.0f / gl_FragCoord.w;
  interp_perspective.varying_vec4_0 += interp_step.varying_vec4_0;
  varying_vec4_0 = w * interp_perspective.varying_vec4_0;
}
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
static void run_perspective(Self *self) {
 self->main();
 self->step_perspective_inputs();
}
static void skip_perspective(Self* self, int chunks) {
 self->step_perspective_inputs();
 while (--chunks > 0) self->step_perspective_inputs();
}
public:
brush_image_TEXTURE_RECT_frag() {
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 enable_perspective();
 init_span_w_func = (InitSpanWFunc)&read_perspective_inputs;
 run_w_func = (RunWFunc)&run_perspective;
 skip_w_func = (SkipWFunc)&skip_perspective;
}
};

struct brush_image_TEXTURE_RECT_program : ProgramImpl, brush_image_TEXTURE_RECT_frag {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 7; }
 if (strcmp("sGpuCache", name) == 0) { return 2; }
 if (strcmp("sPrevPassAlpha", name) == 0) { return 8; }
 if (strcmp("sPrimitiveHeadersF", name) == 0) { return 4; }
 if (strcmp("sPrimitiveHeadersI", name) == 0) { return 5; }
 if (strcmp("sRenderTasks", name) == 0) { return 1; }
 if (strcmp("sTransformPalette", name) == 0) { return 3; }
 if (strcmp("uTransform", name) == 0) { return 6; }
 return -1;
}
void bind_attrib(const char* name, int index) override {
 attrib_locations.bind_loc(name, index);
}
int get_attrib(const char* name) const override {
 return attrib_locations.get_loc(name);
}
size_t interpolants_size() const override { return sizeof(InterpOutputs); }
VertexShaderImpl* get_vertex_shader() override {
 return this;
}
FragmentShaderImpl* get_fragment_shader() override {
 return this;
}
static ProgramImpl* loader() { return new brush_image_TEXTURE_RECT_program; }
};

