struct composite_TEXTURE_2D_common {
struct Samplers {
 sampler2D_impl sColor0_impl;
 int sColor0_slot;
 sampler2D_impl sColor1_impl;
 int sColor1_slot;
 sampler2D_impl sColor2_impl;
 int sColor2_slot;
 bool set_slot(int index, int value) {
  switch (index) {
  case 1:
   sColor0_slot = value;
   return true;
  case 3:
   sColor1_slot = value;
   return true;
  case 4:
   sColor2_slot = value;
   return true;
  }
  return false;
 }
} samplers;
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aDeviceRect = NULL_ATTRIB;
 int aDeviceClipRect = NULL_ATTRIB;
 int aColor = NULL_ATTRIB;
 int aParams = NULL_ATTRIB;
 int aTextureLayers = NULL_ATTRIB;
 int aUvRect0 = NULL_ATTRIB;
 void bind_loc(const char* name, int index) {
  if (strcmp("aPosition", name) == 0) { aPosition = index; return; }
  if (strcmp("aDeviceRect", name) == 0) { aDeviceRect = index; return; }
  if (strcmp("aDeviceClipRect", name) == 0) { aDeviceClipRect = index; return; }
  if (strcmp("aColor", name) == 0) { aColor = index; return; }
  if (strcmp("aParams", name) == 0) { aParams = index; return; }
  if (strcmp("aTextureLayers", name) == 0) { aTextureLayers = index; return; }
  if (strcmp("aUvRect0", name) == 0) { aUvRect0 = index; return; }
 }
 int get_loc(const char* name) const {
  if (strcmp("aPosition", name) == 0) { return aPosition != NULL_ATTRIB ? aPosition : -1; }
  if (strcmp("aDeviceRect", name) == 0) { return aDeviceRect != NULL_ATTRIB ? aDeviceRect : -1; }
  if (strcmp("aDeviceClipRect", name) == 0) { return aDeviceClipRect != NULL_ATTRIB ? aDeviceClipRect : -1; }
  if (strcmp("aColor", name) == 0) { return aColor != NULL_ATTRIB ? aColor : -1; }
  if (strcmp("aParams", name) == 0) { return aParams != NULL_ATTRIB ? aParams : -1; }
  if (strcmp("aTextureLayers", name) == 0) { return aTextureLayers != NULL_ATTRIB ? aTextureLayers : -1; }
  if (strcmp("aUvRect0", name) == 0) { return aUvRect0 != NULL_ATTRIB ? aUvRect0 : -1; }
  return -1;
 }
} attrib_locations;
vec4_scalar vColor;
float vLayer;
vec4_scalar vUVBounds;
sampler2D sColor0;
sampler2D sColor1;
sampler2D sColor2;
mat4_scalar uTransform;
void bind_textures() {
 sColor0 = lookup_sampler(&samplers.sColor0_impl, samplers.sColor0_slot);
 sColor1 = lookup_sampler(&samplers.sColor1_impl, samplers.sColor1_slot);
 sColor2 = lookup_sampler(&samplers.sColor2_impl, samplers.sColor2_slot);
}
};
struct composite_TEXTURE_2D_vert : VertexShaderImpl, composite_TEXTURE_2D_common {
private:
typedef composite_TEXTURE_2D_vert Self;
// int32_t uMode;
// mat4_scalar uTransform;
vec2 aPosition;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
mat3_scalar static constexpr YuvColorMatrixRec601 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.39176f), 2.01723f, 1.59603f, -(0.81297f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec709 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.21325f), 2.1124f, 1.79274f, -(0.53291f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec2020 = make_mat3(1.16438356164384f, 1.16438356164384f, 1.16438356164384f, 0.f, -(0.187326104219343f), 2.14177232142857f, 1.67867410714286f, -(0.650424318505057f), 0.f);
// vec4_scalar vColor;
// float vLayer;
vec2 vUv;
// vec4_scalar vUVBounds;
vec4_scalar aDeviceRect;
vec4_scalar aDeviceClipRect;
vec4_scalar aColor;
vec4_scalar aParams;
vec3_scalar aTextureLayers;
vec4_scalar aUvRect0;
ALWAYS_INLINE void main(void) {
 vec2 world_pos = ((aDeviceRect).sel(X, Y))+(((aPosition).sel(X, Y))*((aDeviceRect).sel(Z, W)));
 vec2 clipped_world_pos = clamp(world_pos, (aDeviceClipRect).sel(X, Y), ((aDeviceClipRect).sel(X, Y))+((aDeviceClipRect).sel(Z, W)));
 vec2 uv = ((clipped_world_pos)-((aDeviceRect).sel(X, Y)))/((aDeviceRect).sel(Z, W));
 vUv = mix((aUvRect0).sel(X, Y), (aUvRect0).sel(Z, W), uv);
 vUVBounds = make_vec4((aUvRect0).sel(X), min((aUvRect0).sel(Y), (aUvRect0).sel(W)), (aUvRect0).sel(Z), max((aUvRect0).sel(Y), (aUvRect0).sel(W)));
 int32_t rescale_uv = make_int((aParams).sel(Y));
 if ((rescale_uv)==(1)) {
  {
   vec2_scalar texture_size = make_vec2((textureSize(sColor0, 0)).sel(X, Y));
   vUVBounds += make_vec4(0.5f, 0.5f, -(0.5f), -(0.5f));
   vUv /= texture_size;
   vUVBounds /= (texture_size).sel(X, Y, X, Y);
  }
 }
 vColor = aColor;
 vLayer = (aTextureLayers).sel(X);
 gl_Position = (uTransform)*(make_vec4(clipped_world_pos, (aParams).sel(X), 1.f));
}
static void set_uniform_1i(Self *self, int index, int value) {
 if (self->samplers.set_slot(index, value)) return;
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 case 2:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 case 2:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 3:
  assert(0); // sColor1
  break;
 case 4:
  assert(0); // sColor2
  break;
 case 2:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, VertexAttrib *attribs, uint32_t start, int instance, int count) {
 load_attrib(self->aPosition, attribs[self->attrib_locations.aPosition], start, instance, count);
 load_flat_attrib(self->aDeviceRect, attribs[self->attrib_locations.aDeviceRect], start, instance, count);
 load_flat_attrib(self->aDeviceClipRect, attribs[self->attrib_locations.aDeviceClipRect], start, instance, count);
 load_flat_attrib(self->aColor, attribs[self->attrib_locations.aColor], start, instance, count);
 load_flat_attrib(self->aParams, attribs[self->attrib_locations.aParams], start, instance, count);
 load_flat_attrib(self->aTextureLayers, attribs[self->attrib_locations.aTextureLayers], start, instance, count);
 load_flat_attrib(self->aUvRect0, attribs[self->attrib_locations.aUvRect0], start, instance, count);
}
public:
struct InterpOutputs {
vec2_scalar vUv;
};
private:
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vUv = get_nth(vUv, n);
    dest_ptr += stride;
  }
}
static void run(Self* self, char* interps, size_t interp_stride) {
 self->main();
 self->store_interp_outputs(interps, interp_stride);
}
static void init_batch(Self *self) { self->bind_textures(); }
public:
composite_TEXTURE_2D_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&init_batch;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_primitive_func = (RunPrimitiveFunc)&run;
}
};

mat3_scalar constexpr composite_TEXTURE_2D_vert::YuvColorMatrixRec601;
mat3_scalar constexpr composite_TEXTURE_2D_vert::YuvColorMatrixRec709;
mat3_scalar constexpr composite_TEXTURE_2D_vert::YuvColorMatrixRec2020;

struct composite_TEXTURE_2D_frag : FragmentShaderImpl, composite_TEXTURE_2D_vert {
private:
typedef composite_TEXTURE_2D_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
// vec4_scalar vColor;
// float vLayer;
vec2 vUv;
// vec4_scalar vUVBounds;
void write_output(vec4 color) {
 oFragColor = color;
}
ALWAYS_INLINE void main(void) {
 vec2 uv = clamp((vUv).sel(X, Y), (vUVBounds).sel(X, Y), (vUVBounds).sel(Z, W));
 vec4 texel = texture(sColor0, (make_vec3(uv, vLayer)).sel(X, Y));
 vec4 color = (vColor)*(texel);
 write_output(color);
}
typedef composite_TEXTURE_2D_vert::InterpOutputs InterpInputs;
InterpInputs interp_step;
struct InterpPerspective {
vec2 vUv;
};
InterpPerspective interp_perspective;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->vUv = init_interp(init->vUv, step->vUv);
  self->interp_step.vUv = step->vUv * step_width;
}
static void read_perspective_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  Float w = 1.0f / self->gl_FragCoord.w;
  self->interp_perspective.vUv = init_interp(init->vUv, step->vUv);
  self->vUv = self->interp_perspective.vUv * w;
  self->interp_step.vUv = step->vUv * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  vUv += interp_step.vUv;
}
ALWAYS_INLINE void step_perspective_inputs() {
  step_perspective();
  Float w = 1.0f / gl_FragCoord.w;
  interp_perspective.vUv += interp_step.vUv;
  vUv = w * interp_perspective.vUv;
}
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
static void run_perspective(Self *self) {
 self->main();
 self->step_perspective_inputs();
}
static void skip_perspective(Self* self, int chunks) {
 self->step_perspective_inputs();
 while (--chunks > 0) self->step_perspective_inputs();
}
public:
composite_TEXTURE_2D_frag() {
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 enable_perspective();
 init_span_w_func = (InitSpanWFunc)&read_perspective_inputs;
 run_w_func = (RunWFunc)&run_perspective;
 skip_w_func = (SkipWFunc)&skip_perspective;
}
};

struct composite_TEXTURE_2D_program : ProgramImpl, composite_TEXTURE_2D_frag {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 1; }
 if (strcmp("sColor1", name) == 0) { return 3; }
 if (strcmp("sColor2", name) == 0) { return 4; }
 if (strcmp("uTransform", name) == 0) { return 2; }
 return -1;
}
void bind_attrib(const char* name, int index) override {
 attrib_locations.bind_loc(name, index);
}
int get_attrib(const char* name) const override {
 return attrib_locations.get_loc(name);
}
size_t interpolants_size() const override { return sizeof(InterpOutputs); }
VertexShaderImpl* get_vertex_shader() override {
 return this;
}
FragmentShaderImpl* get_fragment_shader() override {
 return this;
}
static ProgramImpl* loader() { return new composite_TEXTURE_2D_program; }
};

