struct composite_YUV_TEXTURE_2D_common {
struct Samplers {
 sampler2D_impl sColor0_impl;
 int sColor0_slot;
 sampler2D_impl sColor1_impl;
 int sColor1_slot;
 sampler2D_impl sColor2_impl;
 int sColor2_slot;
 bool set_slot(int index, int value) {
  switch (index) {
  case 1:
   sColor0_slot = value;
   return true;
  case 2:
   sColor1_slot = value;
   return true;
  case 3:
   sColor2_slot = value;
   return true;
  }
  return false;
 }
} samplers;
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aDeviceRect = NULL_ATTRIB;
 int aDeviceClipRect = NULL_ATTRIB;
 int aParams = NULL_ATTRIB;
 int aTextureLayers = NULL_ATTRIB;
 int aUvRect0 = NULL_ATTRIB;
 int aUvRect1 = NULL_ATTRIB;
 int aUvRect2 = NULL_ATTRIB;
 void bind_loc(const char* name, int index) {
  if (strcmp("aPosition", name) == 0) { aPosition = index; return; }
  if (strcmp("aDeviceRect", name) == 0) { aDeviceRect = index; return; }
  if (strcmp("aDeviceClipRect", name) == 0) { aDeviceClipRect = index; return; }
  if (strcmp("aParams", name) == 0) { aParams = index; return; }
  if (strcmp("aTextureLayers", name) == 0) { aTextureLayers = index; return; }
  if (strcmp("aUvRect0", name) == 0) { aUvRect0 = index; return; }
  if (strcmp("aUvRect1", name) == 0) { aUvRect1 = index; return; }
  if (strcmp("aUvRect2", name) == 0) { aUvRect2 = index; return; }
 }
 int get_loc(const char* name) const {
  if (strcmp("aPosition", name) == 0) { return aPosition != NULL_ATTRIB ? aPosition : -1; }
  if (strcmp("aDeviceRect", name) == 0) { return aDeviceRect != NULL_ATTRIB ? aDeviceRect : -1; }
  if (strcmp("aDeviceClipRect", name) == 0) { return aDeviceClipRect != NULL_ATTRIB ? aDeviceClipRect : -1; }
  if (strcmp("aParams", name) == 0) { return aParams != NULL_ATTRIB ? aParams : -1; }
  if (strcmp("aTextureLayers", name) == 0) { return aTextureLayers != NULL_ATTRIB ? aTextureLayers : -1; }
  if (strcmp("aUvRect0", name) == 0) { return aUvRect0 != NULL_ATTRIB ? aUvRect0 : -1; }
  if (strcmp("aUvRect1", name) == 0) { return aUvRect1 != NULL_ATTRIB ? aUvRect1 : -1; }
  if (strcmp("aUvRect2", name) == 0) { return aUvRect2 != NULL_ATTRIB ? aUvRect2 : -1; }
  return -1;
 }
} attrib_locations;
mat3_scalar vYuvColorMatrix;
float vYuvCoefficient;
int32_t vYuvFormat;
vec3_scalar vYuvLayers;
vec4_scalar vUVBounds_y;
vec4_scalar vUVBounds_u;
vec4_scalar vUVBounds_v;
sampler2D sColor0;
sampler2D sColor1;
sampler2D sColor2;
mat4_scalar uTransform;
void bind_textures() {
 sColor0 = lookup_sampler(&samplers.sColor0_impl, samplers.sColor0_slot);
 sColor1 = lookup_sampler(&samplers.sColor1_impl, samplers.sColor1_slot);
 sColor2 = lookup_sampler(&samplers.sColor2_impl, samplers.sColor2_slot);
}
};
struct composite_YUV_TEXTURE_2D_vert : VertexShaderImpl, composite_YUV_TEXTURE_2D_common {
private:
typedef composite_YUV_TEXTURE_2D_vert Self;
// int32_t uMode;
// mat4_scalar uTransform;
vec2 aPosition;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
mat3_scalar static constexpr YuvColorMatrixRec601 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.39176f), 2.01723f, 1.59603f, -(0.81297f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec709 = make_mat3(1.16438f, 1.16438f, 1.16438f, 0.f, -(0.21325f), 2.1124f, 1.79274f, -(0.53291f), 0.f);
mat3_scalar static constexpr YuvColorMatrixRec2020 = make_mat3(1.16438356164384f, 1.16438356164384f, 1.16438356164384f, 0.f, -(0.187326104219343f), 2.14177232142857f, 1.67867410714286f, -(0.650424318505057f), 0.f);
// mat3_scalar vYuvColorMatrix;
// float vYuvCoefficient;
// int32_t vYuvFormat;
// vec3_scalar vYuvLayers;
vec2 vUV_y;
vec2 vUV_u;
vec2 vUV_v;
// vec4_scalar vUVBounds_y;
// vec4_scalar vUVBounds_u;
// vec4_scalar vUVBounds_v;
vec4_scalar aDeviceRect;
vec4_scalar aDeviceClipRect;
vec4_scalar aColor;
vec4_scalar aParams;
vec3_scalar aTextureLayers;
vec4_scalar aUvRect0;
vec4_scalar aUvRect1;
vec4_scalar aUvRect2;
mat3_scalar get_yuv_color_matrix(int32_t color_space) {
 switch (color_space) {
  case 0:
   return YuvColorMatrixRec601;
  case 1:
   return YuvColorMatrixRec709;
  default:
   return YuvColorMatrixRec2020;
 }
}
void write_uv_rect(vec2_scalar uv0, vec2_scalar uv1, vec2 f, vec2_scalar texture_size, vec2& uv, vec4_scalar& uv_bounds) {
 uv = mix(uv0, uv1, f);
 uv_bounds = make_vec4((uv0)+(make_vec2(0.5f)), (uv1)-(make_vec2(0.5f)));
 uv /= texture_size;
 uv_bounds /= (texture_size).sel(X, Y, X, Y);
}
ALWAYS_INLINE void main(void) {
 vec2 world_pos = ((aDeviceRect).sel(X, Y))+(((aPosition).sel(X, Y))*((aDeviceRect).sel(Z, W)));
 vec2 clipped_world_pos = clamp(world_pos, (aDeviceClipRect).sel(X, Y), ((aDeviceClipRect).sel(X, Y))+((aDeviceClipRect).sel(Z, W)));
 vec2 uv = ((clipped_world_pos)-((aDeviceRect).sel(X, Y)))/((aDeviceRect).sel(Z, W));
 int32_t yuv_color_space = make_int((aParams).sel(Y));
 int32_t yuv_format = make_int((aParams).sel(Z));
 float yuv_coefficient = (aParams).sel(W);
 vYuvColorMatrix = get_yuv_color_matrix(yuv_color_space);
 vYuvCoefficient = yuv_coefficient;
 vYuvFormat = yuv_format;
 vYuvLayers = (aTextureLayers).sel(X, Y, Z);
 write_uv_rect((aUvRect0).sel(X, Y), (aUvRect0).sel(Z, W), uv, make_vec2((textureSize(sColor0, 0)).sel(X, Y)), vUV_y, vUVBounds_y);
 write_uv_rect((aUvRect1).sel(X, Y), (aUvRect1).sel(Z, W), uv, make_vec2((textureSize(sColor1, 0)).sel(X, Y)), vUV_u, vUVBounds_u);
 write_uv_rect((aUvRect2).sel(X, Y), (aUvRect2).sel(Z, W), uv, make_vec2((textureSize(sColor2, 0)).sel(X, Y)), vUV_v, vUVBounds_v);
 gl_Position = (uTransform)*(make_vec4(clipped_world_pos, (aParams).sel(X), 1.f));
}
static void set_uniform_1i(Self *self, int index, int value) {
 if (self->samplers.set_slot(index, value)) return;
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sColor1
  break;
 case 3:
  assert(0); // sColor2
  break;
 case 4:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sColor1
  break;
 case 3:
  assert(0); // sColor2
  break;
 case 4:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // sColor0
  break;
 case 2:
  assert(0); // sColor1
  break;
 case 3:
  assert(0); // sColor2
  break;
 case 4:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, VertexAttrib *attribs, uint32_t start, int instance, int count) {
 load_attrib(self->aPosition, attribs[self->attrib_locations.aPosition], start, instance, count);
 load_flat_attrib(self->aDeviceRect, attribs[self->attrib_locations.aDeviceRect], start, instance, count);
 load_flat_attrib(self->aDeviceClipRect, attribs[self->attrib_locations.aDeviceClipRect], start, instance, count);
 load_flat_attrib(self->aParams, attribs[self->attrib_locations.aParams], start, instance, count);
 load_flat_attrib(self->aTextureLayers, attribs[self->attrib_locations.aTextureLayers], start, instance, count);
 load_flat_attrib(self->aUvRect0, attribs[self->attrib_locations.aUvRect0], start, instance, count);
 load_flat_attrib(self->aUvRect1, attribs[self->attrib_locations.aUvRect1], start, instance, count);
 load_flat_attrib(self->aUvRect2, attribs[self->attrib_locations.aUvRect2], start, instance, count);
}
public:
struct InterpOutputs {
vec2_scalar vUV_y;
vec2_scalar vUV_u;
vec2_scalar vUV_v;
};
private:
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vUV_y = get_nth(vUV_y, n);
    dest->vUV_u = get_nth(vUV_u, n);
    dest->vUV_v = get_nth(vUV_v, n);
    dest_ptr += stride;
  }
}
static void run(Self* self, char* interps, size_t interp_stride) {
 self->main();
 self->store_interp_outputs(interps, interp_stride);
}
static void init_batch(Self *self) { self->bind_textures(); }
public:
composite_YUV_TEXTURE_2D_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&init_batch;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_primitive_func = (RunPrimitiveFunc)&run;
}
};

mat3_scalar constexpr composite_YUV_TEXTURE_2D_vert::YuvColorMatrixRec601;
mat3_scalar constexpr composite_YUV_TEXTURE_2D_vert::YuvColorMatrixRec709;
mat3_scalar constexpr composite_YUV_TEXTURE_2D_vert::YuvColorMatrixRec2020;

struct composite_YUV_TEXTURE_2D_frag : FragmentShaderImpl, composite_YUV_TEXTURE_2D_vert {
private:
typedef composite_YUV_TEXTURE_2D_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
// sampler2D sColor0;
// sampler2D sColor1;
// sampler2D sColor2;
// mat3_scalar vYuvColorMatrix;
// float vYuvCoefficient;
// int32_t vYuvFormat;
// vec3_scalar vYuvLayers;
vec2 vUV_y;
vec2 vUV_u;
vec2 vUV_v;
// vec4_scalar vUVBounds_y;
// vec4_scalar vUVBounds_u;
// vec4_scalar vUVBounds_v;
vec4 sample_yuv(int32_t format, mat3_scalar yuv_color_matrix, float coefficient, vec3_scalar yuv_layers, vec2 in_uv_y, vec2 in_uv_u, vec2 in_uv_v, vec4_scalar uv_bounds_y, vec4_scalar uv_bounds_u, vec4_scalar uv_bounds_v) {
 vec3 yuv_value;
 switch (format) {
  case 1:
   {
    vec2 uv_y = clamp(in_uv_y, (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    vec2 uv_u = clamp(in_uv_u, (uv_bounds_u).sel(X, Y), (uv_bounds_u).sel(Z, W));
    vec2 uv_v = clamp(in_uv_v, (uv_bounds_v).sel(X, Y), (uv_bounds_v).sel(Z, W));
    (yuv_value).sel(X) = (texture(sColor0, (make_vec3(uv_y, (yuv_layers).sel(X))).sel(X, Y))).sel(R);
    (yuv_value).sel(Y) = (texture(sColor1, (make_vec3(uv_u, (yuv_layers).sel(Y))).sel(X, Y))).sel(R);
    (yuv_value).sel(Z) = (texture(sColor2, (make_vec3(uv_v, (yuv_layers).sel(Z))).sel(X, Y))).sel(R);
   }
   break;
  case 0:
   {
    vec2 uv_y = clamp(in_uv_y, (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    vec2 uv_uv = clamp(in_uv_u, (uv_bounds_u).sel(X, Y), (uv_bounds_u).sel(Z, W));
    (yuv_value).sel(X) = (texture(sColor0, (make_vec3(uv_y, (yuv_layers).sel(X))).sel(X, Y))).sel(R);
    (yuv_value).lsel(Y, Z) = (texture(sColor1, (make_vec3(uv_uv, (yuv_layers).sel(Y))).sel(X, Y))).sel(R, G);
   }
   break;
  case 2:
   {
    vec2 uv_y = clamp(in_uv_y, (uv_bounds_y).sel(X, Y), (uv_bounds_y).sel(Z, W));
    yuv_value = (texture(sColor0, (make_vec3(uv_y, (yuv_layers).sel(X))).sel(X, Y))).sel(G, B, R);
   }
   break;
  default:
   yuv_value = make_vec3(0.f);
   break;
 }
 vec3 rgb = (yuv_color_matrix)*(((yuv_value)*(coefficient))-(make_vec3(0.06275f, 0.50196f, 0.50196f)));
 vec4 color = make_vec4(rgb, 1.f);
 return color;
}
void write_output(vec4 color) {
 oFragColor = color;
}
ALWAYS_INLINE void main(void) {
 vec4 color = sample_yuv(vYuvFormat, vYuvColorMatrix, vYuvCoefficient, vYuvLayers, vUV_y, vUV_u, vUV_v, vUVBounds_y, vUVBounds_u, vUVBounds_v);
 write_output(color);
}
typedef composite_YUV_TEXTURE_2D_vert::InterpOutputs InterpInputs;
InterpInputs interp_step;
struct InterpPerspective {
vec2 vUV_y;
vec2 vUV_u;
vec2 vUV_v;
};
InterpPerspective interp_perspective;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  self->vUV_y = init_interp(init->vUV_y, step->vUV_y);
  self->interp_step.vUV_y = step->vUV_y * step_width;
  self->vUV_u = init_interp(init->vUV_u, step->vUV_u);
  self->interp_step.vUV_u = step->vUV_u * step_width;
  self->vUV_v = init_interp(init->vUV_v, step->vUV_v);
  self->interp_step.vUV_v = step->vUV_v * step_width;
}
static void read_perspective_inputs(Self *self, const InterpInputs *init, const InterpInputs *step, float step_width) {
  Float w = 1.0f / self->gl_FragCoord.w;
  self->interp_perspective.vUV_y = init_interp(init->vUV_y, step->vUV_y);
  self->vUV_y = self->interp_perspective.vUV_y * w;
  self->interp_step.vUV_y = step->vUV_y * step_width;
  self->interp_perspective.vUV_u = init_interp(init->vUV_u, step->vUV_u);
  self->vUV_u = self->interp_perspective.vUV_u * w;
  self->interp_step.vUV_u = step->vUV_u * step_width;
  self->interp_perspective.vUV_v = init_interp(init->vUV_v, step->vUV_v);
  self->vUV_v = self->interp_perspective.vUV_v * w;
  self->interp_step.vUV_v = step->vUV_v * step_width;
}
ALWAYS_INLINE void step_interp_inputs() {
  vUV_y += interp_step.vUV_y;
  vUV_u += interp_step.vUV_u;
  vUV_v += interp_step.vUV_v;
}
ALWAYS_INLINE void step_perspective_inputs() {
  step_perspective();
  Float w = 1.0f / gl_FragCoord.w;
  interp_perspective.vUV_y += interp_step.vUV_y;
  vUV_y = w * interp_perspective.vUV_y;
  interp_perspective.vUV_u += interp_step.vUV_u;
  vUV_u = w * interp_perspective.vUV_u;
  interp_perspective.vUV_v += interp_step.vUV_v;
  vUV_v = w * interp_perspective.vUV_v;
}
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int chunks) {
 self->step_interp_inputs();
 while (--chunks > 0) self->step_interp_inputs();
}
static void run_perspective(Self *self) {
 self->main();
 self->step_perspective_inputs();
}
static void skip_perspective(Self* self, int chunks) {
 self->step_perspective_inputs();
 while (--chunks > 0) self->step_perspective_inputs();
}
public:
composite_YUV_TEXTURE_2D_frag() {
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 enable_perspective();
 init_span_w_func = (InitSpanWFunc)&read_perspective_inputs;
 run_w_func = (RunWFunc)&run_perspective;
 skip_w_func = (SkipWFunc)&skip_perspective;
}
};

struct composite_YUV_TEXTURE_2D_program : ProgramImpl, composite_YUV_TEXTURE_2D_frag {
int get_uniform(const char *name) const override {
 if (strcmp("sColor0", name) == 0) { return 1; }
 if (strcmp("sColor1", name) == 0) { return 2; }
 if (strcmp("sColor2", name) == 0) { return 3; }
 if (strcmp("uTransform", name) == 0) { return 4; }
 return -1;
}
void bind_attrib(const char* name, int index) override {
 attrib_locations.bind_loc(name, index);
}
int get_attrib(const char* name) const override {
 return attrib_locations.get_loc(name);
}
size_t interpolants_size() const override { return sizeof(InterpOutputs); }
VertexShaderImpl* get_vertex_shader() override {
 return this;
}
FragmentShaderImpl* get_fragment_shader() override {
 return this;
}
static ProgramImpl* loader() { return new composite_YUV_TEXTURE_2D_program; }
};

